#include "nvp6124_reg.h"
#include "common.h"
#include "coax_protocol.h"

extern BOOLEAN F6B9E557A4BA24ffd926B820B836289C8_100NS( ULONG F6B9E557A4BA24ffd926B820B836289C8 );

#define NVP6124_ADDR 0x60
#define FPGA_ADDR 0x98
int chip_id[4];
int rev_id[4];
BYTE chipon297MHz[4]={0};
unsigned char ch_seq[4]={2,1,0,3};
unsigned int vloss=0xFFFF;

#define AIG_DEF   0x0F
#define AOG_DEF   0x03

/*nvp6124 1080P ɫƼ*/
#define BRI_CENTER_VAL_NTSC 0xF4
#define BRI_CENTER_VAL_PAL  0xF4
#define CON_CENTER_VAL_NTSC 0x90
#define CON_CENTER_VAL_PAL  0x90
#define SAT_CENTER_VAL_NTSC 0x80
#define SAT_CENTER_VAL_PAL  0x80                       
#define HUE_CENTER_VAL_NTSC 0x00
#define HUE_CENTER_VAL_PAL  0x00


/*nvp6124 720P ɫƼ*/
#define BRI_CENTER_VAL_NTSC_720P 0x08
#define BRI_CENTER_VAL_PAL_720P  0x08
#define CON_CENTER_VAL_NTSC_720P 0x88
#define CON_CENTER_VAL_PAL_720P  0x88
#define SAT_CENTER_VAL_NTSC_720P 0x90
#define SAT_CENTER_VAL_PAL_720P  0x90                       
#define HUE_CENTER_VAL_NTSC_720P 0xFD
#define HUE_CENTER_VAL_PAL_720P  0x00
                           
/*nvp6124 960H ɫƼ*/
#define BRI_CENTER_VAL_NTSC_960H 0xFF
#define BRI_CENTER_VAL_PAL_960H  0x00
#define CON_CENTER_VAL_NTSC_960H 0x92
#define CON_CENTER_VAL_PAL_960H  0x90
#define SAT_CENTER_VAL_NTSC_960H 0x88
#define SAT_CENTER_VAL_PAL_960H  0x88                       
#define HUE_CENTER_VAL_NTSC_960H 0x01
#define HUE_CENTER_VAL_PAL_960H  0x00

unsigned char nvp6124_con_tbl[2]  = {CON_CENTER_VAL_NTSC, CON_CENTER_VAL_PAL};
unsigned char nvp6124_hue_tbl[2]  = {HUE_CENTER_VAL_NTSC, HUE_CENTER_VAL_PAL};
unsigned char nvp6124_sat_tbl[2]  = {SAT_CENTER_VAL_NTSC, SAT_CENTER_VAL_PAL};
unsigned char nvp6124_bri_tbl[2]  = {BRI_CENTER_VAL_NTSC, BRI_CENTER_VAL_PAL};

unsigned char nvp6124_con_tbl_720P[2]  = {CON_CENTER_VAL_NTSC_720P, CON_CENTER_VAL_PAL_720P};
unsigned char nvp6124_hue_tbl_720P[2]  = {HUE_CENTER_VAL_NTSC_720P, HUE_CENTER_VAL_PAL_720P};
unsigned char nvp6124_sat_tbl_720P[2]  = {SAT_CENTER_VAL_NTSC_720P, SAT_CENTER_VAL_PAL_720P};
unsigned char nvp6124_bri_tbl_720P[2]  = {BRI_CENTER_VAL_NTSC_720P, BRI_CENTER_VAL_PAL_720P};


unsigned char nvp6124_con_tbl_960H[2]  = {CON_CENTER_VAL_NTSC_960H, CON_CENTER_VAL_PAL_960H};
unsigned char nvp6124_hue_tbl_960H[2]  = {HUE_CENTER_VAL_NTSC_960H, HUE_CENTER_VAL_PAL_960H};
unsigned char nvp6124_sat_tbl_960H[2]  = {SAT_CENTER_VAL_NTSC_960H, SAT_CENTER_VAL_PAL_960H};
unsigned char nvp6124_bri_tbl_960H[2]  = {BRI_CENTER_VAL_NTSC_960H, BRI_CENTER_VAL_PAL_960H};

unsigned char nvp6124_motion_sens_tbl[8]= {0xe0,0xc8,0xa0,0x98,0x78,0x68,0x50,0x48};
unsigned char ch_mode_status[16]={0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff};
unsigned char ch_vfmt_status[16]={0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff};

int check_rev( F42A18AF66EFF459eA332CA253FFF8A65 * pDevice)
{
	int ret = 0;
	DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xFF, 0x00);
	ret = E6FB1249C1F642A38BC0228741149CD8( pDevice, 0x00, NVP6124_ADDR, 0xf5);
	return ret;
}

int check_id( F42A18AF66EFF459eA332CA253FFF8A65 * pDevice)
{
	int ret = 0;
	DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xFF, 0x00);
	ret = E6FB1249C1F642A38BC0228741149CD8( pDevice, 0x00, NVP6124_ADDR, 0xf4);
	return ret;
}

void nvp6124_set_clockmode( F42A18AF66EFF459eA332CA253FFF8A65 * pDevice, unsigned char chip, unsigned char is297MHz)
{
	DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xFF, 0x01);
	DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x80, 0x40);
	if(is297MHz == 1)
	{
		DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x82, 0x12); 
		chipon297MHz[chip] = 1;
	}
	else
	{
		DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x82, 0x14); 
		chipon297MHz[chip] = 0;
	}
	DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x83, 0x2C); 
	DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x80, 0x61); 
	DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x80, 0x60); 
	 
	F1838C0176E054c129B7F2BF440D1236E( KERN_INFO, "chip %d nvp6124_set_clockmode %d\n", chip, is297MHz);
}

void nvp6124_set_portmode( F42A18AF66EFF459eA332CA253FFF8A65 * pDevice, unsigned char chip, unsigned char portsel, unsigned char portmode, unsigned char chid)
{
	unsigned char tmp=0;
	unsigned char chipaddr = NVP6124_ADDR;
	if(portmode == NVP6124_OUTMODE_2MUX_FHD || portmode == NVP6124_OUTMODE_4MUX_HD)
	{
		if(chipon297MHz[chip] == 0)
			nvp6124_set_clockmode( pDevice, chip, 1);
	}
	else
	{
		if(chipon297MHz[chip] == 1)
			nvp6124_set_clockmode( pDevice, chip, 0);
	}	
	switch(portmode)
	{
		case NVP6124_OUTMODE_1MUX_SD:
			DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xFF, 0x00);
			DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x56, 0x10);
			DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xFF, 0x01);
			DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xC0+portsel*2, (chid<<4)|chid);    
			DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xC1+portsel*2, (chid<<4)|chid);
			tmp = E6FB1249C1F642A38BC0228741149CD8( pDevice, 0x00, NVP6124_ADDR, 0xC8+portsel/2) & (portsel%2?0x0F:0xF0);
			DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xC8+portsel/2, tmp);         
			tmp = E6FB1249C1F642A38BC0228741149CD8( pDevice, 0x00, NVP6124_ADDR, 0xCA);
			tmp |= ((0x01<<(portsel+4)) | (0x01<<(portsel)));
			DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xCA, tmp);    //򿪶˿[3:0]ʱ[7:4],Ӳء
			DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xCC+portsel, 0x36);    //ʱƵ
		break;
		case NVP6124_OUTMODE_1MUX_HD:
			DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xFF, 0x00);
			DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x56, 0x10);
			DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xFF, 0x01);
			DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xC0+portsel*2, (chid<<4)|chid);    
			DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xC1+portsel*2, (chid<<4)|chid);
			tmp = E6FB1249C1F642A38BC0228741149CD8( pDevice, 0x00, NVP6124_ADDR, 0xC8+portsel/2) & (portsel%2?0x0F:0xF0);
			DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xC8+portsel/2, tmp);         
			tmp = E6FB1249C1F642A38BC0228741149CD8( pDevice, 0x00, NVP6124_ADDR, 0xCA);
			tmp |= ((0x01<<(portsel+4)) | (0x01<<(portsel)));
			DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xCA, tmp);    
			DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xCC+portsel, 0x46);    
		break;
		case NVP6124_OUTMODE_1MUX_HD5060:
		case NVP6124_OUTMODE_1MUX_FHD:	
			DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xFF, 0x00);
			DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x56, 0x10);
			DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xFF, 0x01);
			DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xC0+portsel*2, (chid<<4)|chid);    
			DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xC1+portsel*2, (chid<<4)|chid);
			tmp = E6FB1249C1F642A38BC0228741149CD8( pDevice, 0x00, NVP6124_ADDR, 0xC8+portsel/2) & (portsel%2?0x0F:0xF0);
			DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xC8+portsel/2, tmp);         
			tmp = E6FB1249C1F642A38BC0228741149CD8( pDevice, 0x00, NVP6124_ADDR, 0xCA);
			tmp |= ((0x01<<(portsel+4)) | (0x01<<(portsel)));
			DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xCA, tmp);    
			DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xCC+portsel, 0x66); 
			break;
		case NVP6124_OUTMODE_2MUX_SD:
			DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xFF, 0x00);
			DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x56, 0x10);
			DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xFF, 0x01);
			DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xC0+portsel*2, chid==0?0x10:0x32);    
			DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xC1+portsel*2, chid==0?0x10:0x32);
			tmp = E6FB1249C1F642A38BC0228741149CD8( pDevice, 0x00, NVP6124_ADDR, 0xC8+portsel/2) & (portsel%2?0x0F:0xF0);
			tmp |= (portsel%2?0x20:0x02);
			DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xC8+portsel/2, tmp);         
			tmp = E6FB1249C1F642A38BC0228741149CD8( pDevice, 0x00, NVP6124_ADDR, 0xCA);
			tmp |= ((0x01<<(portsel+4)) | (0x01<<(portsel)));
			DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xCA, tmp);    
			DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xCC+portsel, 0x46); 
			break;
		case NVP6124_OUTMODE_2MUX_HD_X:
			DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xFF, 0x00);
			DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x56, 0x10);
			DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xFF, 0x01);
			DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xC0+portsel*2, chid==0?0x10:0x32);    
			DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xC1+portsel*2, chid==0?0x10:0x32);
			tmp = E6FB1249C1F642A38BC0228741149CD8( pDevice, 0x00, NVP6124_ADDR, 0xC8+portsel/2) & (portsel%2?0x0F:0xF0);
			tmp |= (portsel%2?0x10:0x01);
			DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xC8+portsel/2, tmp);         
			tmp = E6FB1249C1F642A38BC0228741149CD8( pDevice, 0x00, NVP6124_ADDR, 0xCA);
			tmp |= ((0x01<<(portsel+4)) | (0x01<<(portsel)));
			DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xCA, tmp);    
			DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xCC+portsel, 0x46); 
			break;
		case NVP6124_OUTMODE_2MUX_HD:
			DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xFF, 0x00);
			DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x56, 0x10);
			DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xFF, 0x01);
			DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xC0+portsel*2, chid==0?0x10:0x32);    
			DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xC1+portsel*2, chid==0?0x10:0x32);
			tmp = E6FB1249C1F642A38BC0228741149CD8( pDevice, 0x00, NVP6124_ADDR, 0xC8+portsel/2) & (portsel%2?0x0F:0xF0);
			tmp |= (portsel%2?0x20:0x02);
			DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xC8+portsel/2, tmp);         
			tmp = E6FB1249C1F642A38BC0228741149CD8( pDevice, 0x00, NVP6124_ADDR, 0xCA);
			tmp |= ((0x01<<(portsel+4)) | (0x01<<(portsel)));
			DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xCA, tmp);    
			DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xCC+portsel, 0x66); 
			break;
		case NVP6124_OUTMODE_2MUX_FHD_X:
			DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xFF, 0x00);
			DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x56, 0x10);
			DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xFF, 0x01);
			DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xC0+portsel*2, chid==0?0x10:0x32);    
			DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xC1+portsel*2, chid==0?0x10:0x32);
			tmp = E6FB1249C1F642A38BC0228741149CD8( pDevice, 0x00, NVP6124_ADDR, 0xC8+portsel/2) & (portsel%2?0x0F:0xF0);
			tmp |= (portsel%2?0x10:0x01);
			DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xC8+portsel/2, tmp);         
			tmp = E6FB1249C1F642A38BC0228741149CD8( pDevice, 0x00, NVP6124_ADDR, 0xCA);
			tmp |= ((0x01<<(portsel+4)) | (0x01<<(portsel)));
			DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xCA, tmp);    
			DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xCC+portsel, 0x66); 
			break;
		case NVP6124_OUTMODE_4MUX_SD:
		case NVP6124_OUTMODE_4MUX_HD:	
			DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xFF, 0x00);
			DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x56, 0x32);
			DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xFF, 0x01);
			DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xC0+portsel*2, 0x10);    
			DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xC1+portsel*2, 0x32);
			tmp = E6FB1249C1F642A38BC0228741149CD8( pDevice, 0x00, NVP6124_ADDR, 0xC8+portsel/2) & (portsel%2?0x0F:0xF0);
			tmp |= (portsel%2?0x80:0x08);
			DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xC8+portsel/2, tmp);         
			tmp = E6FB1249C1F642A38BC0228741149CD8( pDevice, 0x00, NVP6124_ADDR, 0xCA);
			tmp |= ((0x01<<(portsel+4)) | (0x01<<(portsel)));
			DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xCA, tmp);    
			DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xCC+portsel, 0x66); 
			break;
		case NVP6124_OUTMODE_4MUX_HD_X:
			DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xFF, 0x00);
			DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x56, 0x32);
			DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xFF, 0x01);
			DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xC0+portsel*2, 0x10);    
			DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xC1+portsel*2, 0x32);
			tmp = E6FB1249C1F642A38BC0228741149CD8( pDevice, 0x00, NVP6124_ADDR, 0xC8+portsel/2) & (portsel%2?0x0F:0xF0);
			tmp |= (portsel%2?0x30:0x03);
			DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xC8+portsel/2, tmp);         
			tmp = E6FB1249C1F642A38BC0228741149CD8( pDevice, 0x00, NVP6124_ADDR, 0xCA);
			tmp |= ((0x01<<(portsel+4)) | (0x01<<(portsel)));
			DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xCA, tmp);    
			DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xCC+portsel, 0x66); 
			break;
		case NVP6124_OUTMODE_2MUX_FHD:	
			DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xFF, 0x00);
			DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x56, 0x10);
			DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xFF, 0x01);
			DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x88+chid*2, 0x88);
			DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x89+chid*2, 0x88);
			DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x8C+chid*2, 0x42);
			DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x8D+chid*2, 0x42);
			DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xC0+portsel*2, chid==0?0x10:0x32);    
			DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xC1+portsel*2, chid==0?0x10:0x32);
			tmp = E6FB1249C1F642A38BC0228741149CD8( pDevice, 0x00, NVP6124_ADDR, 0xC8+portsel/2) & (portsel%2?0x0F:0xF0);
			tmp |= (portsel%2?0x20:0x02);
			DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xC8+portsel/2, tmp);         
			tmp = E6FB1249C1F642A38BC0228741149CD8( pDevice, 0x00, NVP6124_ADDR, 0xCA);
			tmp |= ((0x01<<(portsel+4)) | (0x01<<(portsel)));
			DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xCA, tmp);    
			DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xCC+portsel, 0x46); 
			break;	
		default:
			F1838C0176E054c129B7F2BF440D1236E( KERN_INFO, "portmode %d not supported yet\n", portmode);
			break;	
			
  	}
	F1838C0176E054c129B7F2BF440D1236E( KERN_INFO, "nvp6124_set_portmode portsel %d portmode %d setting\n", portsel, portmode);
}
void audio_init( F42A18AF66EFF459eA332CA253FFF8A65 * pDevice, unsigned char recmaster, unsigned char pbmaster, unsigned char ch_num, unsigned char samplerate, unsigned char bits)
{
	int i;
	for(i=0;i<1;i++)
	{
		DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xff, 0x01);
		
		if(i == 0)
		{
			DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x06, 0x1a);
			if(recmaster == 1)
			{
				DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x07, 0x80|(samplerate<<3)|(bits<<2));	//i2s rec: master
				DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x39, 0x01);
			}
			else
			{
				DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x07, 0x00|(samplerate<<3)|(bits<<2));	//i2s rec: slave
				DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x39, 0x81);
			}
			if(pbmaster == 1)
			{
				DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x13, 0x80|(samplerate<<3)|(bits<<2));	// PB I2C 8k 16bit : master
				DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xd5, 0x00);  
			}
			else
			{
				DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x13, 0x00|(samplerate<<3)|(bits<<2));	// PB I2C 8k 16bit : slave
				DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xd5, 0x01); 
			}
			
			if(8 == ch_num)
			{
				DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x06, 0x1b);
				DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x08, 0x02);
				DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x0f, 0x54);    //set I2S right sequence
				DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x10, 0x76);
			}
			else if(4 == ch_num)
			{
				DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x06, 0x1b);
				DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x08, 0x01);
				DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x0f, 0x32);   //set I2S right sequence
			}
			
			DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x23, 0x10);  // Audio playback out
			//DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x23, 0x18);  // Audio mix out | for AD loopback test
		}
		else
		{
			DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x06, 0x19);	
			DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x07, 0x00|(samplerate<<3)|(bits<<2));	//Rec I2C 16K 16bit : slave
			DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x13, 0x00|(samplerate<<3)|(bits<<2));	// PB I2C 8k 16bit : slave
		}	
		DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x01, AIG_DEF);  // ch1 Audio input gain init
		DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x02, AIG_DEF);
		DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x03, AIG_DEF);
		DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x04, AIG_DEF);
		DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x05, AIG_DEF); 
		DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x40, AIG_DEF);  
		DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x41, AIG_DEF);
		DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x42, AIG_DEF);
		DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x43, AIG_DEF);
		DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x22, AOG_DEF);  
		
		DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x24, 0x14); //set mic_1's data to i2s_sp left channel
		DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x25, 0x15); //set mic_2's data to i2s_sp right channel
		#ifdef _INPUT_27MHZ_CLKSOURCE //for test yet
		DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x94, 0x20); 
		DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x32, 0x20);
		DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x34, 0x01);
		DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x35, 0x69);
		DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x36, 0x99);
		DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x38, 0x18);
		F6B9E557A4BA24ffd926B820B836289C8_100NS( 200000 );
		DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x38, 0x08);
		#endif
		
		F1838C0176E054c129B7F2BF440D1236E( KERN_INFO, "nvp6124 audio init,REC:%s,PB:%s\n", recmaster==1?"MASTER":"SLAVE", pbmaster==1?"MASTER":"SLAVE");
	}
}


void acp_reg_rx_clear( F42A18AF66EFF459eA332CA253FFF8A65 * pDevice, unsigned char ch)
{
	DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xFF, 0x03+((ch%4)/2));
	DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, ACP_CLR+((ch%2)*0x80), 0x01);
	F6B9E557A4BA24ffd926B820B836289C8_100NS( 100000 );
	DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, ACP_CLR+((ch%2)*0x80), 0x00);
}

void init_acp( F42A18AF66EFF459eA332CA253FFF8A65 * pDevice, unsigned char ch)
{
	DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xFF, 0x01);
	//Decoder TX Setting
	if(chip_id[ch/4] == NVP6124_R0_ID)
	{
		DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xBD, 0xD0);
		DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xBE, 0xDD);
		DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xBF, 0x0D);
	}
	else if(chip_id[ch/4] == NVP6114A_R0_ID)
	{
		DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xBC, 0xDD);
		DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xBD, 0xED);
	}

	acp_reg_rx_clear( pDevice, ch);
}

void acp_each_setting( F42A18AF66EFF459eA332CA253FFF8A65 * pDevice, unsigned char ch)
{
	DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xFF, 0x03+((ch%4)/2));
	if(ch_mode_status[ch] == NVP6124_VI_720P_2530)
	{
		DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, AHD2_FHD_BAUD+((ch%2)*0x80), 0x0E);
		DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, AHD2_FHD_LINE+((ch%2)*0x80), ch_vfmt_status[ch]==PAL? 0x0D:0x0E);
	}
	else if(ch_mode_status[ch] == NVP6124_VI_1080P_2530)
	{
		DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, AHD2_FHD_BAUD+((ch%2)*0x80), 0x0E);
		DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, AHD2_FHD_LINE+((ch%2)*0x80), 0x0E);
	}
	DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, AHD2_PEL_SYNC+((ch%2)*0x80), 0x14);
	DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, AHD2_PEL_SYNC+((ch%2)*0x80)+1, 0x00);  
	DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, AHD2_FHD_LINES+((ch%2)*0x80), 0x07);
	DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, AHD2_FHD_BYTE+((ch%2)*0x80), 0x03);
	DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, AHD2_FHD_MODE+((ch%2)*0x80), 0x10);
	DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, AHD2_PEL_EVEN+((ch%2)*0x80), 0x00);

	//Decoder RX Setting
	DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xFF, 0x05+(ch%4));
	DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x30, 0x00);
	DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x31, 0x01);
	DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x32, 0x64);
	DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x7C, 0x11);
	if(ch_mode_status[ch] == NVP6124_VI_720P_2530)
	{
		DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x7D, 0x80);
	}
	else if(ch_mode_status[ch] == NVP6124_VI_1080P_2530)
	{
		DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x7D, 0x80);
	}
	DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xFF, 0x03+((ch%4)/2));

	if(ch_mode_status[ch] == NVP6124_VI_720P_2530)
	{
		DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x62+((ch%2)*0x80), ch_vfmt_status[ch]==PAL? 0x05:0x06);	// Camera TX DATA Check
		DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x68+((ch%2)*0x80), 0x40);	// RX size
	}
	else if(ch_mode_status[ch] == NVP6124_VI_1080P_2530)
	{
		DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x62+((ch%2)*0x80), 0x06);	// Camera TX DATA Check
		DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x68+((ch%2)*0x80), 0x70);	// RX size
	}

	DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x60+((ch%2)*0x80), 0x55);
	DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x63+((ch%2)*0x80), 0x01);
	DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x66+((ch%2)*0x80), 0x80);
	DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x67+((ch%2)*0x80), 0x01);
	//F1838C0176E054c129B7F2BF440D1236E( KERN_INFO, "ACP DATA READ TEST!!!!CH%d  RESOL = %s\n\r",ch, ch_mode_status[ch]==NVP6124_VI_720P_2530?"720P":"1080P");
}

void nvp6124_set_fpc( F42A18AF66EFF459eA332CA253FFF8A65 * pDevice, unsigned char ch, unsigned char vformat)
{
	unsigned char tmp;
	DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xFF, 0x00);
	tmp = E6FB1249C1F642A38BC0228741149CD8( pDevice, 0x00, NVP6124_ADDR, 0x54);
	if(vformat==PAL)
		tmp &= ~(0x10<<(ch%4));
	else	
		tmp |= (0x10<<(ch%4));
	DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x54, tmp);
}

void nvp6124_each_mode_setting( F42A18AF66EFF459eA332CA253FFF8A65 * pDevice, nvp6124_video_mode *pvmode )
{  
	//int i;
	unsigned char tmp;
	unsigned char ch, chmode[16];
	unsigned char pn_value_sd_nt_comet[4] = {0x4D,0x0E,0x88,0x6C};
	unsigned char pn_value_720p_30[4] = 	{0xEE,0x00,0xE5,0x4E};
	unsigned char pn_value_720p_60[4] = 	{0x2C,0xF9,0xC5,0x52};
	unsigned char pn_value_fhd_nt[4] = 		{0x2C,0xF0,0xCA,0x52};
	unsigned char pn_value_sd_pal_comet[4]= {0x75,0x35,0xB4,0x6C};
	unsigned char pn_value_720p_25[4] = 	{0x46,0x08,0x10,0x4F};
	unsigned char pn_value_720p_50[4] = 	{0x2C,0xE7,0xCF,0x52};
	unsigned char pn_value_fhd_pal[4] = 	{0xC8,0x7D,0xC3,0x52};
	unsigned char vformat[16];
	
  	for(ch=0;ch<(4);ch++)
  	{
		chmode[ch] = pvmode->chmode[ch];
		vformat[ch] = pvmode->vformat[ch];
  	}
	/*
	for(i=0;i<nvp6124_cnt;i++)
  	{
		DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xFF, 0);
		DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x80, 0x0f);
		DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xFF, 1);
		DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x93, 0x80);
  	}*/
	
	for(ch=0;ch<(4);ch++)
	{
		if(chmode[ch] < NVP6124_VI_BUTT) 
		{
			switch(chmode[ch])
			{
				case NVP6124_VI_SD:
				case NVP6124_VI_1920H:
				case NVP6124_VI_720H:
				case NVP6124_VI_1280H:
				case NVP6124_VI_1440H:	
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xFF, 0x00);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x08+ch%4, vformat[ch]==PAL?0xDD:0xA0);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x0c+ch%4, nvp6124_bri_tbl_960H[vformat[ch]%2]);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x10+ch%4, nvp6124_con_tbl_960H[vformat[ch]%2]);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x14+ch%4, vformat[ch]==PAL?0x80:0x80);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x18+ch%4, vformat[ch]==PAL?0x18:0x18);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x21+4*(ch%4), vformat[ch]==PAL?0x02:0x82);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x23+4*(ch%4), 0x43);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x30+ch%4, vformat[ch]==PAL?0x12:0x11);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x3c+ch%4, nvp6124_sat_tbl_960H[vformat[ch]%2]);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x40+ch%4, nvp6124_hue_tbl_960H[vformat[ch]%2]);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x44+ch%4, vformat[ch]==PAL?0x00:0x00);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x48+ch%4, vformat[ch]==PAL?0x00:0x00);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x4c+ch%4, vformat[ch]==PAL?0x04:0x00);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x50+ch%4, vformat[ch]==PAL?0x04:0x00);
					nvp6124_set_fpc( pDevice, ch, vformat[ch]);
					if(chmode[ch]==NVP6124_VI_SD)
						DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x58+ch%4, vformat[ch]==PAL?0x80:0x80);
					else if(chmode[ch]==NVP6124_VI_720H)
						DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x58+ch%4, vformat[ch]==PAL?0xB0:0x40);
					else if(chmode[ch]==NVP6124_VI_1280H)
						DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x58+ch%4, vformat[ch]==PAL?0x80:0x90);
					else if(chmode[ch]==NVP6124_VI_1440H)
						DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x58+ch%4, vformat[ch]==PAL?0x90:0xA0);
					else	
						DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x58+ch%4, vformat[ch]==PAL?0x3B:0x4B);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x5c+ch%4, vformat[ch]==PAL?0x1e:0x1e);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x64+ch%4, vformat[ch]==PAL?0x0d:0x08);
					if(chmode[ch]==NVP6124_VI_SD || chmode[ch]==NVP6124_VI_720H)
					{
		 				DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x81+ch%4, vformat[ch]==PAL?0x00:0x00);	
		 				DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x85+ch%4, vformat[ch]==PAL?0x11:0x11);
						if(chmode[ch]==NVP6124_VI_720H)
						{
		 					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x89+ch%4, vformat[ch]==PAL?0x11:0x11);
		 					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, ch%4+0x8E, vformat[ch]==PAL?0x20:0x00);
						}
						else
						{
		 					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x89+ch%4, vformat[ch]==PAL?0x10:0x00);
		 					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, ch%4+0x8E, vformat[ch]==PAL?0x08:0x07);
						}	
					}
					else if(chmode[ch]==NVP6124_VI_1280H)
					{
		 				DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x81+ch%4, vformat[ch]==PAL?0x20:0x20);	
		 				DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x85+ch%4, vformat[ch]==PAL?0x00:0x00);
		 				DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x89+ch%4, vformat[ch]==PAL?0x10:0x10);
		 				DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, ch%4+0x8E, vformat[ch]==PAL?0x17:0x17);
					}
					else if(chmode[ch]==NVP6124_VI_1440H)
					{
		 				DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x81+ch%4, vformat[ch]==PAL?0x30:0x30);	
		 				DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x85+ch%4, vformat[ch]==PAL?0x00:0x00);
		 				DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x89+ch%4, vformat[ch]==PAL?0x10:0x10);
		 				DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, ch%4+0x8E, vformat[ch]==PAL?0x0B:0x0B);
					}
					else
					{
		 				DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x81+ch%4, vformat[ch]==PAL?0x40:0x40);	
		 				DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x85+ch%4, vformat[ch]==PAL?0x00:0x00);
		 				DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x89+ch%4, vformat[ch]==PAL?0x00:0x00);
		 				DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, ch%4+0x8E, vformat[ch]==PAL?0x10:0x10);
					}	
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x93+ch%4, 0x00);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x98+ch%4, vformat[ch]==PAL?0x07:0x04);
	 				DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xa0+ch%4, vformat[ch]==PAL?0x00:0x10);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xa4+ch%4, vformat[ch]==PAL?0x00:0x01);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xFF, 0x01);
					if(chmode[ch]==NVP6124_VI_SD || chmode[ch]==NVP6124_VI_720H)
					{
						DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x88+ch%4, vformat[ch]==PAL?0x7e:0x7e);
						DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x8c+ch%4, vformat[ch]==PAL?0x26:0x26);
						DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xd7, E6FB1249C1F642A38BC0228741149CD8( pDevice, 0x00, NVP6124_ADDR, 0xd7)&(~(1<<(ch%4))));
					}
					else if(chmode[ch]==NVP6124_VI_1280H)
					{
						DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x88+ch%4, vformat[ch]==PAL?0x7e:0x7e);
						DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x8c+ch%4, vformat[ch]==PAL?0x56:0x56);
						DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xd7,E6FB1249C1F642A38BC0228741149CD8( pDevice, 0x00, NVP6124_ADDR, 0xd7)|(1<<(ch%4)));
					}
					else if(chmode[ch]==NVP6124_VI_1440H)
					{
						DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x88+ch%4, vformat[ch]==PAL?0x7e:0x7e);
						DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x8c+ch%4, vformat[ch]==PAL?0x56:0x56);
						DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xd7,E6FB1249C1F642A38BC0228741149CD8( pDevice, 0x00, NVP6124_ADDR, 0xd7)|(1<<(ch%4)));
					}
					else
					{
						DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x88+ch%4, vformat[ch]==PAL?0x46:0x46);
						DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x8c+ch%4, vformat[ch]==PAL?0x47:0x47);
						DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xd7,E6FB1249C1F642A38BC0228741149CD8( pDevice, 0x00, NVP6124_ADDR, 0xd7)|(1<<(ch%4)));
					}	
					if(chip_id[ch/4] == NVP6124_R0_ID)
					{
						if((chmode[ch]==NVP6124_VI_SD) || (chmode[ch]==NVP6124_VI_720H))
							DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xcc+ch_seq[ch%4], 0x36);
						else
							DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xcc+ch_seq[ch%4], 0x46);
					}	
					else if(chip_id[ch/4] == NVP6114A_R0_ID && ch_seq[ch]!=0xFF)
					{
						if((chmode[ch]==NVP6124_VI_SD) || (chmode[ch]==NVP6124_VI_720H))
							DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xcd+(ch_seq[ch%4]%2)*2, 0x36);
						else
							DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xcd+(ch_seq[ch%4]%2)*2, 0x46);
					}
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xFF, 0x02);  
					tmp = E6FB1249C1F642A38BC0228741149CD8( pDevice, 0x00, NVP6124_ADDR, 0x16+(ch%4)/2);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x16+(ch%4)/2, (tmp&(ch%2==0?0xF0:0x0F))|(0x00<<((ch%2)*4)));
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xFF, 0x05+ch%4);
					DBF051EEA3B648B49859145F02FA268CS( pDevice, 0x00, NVP6124_ADDR, 0x00, NVP6124_B5678_SD_Buf, 254 );
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x06,0x40);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x0F,vformat[ch]==PAL?0x13:0x00);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x1B,0x08);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x20,0x88);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x1E,vformat[ch]==PAL?0x00:0x01);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x2C,vformat[ch]==PAL?0x00:0x04);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x35,vformat[ch]==PAL?0x17:0x15);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x62,vformat[ch]==PAL?0x20:0x00);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xA1,vformat[ch]==PAL?0x10:0x30);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xA2,vformat[ch]==PAL?0x0E:0x0C);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xA3,vformat[ch]==PAL?0x70:0x50);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xA8,vformat[ch]==PAL?0x40:0x20);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xAC,vformat[ch]==PAL?0x10:0x20);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xAD,vformat[ch]==PAL?0x08:0x20);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xAE,vformat[ch]==PAL?0x04:0x14);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xC0,vformat[ch]==PAL?0x0D:0x00);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x25,vformat[ch]==PAL?0xCA:0xDA);
					if(chmode[ch]==NVP6124_VI_1280H || chmode[ch]==NVP6124_VI_1440H)
					{
						DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x62, vformat[ch]==PAL?0x20:0x20);
						DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x64, vformat[ch]==PAL?0x0D:0x0D);
					}
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xFF, 0x09);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x40+(ch%4), 0x60);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x44, E6FB1249C1F642A38BC0228741149CD8( pDevice, 0x00, NVP6124_ADDR, 0x44)&(~(1<<(ch%4))));
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x50+4*(ch%4),vformat[ch]==PAL?pn_value_sd_pal_comet[0]:pn_value_sd_nt_comet[0]);	//ch%41 960H	
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x51+4*(ch%4),vformat[ch]==PAL?pn_value_sd_pal_comet[1]:pn_value_sd_nt_comet[1]);		
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x52+4*(ch%4),vformat[ch]==PAL?pn_value_sd_pal_comet[2]:pn_value_sd_nt_comet[2]);		
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x53+4*(ch%4),vformat[ch]==PAL?pn_value_sd_pal_comet[3]:pn_value_sd_nt_comet[3]);
					F1838C0176E054c129B7F2BF440D1236E( KERN_INFO, "ch %d setted to %d %s\n", ch, chmode[ch], vformat[ch]==PAL?"PAL":"NTSC");
				break;	
				case NVP6124_VI_720P_2530:
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xFF, 0x00);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x08+ch%4,vformat[ch]==PAL?0x60:0x60);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x0c+ch%4,nvp6124_bri_tbl_720P[vformat[ch]%2]);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x10+ch%4,nvp6124_con_tbl_720P[vformat[ch]%2]);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x14+ch%4,vformat[ch]==PAL?0x90:0x90);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x18+ch%4,vformat[ch]==PAL?0x30:0x30);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x21+4*(ch%4), 0x92);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x22+4*(ch%4), 0x0A);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x23+4*(ch%4), 0x43);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x30+ch%4,vformat[ch]==PAL?0x12:0x12);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x3c+ch%4,nvp6124_sat_tbl_720P[vformat[ch]%2]);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x40+ch%4,nvp6124_hue_tbl_720P[vformat[ch]%2]);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x44+ch%4,vformat[ch]==PAL?0x30:0x30);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x48+ch%4,vformat[ch]==PAL?0x30:0x30);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x4c+ch%4,vformat[ch]==PAL?0x04:0x04);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x50+ch%4,vformat[ch]==PAL?0x04:0x04);
					nvp6124_set_fpc( pDevice, ch, vformat[ch]);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x58+ch%4,vformat[ch]==PAL?0x80:0x90);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x5c+ch%4,vformat[ch]==PAL?0x9e:0x9e);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x64+ch%4,vformat[ch]==PAL?0xb1:0xb2);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x81+ch%4,vformat[ch]==PAL?0x07:0x06);	
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x85+ch%4,vformat[ch]==PAL?0x00:0x00);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x89+ch%4,vformat[ch]==PAL?0x10:0x10);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, ch%4+0x8E,vformat[ch]==PAL?0x0d:0x0d);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x93+ch%4,0x00);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x98+ch%4,vformat[ch]==PAL?0x07:0x04);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xa0+ch%4,vformat[ch]==PAL?0x00:0x00);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xa4+ch%4,vformat[ch]==PAL?0x00:0x01);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xFF,0x01);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x88+ch%4,vformat[ch]==PAL?0x5C:0x5C);	
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x8c+ch%4,vformat[ch]==PAL?0x40:0x40);
					if(chip_id[ch/4] == NVP6124_R0_ID)
						DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xcc+ch_seq[ch%4], 0x46);
					else if(chip_id[ch/4] == NVP6114A_R0_ID && ch_seq[ch]!=0xFF)
						DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xcd+(ch_seq[ch%4]%2)*2, 0x46);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xd7,E6FB1249C1F642A38BC0228741149CD8( pDevice, 0x00, NVP6124_ADDR, 0xd7)|(1<<(ch%4)));
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xFF, 0x02);  
					tmp = E6FB1249C1F642A38BC0228741149CD8( pDevice, 0x00, NVP6124_ADDR, 0x16+(ch%4)/2);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x16+(ch%4)/2, (tmp&(ch%2==0?0xF0:0x0F))|(0x05<<((ch%2)*4)));
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xFF, 0x05+ch%4);
					DBF051EEA3B648B49859145F02FA268CS( pDevice, 0x00, NVP6124_ADDR, 0x00, NVP6124_B5678_Buf,254 );
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x01,0x0D); 
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x06,0x40);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x1E,vformat[ch]==PAL?0x00:0x01);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x35,vformat[ch]==PAL?0x17:0x15);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x7A,vformat[ch]==PAL?0x00:0x01);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x7B,vformat[ch]==PAL?0x00:0x81);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xA1,vformat[ch]==PAL?0x10:0x30);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xA2,vformat[ch]==PAL?0x0E:0x0C);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xA3,vformat[ch]==PAL?0x70:0x50);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xA8,vformat[ch]==PAL?0x40:0x20);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xAC,vformat[ch]==PAL?0x10:0x20);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xAD,vformat[ch]==PAL?0x08:0x20);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xAE,vformat[ch]==PAL?0x04:0x14);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x25,0xDB);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x2B,0x78); 
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x59,0x00);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x58,0x13);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xC0,0x16);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xC1,0x14);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xD8,0x0C);    
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xD9,0x0E); 
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xDA,0x12);    
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xDB,0x14); 
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xDC,0x1C);    
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xDD,0x2C);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xDE,0x34);
					
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xFF, 0x09);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x40+(ch%4),0x00);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x44, E6FB1249C1F642A38BC0228741149CD8( pDevice, 0x00, NVP6124_ADDR, 0x44)|(1<<(ch%4)));
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x50+4*(ch%4),vformat[ch]==PAL?pn_value_720p_25[0]:pn_value_720p_30[0]);	//ch%41 960H	
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x51+4*(ch%4),vformat[ch]==PAL?pn_value_720p_25[1]:pn_value_720p_30[1]);		
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x52+4*(ch%4),vformat[ch]==PAL?pn_value_720p_25[2]:pn_value_720p_30[2]);		
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x53+4*(ch%4),vformat[ch]==PAL?pn_value_720p_25[3]:pn_value_720p_30[3]);
					F1838C0176E054c129B7F2BF440D1236E( KERN_INFO, "ch %d setted to 720P %s\n", ch, vformat[ch]==PAL?"PAL":"NTSC");
				break;
				case NVP6124_VI_720P_5060:
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xFF, 0x00);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x08+ch%4,vformat[ch]==PAL?0x60:0x60);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x0c+ch%4,nvp6124_bri_tbl_720P[vformat[ch]%2]);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x10+ch%4,nvp6124_con_tbl_720P[vformat[ch]%2]);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x14+ch%4,vformat[ch]==PAL?0x90:0x90);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x18+ch%4,vformat[ch]==PAL?0x00:0x00);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x21+4*(ch%4), 0x92);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x22+4*(ch%4), 0x0A);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x23+4*(ch%4), vformat[ch]==PAL?0x43:0x43);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x30+ch%4,vformat[ch]==PAL?0x12:0x12);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x3c+ch%4,nvp6124_sat_tbl_720P[vformat[ch]%2]);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x40+ch%4,nvp6124_hue_tbl_720P[vformat[ch]%2]);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x44+ch%4,vformat[ch]==PAL?0x30:0x30);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x48+ch%4,vformat[ch]==PAL?0x30:0x30);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x4c+ch%4,vformat[ch]==PAL?0x04:0x04);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x50+ch%4,vformat[ch]==PAL?0x04:0x04);
					nvp6124_set_fpc( pDevice, ch, vformat[ch]);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x58+ch%4,vformat[ch]==PAL?0xc0:0xb0);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x5c+ch%4,vformat[ch]==PAL?0x9e:0x9e);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x64+ch%4,vformat[ch]==PAL?0xb1:0xb2);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x81+ch%4,vformat[ch]==PAL?0x05:0x04);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x85+ch%4,vformat[ch]==PAL?0x00:0x00);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x89+ch%4,vformat[ch]==PAL?0x10:0x10);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, ch%4+0x8E,vformat[ch]==PAL?0x0b:0x09);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x93+ch%4,0x00);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x98+ch%4,vformat[ch]==PAL?0x07:0x04);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xa0+ch%4,vformat[ch]==PAL?0x00:0x00);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xa4+ch%4,vformat[ch]==PAL?0x00:0x01);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xFF, 0x01);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x88+ch%4,vformat[ch]==PAL?0x4d:0x4d);	
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x8c+ch%4,vformat[ch]==PAL?0x84:0x84);
					if(chip_id[ch/4] == NVP6124_R0_ID)
						DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xcc+ch_seq[ch%4], 0x66);
					else if(chip_id[ch/4] == NVP6114A_R0_ID && ch_seq[ch]!=0xFF)
						DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xcd+(ch_seq[ch%4]%2)*2, 0x66);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xd7, E6FB1249C1F642A38BC0228741149CD8( pDevice, 0x00, NVP6124_ADDR, 0xd7)|(1<<(ch%4)));
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xFF, 0x02); 
					tmp = E6FB1249C1F642A38BC0228741149CD8( pDevice, 0x00, NVP6124_ADDR, 0x16+(ch%4)/2);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x16+(ch%4)/2, (tmp&(ch%2==0?0xF0:0x0F))|(0x05<<((ch%2)*4)));
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xFF, 0x05+ch%4);
					DBF051EEA3B648B49859145F02FA268CS( pDevice, 0x00, NVP6124_ADDR, 0x00, NVP6124_B5678_Buf,254 );
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x01,0x0C);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x06,0x40);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x1E,vformat[ch]==PAL?0x00:0x01);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x35,vformat[ch]==PAL?0x17:0x15);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x7A,vformat[ch]==PAL?0x00:0x01);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x7B,vformat[ch]==PAL?0x00:0x81);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xA1,vformat[ch]==PAL?0x10:0x30);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xA2,vformat[ch]==PAL?0x0E:0x0C);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xA3,vformat[ch]==PAL?0x70:0x50);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xA8,vformat[ch]==PAL?0x40:0x20);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xAC,vformat[ch]==PAL?0x10:0x20);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xAD,vformat[ch]==PAL?0x08:0x20);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xAE,vformat[ch]==PAL?0x04:0x14);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x2B,0x78); 
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x59,0x01);  
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x24,vformat[ch]==PAL?0x2A:0x1A);  
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x50,vformat[ch]==PAL?0x84:0x86);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xBB,vformat[ch]==PAL?0x00:0xE4);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xFF,0x09);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x40+(ch%4), 0x00);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x44, E6FB1249C1F642A38BC0228741149CD8( pDevice, 0x00, NVP6124_ADDR, 0x44)|(1<<(ch%4)));
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x50+4*(ch%4),vformat[ch]==PAL?pn_value_720p_50[0]:pn_value_720p_60[0]);	//ch%41 960H	
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x51+4*(ch%4),vformat[ch]==PAL?pn_value_720p_50[1]:pn_value_720p_60[1]);		
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x52+4*(ch%4),vformat[ch]==PAL?pn_value_720p_50[2]:pn_value_720p_60[2]);		
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x53+4*(ch%4),vformat[ch]==PAL?pn_value_720p_50[3]:pn_value_720p_60[3]);
					F1838C0176E054c129B7F2BF440D1236E( KERN_INFO, "ch %d setted to 720P@RT %s\n", ch, vformat[ch]==PAL?"PAL":"NTSC");
				break;		
				case NVP6124_VI_1080P_2530:
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xFF, 0x00);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x08+ch%4,vformat[ch]==PAL?0x60:0x60);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x0c+ch%4,nvp6124_bri_tbl[vformat[ch]%2]);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x10+ch%4,nvp6124_con_tbl[vformat[ch]%2]);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x14+ch%4,vformat[ch]==PAL?0x90:0x90);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x18+ch%4,vformat[ch]==PAL?0x00:0x00);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x21+4*(ch%4), 0x92);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x22+4*(ch%4), 0x0A);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x23+4*(ch%4), vformat[ch]==PAL?0x43:0x43);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x30+ch%4,vformat[ch]==PAL?0x12:0x12);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x3c+ch%4,nvp6124_sat_tbl[vformat[ch]%2]);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x40+ch%4,nvp6124_hue_tbl[vformat[ch]%2]);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x44+ch%4,vformat[ch]==PAL?0x00:0x00);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x48+ch%4,vformat[ch]==PAL?0x00:0x00);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x4c+ch%4,vformat[ch]==PAL?0x00:0x00);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x50+ch%4,vformat[ch]==PAL?0x00:0x00);
					nvp6124_set_fpc( pDevice, ch, vformat[ch]);
					//DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x58+ch%4,vformat[ch]==PAL?0x6a:0x49);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x58+ch%4,vformat[ch]==PAL?0x6a:0x91);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x5c+ch%4,vformat[ch]==PAL?0x9e:0x9e);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x64+ch%4,vformat[ch]==PAL?0xbf:0x8d);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x81+ch%4,vformat[ch]==PAL?0x03:0x02);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x85+ch%4,vformat[ch]==PAL?0x00:0x00);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x89+ch%4,vformat[ch]==PAL?0x10:0x10);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, ch%4+0x8E,vformat[ch]==PAL?0x0a:0x09);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x93+ch%4,0x00);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x98+ch%4,vformat[ch]==PAL?0x07:0x04);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xa0+ch%4,vformat[ch]==PAL?0x00:0x00);	
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xa4+ch%4,vformat[ch]==PAL?0x00:0x01);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xFF, 0x01);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x88+ch%4,vformat[ch]==PAL?0x4c:0x4c);	
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x8c+ch%4,vformat[ch]==PAL?0x84:0x84);							 		
					if(chip_id[ch/4] == NVP6124_R0_ID)
						DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xcc+ch_seq[ch%4], 0x66);
					else if(chip_id[ch/4] == NVP6114A_R0_ID && ch_seq[ch]!=0xFF)
						DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xcd+(ch_seq[ch%4]%2)*2, 0x66);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xd7, E6FB1249C1F642A38BC0228741149CD8( pDevice, 0x00, NVP6124_ADDR, 0xd7)|(1<<(ch%4)));
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xFF, 0x02);  
					tmp = E6FB1249C1F642A38BC0228741149CD8( pDevice, 0x00, NVP6124_ADDR, 0x16+(ch%4)/2);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x16+(ch%4)/2, (tmp&(ch%2==0?0xF0:0x0F))|(0x05<<((ch%2)*4)));
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xFF, 0x05+ch%4);
					//??
					//DBF051EEA3B648B49859145F02FA268CS( pDevice, 0x00, NVP6124_ADDR, 0x00, NVP6124_B5678_Buf,254 );
					int i = 0;
					for(i = 0; i < 256; i+= 32)
					{
						DBF051EEA3B648B49859145F02FA268CS( pDevice, 0x00, NVP6124_ADDR, 0x00 + i, NVP6124_B5678_Buf + i, 32);
					}

					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x01,0x0C);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x06,0x40);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x1E,vformat[ch]==PAL?0x00:0x01);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x35,vformat[ch]==PAL?0x17:0x15);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x7A,vformat[ch]==PAL?0x00:0x01);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x7B,vformat[ch]==PAL?0x00:0x81);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xA1,vformat[ch]==PAL?0x10:0x30);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xA2,vformat[ch]==PAL?0x0E:0x0C);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xA3,vformat[ch]==PAL?0x70:0x50);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xA8,vformat[ch]==PAL?0x40:0x20);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xAC,vformat[ch]==PAL?0x10:0x20);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xAD,vformat[ch]==PAL?0x08:0x20);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xAE,vformat[ch]==PAL?0x04:0x14);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x2A,0x72);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x2B,0xA8); 
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x58,0x13);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x59,0x01);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xC0,0x17);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xC1,0x14);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xD8,0x10);    
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xD9,0x1F); 
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xDA,0x2B);    
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xDB,0x7F); 
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xDC,0xFF);    
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xDD,0xFF);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xDE,0xFF);
					
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x24,vformat[ch]==PAL?0x2A:0x1A);  
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x50,vformat[ch]==PAL?0x84:0x86);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xBB,vformat[ch]==PAL?0x00:0xE4);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xFF, 0x09);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x40+(ch%4), 0x00);
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x44,E6FB1249C1F642A38BC0228741149CD8( pDevice, 0x00, NVP6124_ADDR, 0x44)|(1<<(ch%4)));
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x50+4*(ch%4),vformat[ch]==PAL?pn_value_fhd_pal[0]:pn_value_fhd_nt[0]);		
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x51+4*(ch%4),vformat[ch]==PAL?pn_value_fhd_pal[1]:pn_value_fhd_nt[1]);		
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x52+4*(ch%4),vformat[ch]==PAL?pn_value_fhd_pal[2]:pn_value_fhd_nt[2]);		
					DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x53+4*(ch%4),vformat[ch]==PAL?pn_value_fhd_pal[3]:pn_value_fhd_nt[3]);
					F1838C0176E054c129B7F2BF440D1236E( KERN_INFO, "ch %d setted to 1080P %s\n", ch, vformat[ch]==PAL?"PAL":"NTSC");
				break;
				default:
					F1838C0176E054c129B7F2BF440D1236E( KERN_INFO, "ch%d wrong mode detected!!!\n", ch);
					break;
			}			
			ch_mode_status[ch] = chmode[ch];
			ch_vfmt_status[ch] = vformat[ch];
			init_acp( pDevice, ch);
			acp_each_setting( pDevice, ch);
		}	
	}
}

int nvp6124_set_chnmode( F42A18AF66EFF459eA332CA253FFF8A65 * pDevice, BYTE ch, BYTE vfmt, BYTE chnmode)
{
	nvp6124_video_mode vmode;
	int i;
	if((ch >= 4) || chnmode >= NVP6124_VI_BUTT)
	{
		F1838C0176E054c129B7F2BF440D1236E( KERN_INFO, "channel/mode is out of range\n");
		return -1;
	}
	for(i=0;i<4;i++)
	{
		if(ch == i)
		{
			vmode.vformat[i] = vfmt;
			vmode.chmode[i] = chnmode;
		}
		else
			vmode.chmode[i] = NVP6124_VI_BUTT;
	}
	nvp6124_each_mode_setting( pDevice, &vmode);
	return 0;
}


void nvp6124_system_init( F42A18AF66EFF459eA332CA253FFF8A65 * pDevice)
{
    /*
	int i = 0;                               
	for(i=0;i<nvp6124_cnt;i++)
	{
		DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xFF, 0x01); 
		DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x82, 0x14); 
		DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x83, 0x2C); 
		DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x3e, 0x10); 
		DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x80, 0x60); 
		DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x80, 0x61); 
		F6B9E557A4BA24ffd926B820B836289C8_100NS( 1000000 ); 
		DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x80, 0x40); 
		DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x81, 0x02); 
		DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x97, 0x00); 
		F6B9E557A4BA24ffd926B820B836289C8_100NS( 100000 ); 
		DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x80, 0x60); 
		DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x81, 0x00); 
		F6B9E557A4BA24ffd926B820B836289C8_100NS( 100000 ); 
		DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x97, 0x0F); 
		DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x38, 0x18); 
		DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x38, 0x08); 
		F6B9E557A4BA24ffd926B820B836289C8_100NS( 100000 ); 
		F1838C0176E054c129B7F2BF440D1236E( KERN_INFO, "nvp6124_system_init\n");
		F6B9E557A4BA24ffd926B820B836289C8_100NS( 1000000 );
		DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xCA, 0xFF);
		chipon297MHz[i] = 0;
	}
	*/
	DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xFF, 0x01 );
	DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x82, 0x14 );
	DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x83, 0x2C );
	DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x3e, 0x10 );
	DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x80, 0x60 );
	DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x80, 0x61 );
	F6B9E557A4BA24ffd926B820B836289C8_100NS( 1000000 );
	DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x80, 0x40 );
	DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x81, 0x02 );
	DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x97, 0x00 );
	F6B9E557A4BA24ffd926B820B836289C8_100NS( 100000 );
	DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x80, 0x60 );
	DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x81, 0x00 );
	F6B9E557A4BA24ffd926B820B836289C8_100NS( 100000 );
	DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x97, 0x0F );
	DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x38, 0x18 );
	DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0x38, 0x08 );
	F6B9E557A4BA24ffd926B820B836289C8_100NS( 100000 );
	F1838C0176E054c129B7F2BF440D1236E( KERN_INFO, "[%02d] nvp6124_system_init\n", pDevice->F0C7DF8CDF1004a6eB97071CBDF459ECE);

	F6B9E557A4BA24ffd926B820B836289C8_100NS( 1000000 );
	DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xCA, 0xFF );
	chipon297MHz[0] = 0;

}

void nvp6124_common_init( F42A18AF66EFF459eA332CA253FFF8A65 * pDevice)
{
	int i = 0;
	/*
	for(i=0;i<nvp6124_cnt;i++)
	{
		DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xFF, 0x00);
        nvp6124_write_table(nvp6124_slave_addr[i],0x00,NVP6124_B0_Buf,254);
		DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xFF, 0x01);
        nvp6124_write_table(nvp6124_slave_addr[i],0x00,NVP6124_B1_Buf,254);
		DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xFF, 0x02);
        nvp6124_write_table(nvp6124_slave_addr[i],0x00,NVP6124_B2_Buf,254);
		DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xFF, 0x03);
        nvp6124_write_table(nvp6124_slave_addr[i],0x00,NVP6124_B3_Buf,254);
		DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xFF, 0x04);
        nvp6124_write_table(nvp6124_slave_addr[i],0x00,NVP6124_B4_Buf,254);
		DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xFF, 0x09);
        nvp6124_write_table(nvp6124_slave_addr[i],0x00,NVP6124_B9_Buf,254);
		DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xFF, 0x0A);
        nvp6124_write_table(nvp6124_slave_addr[i],0x00,NVP6124_BA_Buf,254);
		DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xFF, 0x0B);
        nvp6124_write_table(nvp6124_slave_addr[i],0x00,NVP6124_BB_Buf,254);
	}
	*/

	DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xFF, 0x00 );
	//DBF051EEA3B648B49859145F02FA268CS( pDevice, 0x00, NVP6124_ADDR, 0x00, NVP6124_B0_Buf, 254);
	for(i = 0; i < 256; i+= 32)
	{
		DBF051EEA3B648B49859145F02FA268CS( pDevice, 0x00, NVP6124_ADDR, 0x00 + i, NVP6124_B0_Buf + i, 32);
	}

	DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xFF, 0x01 );
	//DBF051EEA3B648B49859145F02FA268CS( pDevice, 0x00, NVP6124_ADDR, 0x00, NVP6124_B1_Buf, 254);
	for(i = 0; i < 256; i+= 32)
	{
		DBF051EEA3B648B49859145F02FA268CS( pDevice, 0x00, NVP6124_ADDR, 0x00 + i, NVP6124_B1_Buf + i, 32);
	}

	DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xFF, 0x02 );
	//DBF051EEA3B648B49859145F02FA268CS( pDevice, 0x00, NVP6124_ADDR, 0x00, NVP6124_B2_Buf, 254);
	for(i = 0; i < 256; i+= 32)
	{
		DBF051EEA3B648B49859145F02FA268CS( pDevice, 0x00, NVP6124_ADDR, 0x00 + i, NVP6124_B2_Buf + i, 32);
	}

	DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xFF, 0x03 );
	//DBF051EEA3B648B49859145F02FA268CS( pDevice, 0x00, NVP6124_ADDR, 0x00, NVP6124_B3_Buf, 254);
	for(i = 0; i < 256; i+= 32)
	{
		DBF051EEA3B648B49859145F02FA268CS( pDevice, 0x00, NVP6124_ADDR, 0x00 + i, NVP6124_B3_Buf + i, 32);
	}

	DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xFF, 0x04 );
	//DBF051EEA3B648B49859145F02FA268CS( pDevice, 0x00, NVP6124_ADDR, 0x00, NVP6124_B4_Buf, 254);
	for(i = 0; i < 256; i+= 32)
	{
		DBF051EEA3B648B49859145F02FA268CS( pDevice, 0x00, NVP6124_ADDR, 0x00 + i, NVP6124_B4_Buf + i, 32);
	}

	DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xFF, 0x09 );
	//DBF051EEA3B648B49859145F02FA268CS( pDevice, 0x00, NVP6124_ADDR, 0x00, NVP6124_B9_Buf, 254);
	for(i = 0; i < 256; i+= 32)
	{
		DBF051EEA3B648B49859145F02FA268CS( pDevice, 0x00, NVP6124_ADDR, 0x00 + i, NVP6124_B9_Buf + i, 32);
	}

	DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xFF, 0x0A );
	//DBF051EEA3B648B49859145F02FA268CS( pDevice, 0x00, NVP6124_ADDR, 0x00, NVP6124_BA_Buf, 254);
	for(i = 0; i < 256; i+= 32)
	{
		DBF051EEA3B648B49859145F02FA268CS( pDevice, 0x00, NVP6124_ADDR, 0x00 + i, NVP6124_BA_Buf + i, 32);
	}

	DBF051EEA3B648B49859145F02FA268C( pDevice, 0x00, NVP6124_ADDR, 0xFF, 0x0B );
	//DBF051EEA3B648B49859145F02FA268CS( pDevice, 0x00, NVP6124_ADDR, 0x00, NVP6124_BB_Buf, 254);
	for(i = 0; i < 256; i+= 32)
	{
		DBF051EEA3B648B49859145F02FA268CS( pDevice, 0x00, NVP6124_ADDR, 0x00 + i, NVP6124_BB_Buf + i, 32);
	}


	nvp6124_system_init(pDevice);
}

