

#ifndef _MP4_FILE_H
#define _MP4_FILE_H

#define QT_VBUFF		0x80
#define QMP_S_STTSP		0x1000
#define QMP_S_STCOP		0x2000
#define QMP_S_STSZP		0x1000
#define QMP_S_STSCP		0x3000

#define QT_TIME_SCALE 90000

typedef struct QP_MPVCONFIG_s 
{
    TQP_UINT32 framerate;
    TQP_UINT32 maxbitrate;
    TQP_UINT32 minbitrate;
    TQP_UINT32 avgbitrate;
    TQP_UINT32 duration;
    TQP_UINT32 frames;
    TQP_UINT32 creationtime;
    TQP_UINT32 width;
    TQP_UINT32 height;
    TQP_UINT32 gopsize;
//    TQP_UINT32 goptype;
    TQP_UINT32 num_of_b_frames;
    TQP_UINT32 profile;
    TQP_UINT32 level;
    TQP_UINT32 vmode;
    TQP_UINT32 vid_block_num;
    TQP_UINT32 vid_block_set;
    TQP_UINT32 i_pts;
} QP_MPVCONFIG;

typedef struct QP_MPACONFIG
{
    TQP_UINT32 samplingrate;
    TQP_UINT32 sr;
    TQP_UINT32 bitrate;
    TQP_UINT32 channelnum;
    TQP_UINT32 frames;
    //TQP_UINT32 lastpos;
    TQP_UINT32 duration;
    TQP_UINT32 i_pts_start;
    TQP_UINT32 i_pts;
    TQP_UINT32 i_pts_back;
} QP_MPACONFIG;

typedef struct qt_buffer_s
{
    char            *buff;
    TQP_UINT32   size;
    TQP_UINT32   offset;
} QT_BUFFER;

typedef struct QT_TRANSCODE_INFO_S
{
    QP_MPVCONFIG    vcfg;
    QP_MPACONFIG    acfg;

    QT_BUFFER		vbuff;
    TQP_UINT32	dc;
    const char		fname[64];

    FILE * mp4_handle;
    unsigned long file_offset;         //Global file offset

	unsigned int dAudio;
	unsigned int dVideo;
	unsigned int aChunkCnt;
	unsigned int vChunkCnt;
	unsigned int nvstts;
    unsigned int nvsttsp;
    unsigned int nvstsz;
    unsigned int nvstszp;
    unsigned int nvstco;
    unsigned int nvstcop;
    unsigned int vstsc;
    unsigned int nvstsc;
    unsigned int nvstscp;
	unsigned int nastts;
    unsigned int nasttsp;
    unsigned int nastsz;
    unsigned int nastszp;
    unsigned int nastco;
    unsigned int nastcop;
    unsigned int astsc;
    unsigned int nastsc;
    unsigned int nastscp;

    unsigned char *mpbuff;
    unsigned char *vsttsp;
    unsigned char *vstszp;
    unsigned char *vstcop;
    unsigned char *vstscp;
    unsigned char *asttsp;
    unsigned char *astszp;
    unsigned char *astcop;
    unsigned char *astscp;
    char  *data_buff;

    unsigned int avstart_address;
    FILE * fp_vsttsp;
    FILE * fp_vstszp;
    FILE * fp_vstcop;
    FILE * fp_vstscp;
    FILE * fp_asttsp;
    FILE * fp_astszp;
    FILE * fp_astcop;
    FILE * fp_astscp;
} QT_TRANSCODE_INFO;

TQP_UINT32 qlput4byte( unsigned char *buff, TQP_UINT32 val );
QT_TRANSCODE_INFO * mp4_init(FILE * mp4_clip_file_handle, 
                FILE * mp4_vstts, FILE * mp4_vstsz, FILE * mp4_vstco, FILE * mp4_vstsc,
                FILE * mp4_astts, FILE * mp4_astsz, FILE * mp4_astco, FILE * mp4_astsc, 
                component_t *pComponent);
long mp4_fini(QT_TRANSCODE_INFO *info);
#endif

