// get_profile.cpp : Defines the entry point for the console application.
//

#define __LINUX__
#ifndef __LINUX__
#include "stdafx.h"
#endif
#include <stdio.h>
#include <ctype.h>
#include <string.h>
#include <stdlib.h>
#ifndef __LINUX__
#include <dos.h>
#endif
#ifdef __LINUX__
#include <stdint.h>
#endif

typedef struct _PL_PROFILE_ITEM_CONFIG_TABLE
{
    uint32_t id;
    const char *str1;
//    const char *str2;
} PL_PROFILE_ITEM_CONFIG_TABLE;

uint32_t g_hci_link_offset = 0;   /* time of first HCI_LINK_CH command in FW */
uint32_t g_hci_link_get = 0;
uint32_t g_drv_link_offset = 0;   /* time of first systemLink command */
uint32_t g_drv_link_get = 0;
uint32_t g_drv_fw_time_offset = 0;
uint32_t g_app_timesync_get = 0;
uint32_t g_app_timesync_offset = 0;

int app_log_got = 0;
int drv_log_got = 0;
int fw_log_got = 0;


#if 1 /* fw part */
#define VIU_THREAD		0x00
#define VIU_ENC_START           	0x00000001
#define VIU_ENC_STOP		   		0x00000002
#define HIU_ENC_RAW_REQ		   		0x00000003
#define HIU_ENC_RAW_REQ_DONE	   	0x00000004
#define VIU_PASS_FRAME_IN	   		0x00000005
#define VIU_DATA_PASSING_GET	   	0x00000006
#define VIU2VEN_DATA_PASSING	   	0x00000007
#define VIU2VEN_DATA_DONE	   		0x00000008
#define VIU_CLOSE_CH            	0x00000009

#define VIU_ENC_START_1         	0x00001001
#define VIU_ENC_STOP_1		   		0x00001002
#define HIU_ENC_RAW_REQ_1	   		0x00001003
#define HIU_ENC_RAW_REQ_DONE_1  	0x00001004
#define VIU_PASS_FRAME_IN_1	   		0x00001005
#define VIU_DATA_PASSING_GET_1  	0x00001006
#define VIU2VEN_DATA_PASSING_1  	0x00001007
#define VIU2VEN_DATA_DONE_1	   		0x00001008
#define VIU_CLOSE_CH_1          	0x00001009


#define VEN_THREAD		0x01
#define VEN_ENC_START				0x00010001
#define VEN_ENC_STOP				0x00010002
#define VEN_DATA_PASSING_GET		0x00010003
#define VEN_ENC_TOP					0x00010004
#define VEN_ENC_SEM_GET				0x00010005
#define VEN_ENC_KICK				0x00010006
#define VEN_ENC_TOP_DONE			0x00010007
#define VEN2MUX_DATA_PASSING		0x00010008
#define VEN2MUX_DATA_DONE			0x00010009
#define VEN_CLOSE_CH				0x0001000a
#define VEN_UPDATE_QP				0x0001000b
#define VEN_DISTORTION				0x0001000c

#define VEN_ENC_START_1				0x00011001
#define VEN_ENC_STOP_1				0x00011002
#define VEN_DATA_PASSING_GET_1		0x00011003
#define VEN_ENC_TOP_1				0x00011004
#define VEN_ENC_SEM_GET_1			0x00011005
#define VEN_ENC_KICK_1				0x00011006
#define VEN_ENC_TOP_DONE_1			0x00011007
#define VEN2MUX_DATA_PASSING_1		0x00011008
#define VEN2MUX_DATA_DONE_1			0x00011009
#define VEN_CLOSE_CH_1				0x0001100a
#define VEN_UPDATE_QP_1				0x0001100b
#define VEN_DISTORTION_1			0x0001100c


#define MUX_THREAD		0x02
#define MUX_ENC_START				0x00020001
#define MUX_ENC_STOP				0x00020002
#define MUX_DATA_PASSING_VIDEO_GET	0x00020003
#define MUX_DATA_PASSING_AUDIO_GET	0x00020004
#define MUX_M2M_REQ					0x00020005
#define MUX_M2M_DONE				0x00020006
#define MUX_DTM_REQ					0x00020007
#define MUX_DTM_DONE				0x00020008
#define MUX_CLOSE_CH				0x00020009
#define MUX_VES						0x0002000a
#define MUX_AES						0x0002000b

#define MUX_ENC_START_1				0x00021001
#define MUX_ENC_STOP_1				0x00021002
#define MUX_DATA_PASSING_VIDEO_GET_1	0x00021003
#define MUX_DATA_PASSING_AUDIO_GET_1	0x00021004
#define MUX_M2M_REQ_1					0x00021005
#define MUX_M2M_DONE_1					0x00021006
#define MUX_DTM_REQ_1					0x00021007
#define MUX_DTM_DONE_1					0x00021008
#define MUX_CLOSE_CH_1					0x00021009
#define MUX_VES_1						0x0002100a
#define MUX_AES_1						0x0002100b

#define DTM_THREAD		0x03
#define DTM_REQ_OUT					0x00030001
#define DTM_REQ_OUT_RET				0x00030002
#define DTM_VDE_REQ_IN				0x00030003
#define DTM_VDE_REQ_IN_RET			0x00030004
#define DTM_JDE_REQ_IN				0x00030005
#define DTM_JDE_REQ_IN_RET			0x00030006
#define DTM_REQ_OUT_1				0x00030007
#define DTM_REQ_OUT_RET_1			0x00030008
#define DTM_ENC_STOP				0x00030009
#define DTM_DEC_STOP				0x0003000a


#define VIU_INT			0x05
#define VIU_INT_TOP_FIELD			0x00050001
#define VIU_INT_LINE1				0x00050002
#define VIU_INT_BOTTOM_FIELD		0x00050003
#define VIU_INT_LINE2				0x00050004
#define VIU_INT_FRAME_DONE			0x00050005
#define VIU_INT_PREPARE_REG			0x00050006
#define VIU_INT_FRAME_DROP			0x00050007


#define HCI_THREAD		0x08
#define CODEC_ERROR		0x00080001
#define HCI_OPEN_CH    	0x00080002
#define HCI_LINK_CH    	0x00080003
#define HCI_SEND_OP    	0x00080004
#define HCI_START_CH    0x00080005
#define HCI_STOP_CH    	0x00080006
#define HCI_CLOSE_CH	0x00080007


#define DMX_H264_THREAD			0x10
#define DMX_RAW_REQ    				0x00100001
#define DMX_RAW_REQ_DONE    		0x00100002
#define DMX2VDE_DATA_PASSING_SPS    0x00100003
#define DMX2VDE_DATA_PASSING_PPS    0x00100004
#define DMX2VDE_DATA_PASSING_SEI    0x00100005
#define DMX2VDE_DATA_PASSING_AUD    0x00100006
#define DMX2VDE_DATA_PASSING_VCL    0x00100007
#define DMX2VDE_DATA_DONE_SPS    	0x00100008
#define DMX2VDE_DATA_DONE_PPS    	0x00100009
#define DMX2VDE_DATA_DONE_SEI    	0x0010000a
#define DMX2VDE_DATA_DONE_AUD    	0x0010000b
#define DMX2VDE_DATA_DONE_VCL    	0x0010000c
#define DMX_HW_SSU_START    		0x0010000d
#define DMX_HW_SSU_END    			0x0010000e
#define DMX_SW_SSU_START    		0x0010000f
#define DMX_SW_SSU_END    			0x00100010
#define DMX_HW_SSU_AESVES   		0x00100011
#define DMX_SW_SSU_AESVES   		0x00100012
#define DMX_AES_REQ    				0x00100013
#define DMX_AES_REQ_DONE    		0x00100014
#define DMX_AES_DATA_PASS   		0x00100015

#define VDE_THREAD				0x11
#define VDE_DATA_PASSING_SPS_GET    0x00110001
#define VDE_DATA_PASSING_PPS_GET    0x00110002
#define VDE_DATA_PASSING_SEI_GET    0x00110003
#define VDE_DATA_PASSING_AUD_GET    0x00110004
#define VDE_DATA_PASSING_VCL_GET    0x00110005
#define VDE_DATA_WAIT_SEM    		0x00110006
#define VDE_DATA_START_DEC    		0x00110007
#define VDE_DATA_END_DEC    		0x00110008
#define VDE_DATA_2VOU_DATA_PASSING  0x00110009
#define VDE_DATA_2VOU_DATA_DONE    	0x0011000a
#define VDE_DATA_CHK				0x0011000b

#define VOU_THREAD				0x12
#define VOU_DATA_PASSING_GET    	0x00120001
#define VOU_LOCAL_DATA_PASSING_GET  0x00120002
#define VOU_REMOTE_DATA_PASSING_GET 0x00120003
#define VOU_DATA_DISPLAY    		0x00120004
#define VOU_LOCAL_DATA_DISPLAY    	0x00120005
#define VOU_REMOTE_DATA_DISPLAY    	0x00120006
#define VOU_DATA_REPEAT    			0x00120007
#define VOU_LOCAL_DATA_REPEAT    	0x00120008
#define VOU_REMOTE_DATA_REPEAT    	0x00120009
#define VOU_DTM_REQ    				0x0012000a
#define VOU_DTM_DONE    			0x0012000b

#define DMX_JPEG_THREAD			0x20
#define JDMX_RAW_REQ    			0x00200001
#define JDMX_RAW_REQ_DONE    		0x00200002
#define JDMX2JDE_DATA_PASSING    	0x00200003
#define JDMX2JDE_DATA_DONE    		0x00200004
#define JDMX_DEC_START    			0x00200005
#define JDMX_M2M_START    			0x00200006
#define JDMX_M2M_DONE    			0x00200007
#define JDMX_PARSE_START    		0x00200008
#define JDMX_PARSE_DONE    			0x00200009
#define JDMX_M2M_CHK    			0x0020000a
#define JDMX_M2M_IF    				0x0020000b
#define JDMX_M2M_START_2			0x0020000c


#define JDE_THREAD				0x21
#define JDE_DATA_PASSING_GET    	0x00200001
#define JDE_START_DEC    			0x00200002
#define JDE_END_DEC    				0x00200003
#define JDE2VOU_DATA_PASSING    	0x00200004
#define JDE2VOU_DATA_DONE    		0x00200005
#define JDE2VIU_DATA_PASSING    	0x00200006
#define JDE2VIU_DATA_DONE    		0x00200007


#define JEN_THREAD				0x31
#define JVE_DATA_PASSING_GET    	0x00310001
#define JVE_START_ENC    			0x00310002
#define JVE_END_ENC    				0x00310003
#define JVE_DTM_REQ    				0x00310004
#define JVE_DTM_DONE    			0x00310005
#define JVE_DROP_FRAME				0x00310006


#define DCMMSG_THREAD   		0x60
#define DCMMSG_THREAD_START    		0x00600001
#define DCMMSG_GET_MSG    			0x00600002
#define DCMMSG_MISC_MSG    			0x00600003
#define DCMMSG_GET_DATA_PASSING    	0x00600004
#define DCMMSG_SEND2INTERNAL    	0x00600005
#define DCMMSG_GET_DATA_PASSING_4   0x00600006
#define DCMMSG_GET_DATA_PASSING_5   0x00600007
#define DCMMSG_GET_DATA_PASSING_6   0x00600008
#define DCMMSG_GET_DTM_DATA_DONE    0x00600009
#define DCMMSG_GET_DCM_DATA_DONE    0x0060000a
#define DCMMSG_SENDBACK_DATA_DONE   0x0060000b
#define DCMMSG_SEND2DCM    			0x0060000c
#define DCMMSG_SEND2DTM    			0x0060000d
#define DCMMSG_DCMBUFF    			0x0060000e
#define DCMMSG_DEBUG				0x0060000f

#define DCM_THREAD   			0x70
#define DCM_MBO_MBO    				0x00700001
#define DCM_GET_MSG    				0x00700002
#define DCM_MBO_MBO_DEBUG    		0x00700003
#define DCM_DEBUG    				0x00700004
#define DCM_LINE    				0x00700005
#define DCM_DONE                    0x00700006


#define USB_QCAM_THREAD			0x80
#define USB_QCAM_CMD_OUT    		0x00800001
#define USB_QCAM_DATA_OUT    		0x00800002
#define USB_QCAM_DATA_IN    		0x00800003
#define USB_QCAM_CMD_IN    			0x00800004
#define USB_QCAM_CMD_OUT_SUB    	0x00800005
#define USB_QCAM_CMD_IN_SUB    		0x00800006
#define USB_QCAM_WR_ARM_REG    		0x00800007
#define USB_QCAM_DMA_IN    			0x00800008
#define USB_QCAM_DMA_OUT    		0x00800009
#define USB_QCAM_DMA_IN_DONE    	0x0080000a
#define USB_QCAM_DMA_OUT_DONE    	0x0080000b
#define USB_RESET_ARM_HOLD    		0x0080000c
#define USB_RESET_ARM_RUN    		0x0080000d
#define USB_RD_MEM    				0x0080000e
#define USB_WR_MEM    				0x0080000f
#define USB_RD_HCI    				0x00800010
#define USB_WR_HCI    				0x00800011

#define AIO_THREAD				0x90
#define AIO_LPCM_DTM_OUT    		0x00900001
#define AIO_ENC_STOP    			0x00900002
#define AIO2MUX_DATA_PASSING    	0x00900003
#define AIO2MUX_DATA_DONE    		0x00900004
#define AIO_DEC_DATA_PASS_GET    	0x00900005
#define AIO_PASS_START    			0x00900006
#define AIO_ENC_START    			0x00900007
#define AIO_PASS_GET    			0x00900008
#define AIO_PASS_DONE    			0x00900009
#define AIO_ENC_GET    				0x0090000a
#define AIO_ENC_DONE    			0x0090000b
#define AIO_DEC_START    			0x0090000c
#define AIO_DEC_APSSING    			0x0090000d
#define AIO_ENC_CMPR_DONE  			0x0090000e

#define QPSOS_THREAD			0xA0
#define QPSOS_ENTER    				0x00A00001
#define QPSOS_EXIT_1    			0x00A00002
#define QPSOS_EXIT_2				0x00A00003



//unsigned long viu_frame_cnt[VIU_MESSAGE_CNT];
//unsigned long jen_frame_cnt[JEN_MESSAGE_CNT];
//unsigned long dtm_frame_cnt[DTM_MESSAGE_CNT];


char ch_unknown[10]="xxx";
char hex_prefix[10]="0x";

#define FW_STRING_TABLE_MAX_SIZE     320
PL_PROFILE_ITEM_CONFIG_TABLE  fw_string_table[FW_STRING_TABLE_MAX_SIZE] = {
{VIU_ENC_START           	, "VIU_ENC_START"},
{VIU_ENC_STOP		   		, "VIU_ENC_STOP"},
{HIU_ENC_RAW_REQ		   	, "HIU_ENC_RAW_REQ"},
{HIU_ENC_RAW_REQ_DONE	   	, "HIU_ENC_RAW_REQ_DONE"},
{VIU_PASS_FRAME_IN	   		, "VIU_PASS_FRAME_IN"},
{VIU_DATA_PASSING_GET	   	, "VIU_DATA_PASSING_GET"},
{VIU2VEN_DATA_PASSING	   	, "VIU2VEN_DATA_PASSING"},
{VIU2VEN_DATA_DONE	   		, "VIU2VEN_DATA_DONE"},
{VIU_CLOSE_CH            	, "VIU_CLOSE_CH"},

{VIU_ENC_START_1         	, "VIU_ENC_START_1"},
{VIU_ENC_STOP_1		   		, "VIU_ENC_STOP_1"},
{HIU_ENC_RAW_REQ_1	   		, "HIU_ENC_RAW_REQ_1"},
{HIU_ENC_RAW_REQ_DONE_1  	, "HIU_ENC_RAW_REQ_DONE_1"},
{VIU_PASS_FRAME_IN_1	   	, "VIU_PASS_FRAME_IN_1"},
{VIU_DATA_PASSING_GET_1  	, "VIU_DATA_PASSING_GET_1"},
{VIU2VEN_DATA_PASSING_1  	, "VIU2VEN_DATA_PASSING_1"},
{VIU2VEN_DATA_DONE_1	   	, "VIU2VEN_DATA_DONE_1"},
{VIU_CLOSE_CH_1          	, "VIU_CLOSE_CH_1"},

//VEN_THREAD		0x01
{VEN_ENC_START				, "VEN_ENC_START"},
{VEN_ENC_STOP				, "VEN_ENC_STOP"},
{VEN_DATA_PASSING_GET		, "VEN_DATA_PASSING_GET"},
{VEN_ENC_TOP				, "VEN_ENC_TOP"},
{VEN_ENC_SEM_GET			, "VEN_ENC_SEM_GET"},
{VEN_ENC_KICK				, "VEN_ENC_KICK"},
{VEN_ENC_TOP_DONE			, "VEN_ENC_TOP_DONE"},
{VEN2MUX_DATA_PASSING		, "VEN2MUX_DATA_PASSING"},
{VEN2MUX_DATA_DONE			, "VEN2MUX_DATA_DONE"},
{VEN_CLOSE_CH				, "VEN_CLOSE_CH"},
{VEN_UPDATE_QP				, "VEN_UPDATE_QP"},
{VEN_DISTORTION				, "VEN_DISTORTION"},

{VEN_ENC_START_1			, "VEN_ENC_START_1"},
{VEN_ENC_STOP_1				, "VEN_ENC_STOP_1"},
{VEN_DATA_PASSING_GET_1		, "VEN_DATA_PASSING_GET_1"},
{VEN_ENC_TOP_1				, "VEN_ENC_TOP_1"},
{VEN_ENC_SEM_GET_1			, "VEN_ENC_SEM_GET_1"},
{VEN_ENC_KICK_1				, "VEN_ENC_KICK_1"},
{VEN_ENC_TOP_DONE_1			, "VEN_ENC_TOP_DONE_1"},
{VEN2MUX_DATA_PASSING_1		, "VEN2MUX_DATA_PASSING_1"},
{VEN2MUX_DATA_DONE_1		, "VEN2MUX_DATA_DONE_1"},
{VEN_CLOSE_CH_1				, "VEN_CLOSE_CH_1"},
{VEN_UPDATE_QP_1			, "VEN_UPDATE_QP_1"},
{VEN_DISTORTION_1			, "VEN_DISTORTION_1"},


//MUX_THREAD		0x02
{MUX_ENC_START				, "MUX_ENC_START"},
{MUX_ENC_STOP				, "MUX_ENC_STOP"},
{MUX_DATA_PASSING_VIDEO_GET	, "MUX_DATA_PASSING_VIDEO_GET"},
{MUX_DATA_PASSING_AUDIO_GET	, "MUX_DATA_PASSING_AUDIO_GET"},
{MUX_M2M_REQ				, "MUX_M2M_REQ"},
{MUX_M2M_DONE				, "MUX_M2M_DONE"},
{MUX_DTM_REQ				, "MUX_DTM_REQ"},
{MUX_DTM_DONE				, "MUX_DTM_DONE"},
{MUX_CLOSE_CH				, "MUX_CLOSE_CH"},
{MUX_VES					, "MUX_VES"},
{MUX_AES					, "MUX_AES"},

{MUX_ENC_START_1			, "MUX_ENC_START_1"},
{MUX_ENC_STOP_1				, "MUX_ENC_STOP_1"},
{MUX_DATA_PASSING_VIDEO_GET_1	, "MUX_DATA_PASSING_VIDEO_GET_1"},
{MUX_DATA_PASSING_AUDIO_GET_1	, "MUX_DATA_PASSING_AUDIO_GET_1"},
{MUX_M2M_REQ_1				, "MUX_M2M_REQ_1"},
{MUX_M2M_DONE_1				, "MUX_M2M_DONE_1"},
{MUX_DTM_REQ_1				, "MUX_DTM_REQ_1"},
{MUX_DTM_DONE_1				, "MUX_DTM_DONE_1"},
{MUX_CLOSE_CH_1				, "MUX_CLOSE_CH_1"},
{MUX_VES_1					, "MUX_VES_1"},
{MUX_AES_1					, "MUX_AES_1"},

//DTM_THREAD		0x03
{DTM_REQ_OUT				, "DTM_REQ_OUT"},
{DTM_REQ_OUT_RET			, "DTM_REQ_OUT_RET"},
{DTM_VDE_REQ_IN				, "DTM_VDE_REQ_IN"},
{DTM_VDE_REQ_IN_RET			, "DTM_VDE_REQ_IN_RET"},
{DTM_JDE_REQ_IN				, "DTM_JDE_REQ_IN"},
{DTM_JDE_REQ_IN_RET			, "DTM_JDE_REQ_IN_RET"},
{DTM_REQ_OUT_1				, "DTM_REQ_OUT_1"},
{DTM_REQ_OUT_RET_1			, "DTM_REQ_OUT_RET_1"},
{DTM_ENC_STOP				, "DTM_ENC_STOP"},
{DTM_DEC_STOP				, "DTM_DEC_STOP"},

//VIU_INT			0x05
{VIU_INT_TOP_FIELD			, "VIU_INT_TOP_FIELD"},
{VIU_INT_LINE1				, "VIU_INT_LINE1"},
{VIU_INT_BOTTOM_FIELD		, "VIU_INT_BOTTOM_FIELD"},
{VIU_INT_LINE2				, "VIU_INT_LINE2"},
{VIU_INT_FRAME_DONE			, "VIU_INT_FRAME_DONE"},
{VIU_INT_PREPARE_REG		, "VIU_INT_PREPARE_REG"},
{VIU_INT_FRAME_DROP			, "VIU_INT_FRAME_DROP"},

//HCI_THREAD		0x08
{CODEC_ERROR		, "CODEC_ERROR"},
{HCI_OPEN_CH    	, "HCI_OPEN_CH"},
{HCI_LINK_CH    	, "HCI_LINK_CH"},
{HCI_SEND_OP    	, "HCI_SEND_OP"},
{HCI_START_CH    	, "HCI_START_CH"},
{HCI_STOP_CH    	, "HCI_STOP_CH"},
{HCI_CLOSE_CH		, "HCI_CLOSE_CH"},

//DMX_H264_THREAD			0x10
{DMX_RAW_REQ    			, "DMX_RAW_REQ"},
{DMX_RAW_REQ_DONE    		, "DMX_RAW_REQ_DONE"},
{DMX2VDE_DATA_PASSING_SPS   , "DMX2VDE_DATA_PASSING_SPS"},
{DMX2VDE_DATA_PASSING_PPS   , "DMX2VDE_DATA_PASSING_PPS"},
{DMX2VDE_DATA_PASSING_SEI   , "DMX2VDE_DATA_PASSING_SEI"},
{DMX2VDE_DATA_PASSING_AUD   , "DMX2VDE_DATA_PASSING_AUD"},
{DMX2VDE_DATA_PASSING_VCL   , "DMX2VDE_DATA_PASSING_VCL"},
{DMX2VDE_DATA_DONE_SPS    	, "DMX2VDE_DATA_DONE_SPS"},
{DMX2VDE_DATA_DONE_PPS    	, "DMX2VDE_DATA_DONE_PPS"},
{DMX2VDE_DATA_DONE_SEI    	, "DMX2VDE_DATA_DONE_SEI"},
{DMX2VDE_DATA_DONE_AUD    	, "DMX2VDE_DATA_DONE_AUD"},
{DMX2VDE_DATA_DONE_VCL    	, "DMX2VDE_DATA_DONE_VCL"},
{DMX_HW_SSU_START    		, "DMX_HW_SSU_START"},
{DMX_HW_SSU_END    			, "DMX_HW_SSU_END"},
{DMX_SW_SSU_START    		, "DMX_SW_SSU_START"},
{DMX_SW_SSU_END    			, "DMX_SW_SSU_END"},
{DMX_HW_SSU_AESVES   		, "DMX_HW_SSU_AESVES"},
{DMX_SW_SSU_AESVES   		, "DMX_SW_SSU_AESVES"},
{DMX_AES_REQ    			, "DMX_AES_REQ"},
{DMX_AES_REQ_DONE    		, "DMX_AES_REQ_DONE"},
{DMX_AES_DATA_PASS   		, "DMX_AES_DATA_PASS"},

//VDE_THREAD				0x11
{VDE_DATA_PASSING_SPS_GET   , "VDE_DATA_PASSING_SPS_GET"},
{VDE_DATA_PASSING_PPS_GET   , "VDE_DATA_PASSING_PPS_GET"},
{VDE_DATA_PASSING_SEI_GET   , "VDE_DATA_PASSING_SEI_GET"},
{VDE_DATA_PASSING_AUD_GET   , "VDE_DATA_PASSING_AUD_GET"},
{VDE_DATA_PASSING_VCL_GET   , "VDE_DATA_PASSING_VCL_GET"},
{VDE_DATA_WAIT_SEM    		, "VDE_DATA_WAIT_SEM"},
{VDE_DATA_START_DEC    		, "VDE_DATA_START_DEC"},
{VDE_DATA_END_DEC    		, "VDE_DATA_END_DEC"},
{VDE_DATA_2VOU_DATA_PASSING , "VDE_DATA_2VOU_DATA_PASSING"},
{VDE_DATA_2VOU_DATA_DONE    , "VDE_DATA_2VOU_DATA_DONE"},
{VDE_DATA_CHK				, "VDE_DATA_CHK"},

//VOU_THREAD				0x12
{VOU_DATA_PASSING_GET    		, "VOU_DATA_PASSING_GET"},
{VOU_LOCAL_DATA_PASSING_GET  	, "VOU_LOCAL_DATA_PASSING_GET"},
{VOU_REMOTE_DATA_PASSING_GET 	, "VOU_REMOTE_DATA_PASSING_GET"},
{VOU_DATA_DISPLAY    			, "VOU_DATA_DISPLAY"},
{VOU_LOCAL_DATA_DISPLAY    		, "VOU_LOCAL_DATA_DISPLAY"},
{VOU_REMOTE_DATA_DISPLAY    	, "VOU_REMOTE_DATA_DISPLAY"},
{VOU_DATA_REPEAT    			, "VOU_DATA_REPEAT"},
{VOU_LOCAL_DATA_REPEAT    		, "VOU_LOCAL_DATA_REPEAT"},
{VOU_REMOTE_DATA_REPEAT    		, "VOU_REMOTE_DATA_REPEAT"},
{VOU_DTM_REQ    				, "VOU_DTM_REQ"},
{VOU_DTM_DONE    				, "VOU_DTM_DONE"},

//DMX_JPEG_THREAD			0x20
{JDMX_RAW_REQ    			, "JDMX_RAW_REQ"},
{JDMX_RAW_REQ_DONE    		, "JDMX_RAW_REQ_DONE"},
{JDMX2JDE_DATA_PASSING    	, "JDMX2JDE_DATA_PASSING"},
{JDMX2JDE_DATA_DONE    		, "JDMX2JDE_DATA_DONE"},
{JDMX_DEC_START    			, "JDMX_DEC_START"},
{JDMX_M2M_START    			, "JDMX_M2M_START"},
{JDMX_M2M_DONE    			, "JDMX_M2M_DONE"},
{JDMX_PARSE_START    		, "JDMX_PARSE_START"},
{JDMX_PARSE_DONE    		, "JDMX_PARSE_DONE"},
{JDMX_M2M_CHK    			, "JDMX_M2M_CHK"},
{JDMX_M2M_IF    			, "JDMX_M2M_IF"},
{JDMX_M2M_START_2			, "JDMX_M2M_START_2"},

//JDE_THREAD				0x21
{JDE_DATA_PASSING_GET    	, "JDE_DATA_PASSING_GET"},
{JDE_START_DEC    			, "JDE_START_DEC"},
{JDE_END_DEC    			, "JDE_END_DEC"},
{JDE2VOU_DATA_PASSING    	, "JDE2VOU_DATA_PASSING"},
{JDE2VOU_DATA_DONE    		, "JDE2VOU_DATA_DONE"},
{JDE2VIU_DATA_PASSING    	, "JDE2VIU_DATA_PASSING"},
{JDE2VIU_DATA_DONE    		, "JDE2VIU_DATA_DONE"},

//JEN_THREAD				0x31
{JVE_DATA_PASSING_GET    	, "JVE_DATA_PASSING_GET"},
{JVE_START_ENC    			, "JVE_START_ENC"},
{JVE_END_ENC    			, "JVE_END_ENC"},
{JVE_DTM_REQ    			, "JVE_DTM_REQ"},
{JVE_DTM_DONE    			, "JVE_DTM_DONE"},
{JVE_DROP_FRAME				, "JVE_DROP_FRAME"},

//DCMMSG_THREAD   		0x60
{DCMMSG_THREAD_START    	, "DCMMSG_THREAD_START"},
{DCMMSG_GET_MSG    			, "DCMMSG_GET_MSG"},
{DCMMSG_MISC_MSG    		, "DCMMSG_MISC_MSG"},
{DCMMSG_GET_DATA_PASSING    , "DCMMSG_GET_DATA_PASSING"},
{DCMMSG_SEND2INTERNAL    	, "DCMMSG_SEND2INTERNAL"},
{DCMMSG_GET_DATA_PASSING_4  , "DCMMSG_GET_DATA_PASSING_4"},
{DCMMSG_GET_DATA_PASSING_5  , "DCMMSG_GET_DATA_PASSING_5"},
{DCMMSG_GET_DATA_PASSING_6  , "DCMMSG_GET_DATA_PASSING_6"},
{DCMMSG_GET_DTM_DATA_DONE   , "DCMMSG_GET_DTM_DATA_DONE"},
{DCMMSG_GET_DCM_DATA_DONE   , "DCMMSG_GET_DCM_DATA_DONE"},
{DCMMSG_SENDBACK_DATA_DONE  , "DCMMSG_SENDBACK_DATA_DONE"},
{DCMMSG_SEND2DCM    		, "DCMMSG_SEND2DCM"},
{DCMMSG_SEND2DTM    		, "DCMMSG_SEND2DTM"},
{DCMMSG_DCMBUFF    			, "DCMMSG_DCMBUFF"},
{DCMMSG_DEBUG				, "DCMMSG_DEBUG"},

//DCM_THREAD   			0x70
{DCM_MBO_MBO    			, "DCM_MBO_MBO"},
{DCM_GET_MSG    			, "DCM_GET_MSG"},
{DCM_MBO_MBO_DEBUG    		, "DCM_MBO_MBO_DEBUG"},
{DCM_DEBUG    				, "DCM_DEBUG"},
{DCM_LINE    				, "DCM_LINE"},
{DCM_DONE                   , "DCM_DONE"},

//USB_QCAM_THREAD			0x80
{USB_QCAM_CMD_OUT    		, "USB_QCAM_CMD_OUT"},
{USB_QCAM_DATA_OUT    		, "USB_QCAM_DATA_OUT"},
{USB_QCAM_DATA_IN    		, "USB_QCAM_DATA_IN"},
{USB_QCAM_CMD_IN    		, "USB_QCAM_CMD_IN"},
{USB_QCAM_CMD_OUT_SUB    	, "USB_QCAM_CMD_OUT_SUB"},
{USB_QCAM_CMD_IN_SUB    	, "USB_QCAM_CMD_IN_SUB"},
{USB_QCAM_WR_ARM_REG    	, "USB_QCAM_WR_ARM_REG"},
{USB_QCAM_DMA_IN    		, "USB_QCAM_DMA_IN"},
{USB_QCAM_DMA_OUT    		, "USB_QCAM_DMA_OUT"},
{USB_QCAM_DMA_IN_DONE    	, "USB_QCAM_DMA_IN_DONE"},
{USB_QCAM_DMA_OUT_DONE    	, "USB_QCAM_DMA_OUT_DONE"},
{USB_RESET_ARM_HOLD    		, "USB_RESET_ARM_HOLD"},
{USB_RESET_ARM_RUN    		, "USB_RESET_ARM_RUN"},
{USB_RD_MEM    				, "USB_RD_MEM"},
{USB_WR_MEM    				, "USB_WR_MEM"},
{USB_RD_HCI    				, "USB_RD_HCI"},
{USB_WR_HCI    				, "USB_WR_HCI"},

//AIO_THREAD				0x90
{AIO_LPCM_DTM_OUT    		, "AIO_LPCM_DTM_OUT"},
{AIO_ENC_STOP    			, "AIO_ENC_STOP"},
{AIO2MUX_DATA_PASSING    	, "AIO2MUX_DATA_PASSING"},
{AIO2MUX_DATA_DONE    		, "AIO2MUX_DATA_DONE"},
{AIO_DEC_DATA_PASS_GET    	, "AIO_DEC_DATA_PASS_GET"},
{AIO_PASS_START    			, "AIO_PASS_START"},
{AIO_ENC_START    			, "AIO_ENC_START"},
{AIO_PASS_GET    			, "AIO_PASS_GET"},
{AIO_PASS_DONE    			, "AIO_PASS_DONE"},
{AIO_ENC_GET    			, "AIO_ENC_GET"},
{AIO_ENC_DONE    			, "AIO_ENC_DONE"},
{AIO_DEC_START    			, "AIO_DEC_START"},
{AIO_DEC_APSSING    		, "AIO_DEC_APSSING"},
{AIO_ENC_CMPR_DONE  		, "AIO_ENC_CMPR_DONE"},

//QPSOS_THREAD			0xA0
{QPSOS_ENTER    			, "QPSOS_ENTER"},
{QPSOS_EXIT_1    			, "QPSOS_EXIT_1"},
{QPSOS_EXIT_2				, "QPSOS_EXIT_2"},
{0,""}
};

#endif

/* refer to define in qlprofile.h */
#define EVENT_APP_PORTOPEN			0xC0000001
#define EVENT_APP_PORTCLOSE		    0xC0000002
#define EVENT_APP_START             0xC0000003
#define EVENT_APP_STOP				0xC0000004
#define EVENT_APP_ACQUIRE			0xC0000005
#define EVENT_APP_OPEN				0xC0000006
#define EVENT_APP_OPEN_FAILED		0xC0001006
#define EVENT_APP_CLOSE			    0xC0000007
#define EVENT_APP_OPEN_MAPTO_CH		0xC0000008
#define EVENT_APP_D_OUT_START		0xC0000010
#define EVENT_APP_D_OUT			    0xC0000011
#define EVENT_APP_D_OUT_NODATA		0xC0000012
#define EVENT_APP_D_OUT_FAILED		0xC0000013
#define EVENT_APP_D_IN_START		0xC0000020
#define EVENT_APP_D_IN				0xC0000021
#define EVENT_APP_D_IN_FAILED		0xC0001022
#define EVENT_APP_D_OUT_INCOMPLETE_FRAME  0xC0000015

#define EVENT_APP_S_IN              0xC0000300
#define EVENT_APP_S_IN_FIRST        0xC0000301
#define EVENT_APP_S_IN_FINISH       0xC0000302
#define EVENT_APP_S_OUT             0xC0000400
#define EVENT_APP_S_OUT_FIRST       0xC0000401
#define EVENT_APP_S_OUT_FINISH      0xC0000402

#define EVENT_APP_TIME_SYNC         0xC0000501


/* refer to define in plprofiling.h */
#define EVENT_COMP_PORTOPEN			0x80000001
#define EVENT_COMP_PORTCLOSE		0x80000002
#define EVENT_COMP_START            0x80000003
#define EVENT_COMP_STOP				0x80000004
#define EVENT_COMP_ACQUIRE			0x80000005
#define EVENT_COMP_OPEN				0x80000006
#define EVENT_COMP_OPEN_FAILED		0x80001006
#define EVENT_COMP_CLOSE			0x80000007
#define EVENT_COMP_D_OUT			0x80000010
#define EVENT_COMP_D_OUT_NODATA		0x80000011
#define EVENT_COMP_D_OUT_FAILED		0x80001010
#define EVENT_COMP_D_IN				0x80000020
#define EVENT_COMP_D_IN_FAILED		0x80001020
#define EVENT_COMP_D_OUT_INCOMPLETE_FRAME  0x80000015

#define EVENT_FW_TO_ARM_MSG			0x90000001
#define EVENT_FW_TO_ARM_MSG_FAILED	0x90001001

#define EVENT_FW_FROM_ARM_MSG		0x90000010

#define EVENT_FW_SYSTEM_OPEN        0x90000101
#define EVENT_FW_SYSTEM_LINK		0x90000102
#define EVENT_FW_SYSTEM_START		0x90000103
#define EVENT_FW_SYSTEM_CLOSE		0x90000104
#define EVENT_FW_D_OUT_REQ			0x90000400
#define EVENT_FW_D_OUT_LAST_REQ		0x90000401
#define EVENT_FW_D_OUT_REQ2			0x90000402
#define EVENT_FW_D_OUT_INCOMPLETE_FRAME  0x90000415
#define EVENT_FW_D_OUT_REQ_ACK  	0x900004ff
#define EVENT_FW_D_IN_REQ			0x90000500
#define EVENT_FW_D_IN_REQ_FINISH	0x900005ff

#define PROFILE_STRING_TABLE_MAX_SIZE  256

PL_PROFILE_ITEM_CONFIG_TABLE  profile_string_table[PROFILE_STRING_TABLE_MAX_SIZE] = {
{EVENT_APP_PORTOPEN			, "APP_PORTOPEN"},
{EVENT_APP_PORTCLOSE		, "APP_PORTCLOSE"},
{EVENT_APP_START            , "APP_START"},
{EVENT_APP_STOP				, "APP_STOP"},
{EVENT_APP_ACQUIRE			, "APP_ACQUIRE"},
{EVENT_APP_OPEN				, "APP_OPEN"},
{EVENT_APP_OPEN_FAILED		, "APP_OPEN_FAILED"},
{EVENT_APP_CLOSE			, "APP_CLOSE"},
{EVENT_APP_OPEN_MAPTO_CH	, "APP_OPEN_MAPTO_CH"},
{EVENT_APP_D_OUT_START		, "APP_D_OUT_START"},
{EVENT_APP_D_OUT			, "APP_D_OUT"},
{EVENT_APP_D_OUT_NODATA		, "APP_D_OUT_NODATA"},
{EVENT_APP_D_OUT_FAILED		, "APP_D_OUT_FAILED"},
{EVENT_APP_D_IN_START		, "APP_D_IN_START"},
{EVENT_APP_D_IN				, "APP_D_IN"},
{EVENT_APP_D_IN_FAILED		, "APP_D_IN_FAILED"},
{EVENT_APP_D_OUT_INCOMPLETE_FRAME  , "APP_D_OUT_IC_FRAME"},

{EVENT_APP_S_IN             , "APP_S_IN"},
{EVENT_APP_S_IN_FIRST       , "APP_S_IN_FIRST"},
{EVENT_APP_S_IN_FINISH      , "APP_S_IN_FINISH"},
{EVENT_APP_S_OUT            , "APP_S_OUT"},
{EVENT_APP_S_OUT_FIRST      , "APP_S_OUT_FIRST"},
{EVENT_APP_S_OUT_FINISH     , "APP_S_OUT_FINISH"},
{EVENT_APP_TIME_SYNC     	, "APP_TIME_SYNC"},

/* define in plprofiling.h */
{EVENT_COMP_PORTOPEN		, "COMP_PORTOPEN"},
{EVENT_COMP_PORTCLOSE		, "COMP_PORTCLOSE"},
{EVENT_COMP_START           , "COMP_START"},
{EVENT_COMP_STOP			, "COMP_STOP"},
{EVENT_COMP_ACQUIRE			, "COMP_ACQUIRE"},
{EVENT_COMP_OPEN		    , "COMP_OPEN"},
{EVENT_COMP_OPEN_FAILED		, "COMP_OPEN_FAILED"},
{EVENT_COMP_CLOSE			, "COMP_CLOSE"},
{EVENT_COMP_D_OUT			, "COMP_D_OUT"},
{EVENT_COMP_D_OUT_NODATA	, "COMP_D_OUT_NODATA"},
{EVENT_COMP_D_OUT_FAILED    , "COMP_D_OUT_FAILED"},
{EVENT_COMP_D_IN			, "COMP_D_IN"},
{EVENT_COMP_D_IN_FAILED		, "COMP_D_IN_FAILED"},
{EVENT_COMP_D_OUT_INCOMPLETE_FRAME  , "COMP_D_OUT_IC_FRAME"},

{EVENT_FW_TO_ARM_MSG		, "FW_TO_ARM_MSG"},
{EVENT_FW_TO_ARM_MSG_FAILED	, "FW_TO_ARM_MSG_FAILED"},

{EVENT_FW_FROM_ARM_MSG		, "FW_FROM_ARM_MSG"},

{EVENT_FW_SYSTEM_OPEN       , "FW_SYSTEM_OPEN"},
{EVENT_FW_SYSTEM_LINK		, "FW_SYSTEM_LINK"},
{EVENT_FW_SYSTEM_START		, "FW_SYSTEM_START"},
{EVENT_FW_SYSTEM_CLOSE		, "FW_SYSTEM_CLOSE"},
{EVENT_FW_D_OUT_REQ			, "FW_D_OUT_REQ"},
{EVENT_FW_D_OUT_LAST_REQ	, "FW_D_OUT_LAST_REQ"},
{EVENT_FW_D_OUT_REQ2		, "FW_D_OUT_REQ2"},
{EVENT_FW_D_OUT_INCOMPLETE_FRAME  , "FW_D_OUT_IC_FRAME"},
{EVENT_FW_D_OUT_REQ_ACK  	, "FW_D_OUT_REQ_ACK"},
{EVENT_FW_D_IN_REQ			, "FW_D_IN_REQ"},
{EVENT_FW_D_IN_REQ_FINISH	, "FW_D_IN_REQ_FINISH"},
{0,""}
};

typedef struct _PLAPP_DIAG_PROFILING_ENTRY
{
    uint32_t data[5];
} PLAPP_DIAG_PROFILING_ENTRY;

typedef struct _PLFW_DIAG_PROFILING_ENTRY
{
    unsigned char data[20];
} PLFW_DIAG_PROFILING_ENTRY;

char g_string0[36];

const char *get_fwstring_in_table(uint32_t id)
{
    int loop = 0;
    for (loop=0;loop<FW_STRING_TABLE_MAX_SIZE;loop++) {
        if (fw_string_table[loop].id==0)
            break;
        if (id==fw_string_table[loop].id)
            return fw_string_table[loop].str1;
    }
	sprintf(g_string0,"0x%x", id);
    return g_string0;
}

char g_string1[36];

const char *get_string_in_table(uint32_t id)
{
    int loop = 0;
    for (loop=0;loop<PROFILE_STRING_TABLE_MAX_SIZE;loop++) {
        if (profile_string_table[loop].id==0)
            break;
        if (id==profile_string_table[loop].id)
            return profile_string_table[loop].str1;
    }
	sprintf(g_string1,"0x%x", id);
    return g_string1;
}

#define LOG_TYPE_UNKNOWN   0
#define LOG_TYPE_APP  1
#define LOG_TYPE_DRV  2
#define LOG_TYPE_FW   3
#define LOG_TYPE_FUL  4

typedef struct _FILE_INFO_ST
{
	uint32_t filesize;
	uint32_t filetype;
	uint32_t entries_num;
	uint32_t entries_cnt;
	uint32_t entries_looped;
	uint32_t max_frameno;
	unsigned char *dataptr;
	char filename[255];
} FILE_INFO_ST;

#define MAX_FILE_NO  10
FILE_INFO_ST  finfo[MAX_FILE_NO];
int           finfo_used = 0;

void update_max_frameno(int idx)
{
	uint32_t loop;
	uint32_t startpos;
	uint32_t endpos;
	PLAPP_DIAG_PROFILING_ENTRY	*entries;
	uint32_t maxno=0;

	startpos = 0;
    endpos = finfo[idx].entries_cnt;
	entries = (PLAPP_DIAG_PROFILING_ENTRY *) finfo[idx].dataptr;

	if ((finfo[idx].filetype==LOG_TYPE_APP)||(finfo[idx].filetype==LOG_TYPE_DRV))	{
	    for (loop=startpos;loop<endpos;loop++) {
			if ( maxno < (entries[loop].data[1] & 0xFFFFFF))
				maxno = entries[loop].data[1] & 0xFFFFFF;
		}
		finfo[idx].max_frameno = maxno;
	}
	else { /* FW */
	    for (loop=startpos;loop<endpos;loop++) {
			if ( maxno < (entries[loop].data[1] & 0xFFFFFFF))
				maxno = entries[loop].data[1] & 0xFFFFFFF;
		}
		finfo[idx].max_frameno = maxno;
	}
}

int read_file_into_mem(int idx, const char *filename)
{
	FILE *rd_fp;
	size_t rb;
	uint32_t byte_swap=1;
	unsigned char Buf[12];

	if ((rd_fp=fopen(filename,"rb"))== NULL)
	{
		fprintf(stderr,"Error opening source file: %s\n", filename);
		return 1;
	}

    if (rd_fp!=NULL ) {
        fseek (rd_fp, 0, SEEK_END);
        finfo[idx].filesize = ftell(rd_fp);
        fseek(rd_fp, 0, SEEK_SET);
	}
	if (finfo[idx].filesize<16) {
		finfo[idx].filetype = LOG_TYPE_FW;
	}
	else {
		rb = fread(Buf,1,8,rd_fp);
		if (rb!=8) {
			fclose(rd_fp);
			return -1;
		}
		if (memcmp(Buf,"APPPROF", 7)==0)
			finfo[idx].filetype = LOG_TYPE_APP;
		else if (memcmp(Buf,"DRVPROF", 7)==0)
			finfo[idx].filetype = LOG_TYPE_DRV;
		else if (memcmp(Buf,"FULPROF", 7)==0)
			finfo[idx].filetype = LOG_TYPE_FUL;
		else
			finfo[idx].filetype = LOG_TYPE_FW;
	}
	if ((finfo[idx].filetype==LOG_TYPE_APP) || (finfo[idx].filetype==LOG_TYPE_DRV)|| (finfo[idx].filetype==LOG_TYPE_FUL)) {
		/* App / Driver Log */
		if (fread(Buf,1,4,rd_fp) ==0) { // profiling_idx
			fclose(rd_fp);
			return -1;
		}
		if (byte_swap==0)
            finfo[idx].entries_cnt = (((uint32_t)Buf[0]) << 24)  |  (((uint32_t)Buf[1]) << 16) | (((uint32_t)Buf[2]) << 8) | ((uint32_t)Buf[3]);
		else
            finfo[idx].entries_cnt = (((uint32_t)Buf[3]) << 24)  |  (((uint32_t)Buf[2]) << 16) | (((uint32_t)Buf[1]) << 8) | ((uint32_t)Buf[0]);

		if (fread(Buf,1,4,rd_fp) ==0) { // looped
			fclose(rd_fp);
			return -1;
		}
		if (byte_swap==0)
            finfo[idx].entries_looped = (((uint32_t)Buf[0]) << 24)  |  (((uint32_t)Buf[1]) << 16) | (((uint32_t)Buf[2]) << 8) | ((uint32_t)Buf[3]);
		else
            finfo[idx].entries_looped = (((uint32_t)Buf[3]) << 24)  |  (((uint32_t)Buf[2]) << 16) | (((uint32_t)Buf[1]) << 8) | ((uint32_t)Buf[0]);
        finfo[idx].entries_num = (finfo[idx].filesize - 16 ) / (5*4);
		if (finfo[idx].entries_cnt >= finfo[idx].entries_num)
			finfo[idx].entries_cnt = finfo[idx].entries_num-1;
		finfo[idx].dataptr = (unsigned char *) malloc(finfo[idx].filesize-16);
		if (finfo[idx].dataptr) {
			int offset = 0;
			int i;
			for (i=0;i<finfo[idx].entries_num;i++) {
				if (fread(finfo[idx].dataptr+offset,1, 20, rd_fp)!=20) {
					fclose(rd_fp);
					fprintf(stderr,"file read error at offset %d\n", offset);
					return -1;
				}
				offset += 20;
			}
		}
	}
 	else if (finfo[idx].filetype==LOG_TYPE_FW) {
		/* FW log */
        finfo[idx].entries_cnt = (finfo[idx].filesize)/(4*4);
        finfo[idx].entries_num = (finfo[idx].filesize)/(4*4);
        finfo[idx].entries_looped = 0;
		finfo[idx].dataptr = (unsigned char *) malloc((finfo[idx].filesize*5+100)/4); /* +100 for save */
        fseek(rd_fp, 0, SEEK_SET);
		if (finfo[idx].dataptr) {
			int offset = 0;
			int i;
			memset(	finfo[idx].dataptr, 0, (finfo[idx].filesize*5+100)/4);
			for (i=0;i<finfo[idx].entries_num;i++) {
				if (fread(finfo[idx].dataptr+offset,1, 16, rd_fp)!=16) {
					fclose(rd_fp);
					fprintf(stderr,"file read error at offset %d\n", offset);
					return -1;
				}
				offset += 20;
			}
		}
	}
	else {
		fprintf(stderr, "FILE type unknown\n");
	}
	fclose(rd_fp);

	if (finfo[idx].filetype==LOG_TYPE_APP)
		app_log_got = 1;
	else if (finfo[idx].filetype==LOG_TYPE_DRV)
		drv_log_got = 1;
	else if (finfo[idx].filetype==LOG_TYPE_FW)
		fw_log_got = 1;
	if ((finfo[idx].filetype==LOG_TYPE_APP)||(finfo[idx].filetype==LOG_TYPE_DRV)||(finfo[idx].filetype==LOG_TYPE_FW)) {
		update_max_frameno(idx);
	}
	strncpy(finfo[idx].filename, filename, 255);
	return 0;
}

int seach_app_buffer_timesync(int idx)
{
	unsigned long loop;
	unsigned long startpos;
	unsigned long endpos;
	PLAPP_DIAG_PROFILING_ENTRY	*entries;

	startpos = 0;
    endpos = finfo[idx].entries_cnt;
	entries = (PLAPP_DIAG_PROFILING_ENTRY *) finfo[idx].dataptr;

    for (loop=startpos;loop<endpos;loop++) {
        unsigned long curidx;
        curidx = loop;
        if (entries[curidx].data[0]==EVENT_APP_TIME_SYNC) {
			g_app_timesync_get = 1;
			g_app_timesync_offset = entries[curidx].data[2] - entries[curidx].data[4];
			fprintf(stderr, "Get APP TimeSync Real day time=%u boot time=%u offset = %u\n",
			             entries[curidx].data[2], entries[curidx].data[4], g_app_timesync_offset);
			return 0;
		}
	}
	return 0;
}

int seach_drv_buffer_link(int idx)
{
	unsigned long loop;
	unsigned long startpos;
	unsigned long endpos;
	PLAPP_DIAG_PROFILING_ENTRY	*entries;

	startpos = 0;
    endpos = finfo[idx].entries_cnt;
	entries = (PLAPP_DIAG_PROFILING_ENTRY *) finfo[idx].dataptr;

    for (loop=startpos;loop<endpos;loop++) {
        unsigned long curidx;
        curidx = loop;
        if ((entries[curidx].data[0]==EVENT_FW_TO_ARM_MSG) && (entries[curidx].data[2]==242)) {
			g_drv_link_get = 1;
			g_drv_link_offset = entries[curidx].data[4];
			fprintf(stderr, "Get DRV HCI_LINK_CH time offset = %u\n", g_drv_link_offset);
			return 0;
		}
	}
	return 0;
}


int process_app_buffer(int idx)
{
	uint32_t loop;
	uint32_t startpos;
	uint32_t endpos;
	PLAPP_DIAG_PROFILING_ENTRY	*entries;
	FILE *wr_fp;
	char filename[255];

	startpos = 0;
    endpos = finfo[idx].entries_cnt;
	entries = (PLAPP_DIAG_PROFILING_ENTRY *) finfo[idx].dataptr;

    memset(filename, 0, 255);
	strncpy(filename, finfo[idx].filename, 250);
	strcat(filename,".txt");

	if ((wr_fp=fopen(filename, "w"))==NULL)
	{
		fprintf(stderr,"Error opening ouput file: %s\n",filename);
		return 1;
	}
	if (finfo[idx].filetype==LOG_TYPE_APP)
	    fprintf(wr_fp,"TXT_APPLOG\n");
	else
	    fprintf(wr_fp,"TXT_DRVLOG\n");
    fprintf(wr_fp,"ENTRIES: %d\n", finfo[idx].entries_cnt);
    fprintf(wr_fp,"FRAMENO: %d\n", finfo[idx].max_frameno);
    fprintf(wr_fp," idx  event_id( %-30s ) ch type  FullFNo   FrameNo    Size        Time(ms)\n","name");
    fprintf(wr_fp,"=================================================================================\n");
    for (loop=startpos;loop<endpos;loop++) {
        uint32_t curidx;
        curidx = loop;
		#if 0
		/* skip some item */
        if (entries[curidx].data[0]==EVENT_APP_D_OUT_START)
            continue;
		#endif
        fprintf(wr_fp,"%05u %08x( %-30s ) %2u  %2u %9u %9u %9u %12u\n",
        									curidx,
                                            entries[curidx].data[0],
                                            get_string_in_table(entries[curidx].data[0]),
                                            entries[curidx].data[1] >> 28,
                                            (entries[curidx].data[1] >> 24) & 0xF,
                                            entries[curidx].data[3],
                                            entries[curidx].data[1] & 0xFFFFFF,
                                            entries[curidx].data[2],
                                            entries[curidx].data[4]
											);
    }
	fclose(wr_fp);
	fprintf(stderr,"Update ouput file: %s success!\n",filename);
	return 0;
}


int process_fw_buffer(int idx)
{
	long int byte_swap;
	char temp_string[40];

	uint32_t dw1,dw2,dw3,tick;
	uint32_t start_tick,rel_tick;
	uint64_t rel_us;
	uint32_t rel_ms_32;
	uint32_t thread_id,message_id,dram_log_ch_id;
	uint32_t frame_id;
	uint32_t prev_tick;
	uint32_t chNo;
	uint32_t maxframeno = 0;


	char buffer_dw1[20],buffer_chNo[10],buffer_dw2[20],buffer_dw3[20],buffer_tick[20],buffer_rel_tick[20],buffer_rel_us[20];
	unsigned char *Buf;
	int i;
	int message_lost;

	int frame_cnt=0;

	int start_tick_get = 0;
	uint32_t loop;
	uint32_t startpos;
	uint32_t endpos;
	PLFW_DIAG_PROFILING_ENTRY	*entries;
	FILE *wr_fp;
	char filename[255];

	startpos = 0;
    endpos = finfo[idx].entries_cnt;
	entries = (PLFW_DIAG_PROFILING_ENTRY *) finfo[idx].dataptr;

    memset(filename, 0, 255);
	strncpy(filename, finfo[idx].filename, 250);
	strcat(filename,".txt");

	if ((wr_fp=fopen(filename, "w"))==NULL)
	{
		fprintf(stderr,"Error opening ouput file: %s\n",filename);
		return 1;
	}
/***************************************************/
	prev_tick=0;

	//Buf= (unsigned char *)(&temp);
	//fprintf(wr_fp,"\tmessage   \t\t\t   Time(us)\n");
    fprintf(wr_fp,"TXT_FWLOG\n");
    fprintf(wr_fp,"ENTRIES: %d\n", finfo[idx].entries_cnt);
    fprintf(wr_fp,"FRAMENO: %d\n", finfo[idx].max_frameno);
	fprintf(wr_fp,"%30s\t%23s\t%15s\t%15s\t%25s%5s\n","dw1","dw2          ","dw3","tick(90KHz)","rel time","");
	fprintf(wr_fp,"%30s\t%8s%15s\t%15s\t%15s\t%15s%15s\n","","(chNo,","#frame/#req)","","","tick(90KHz)","uSec");
	fprintf(wr_fp,"=============================================================================================================================\n");

	byte_swap = 1;

	loop = startpos;
	while (1)
	{
		Buf = (unsigned char *)&entries[loop];
		if (byte_swap ==0)
			dw1= (((uint32_t)Buf[0]) << 24)  |  (((uint32_t)Buf[1]) << 16) | (((uint32_t)Buf[2]) << 8) | ((uint32_t)Buf[3]);
		else
			dw1= (((uint32_t)Buf[3]) << 24)  |  (((uint32_t)Buf[2]) << 16) | (((uint32_t)Buf[1]) << 8) | ((uint32_t)Buf[0]);
		thread_id= (dw1 & 0xffff0000) >> 16;
		message_id=(dw1 & 0x0fff)-1;
		dram_log_ch_id= (dw1 & 0xf000) >> 12;

		if (byte_swap ==0)
			dw2= (((uint32_t)Buf[4]) << 24)  |  (((uint32_t)Buf[5]) << 16) | (((uint32_t)Buf[6]) << 8) | ((uint32_t)Buf[7]);
		else
			dw2= (((uint32_t)Buf[7]) << 24)  |  (((uint32_t)Buf[6]) << 16) | (((uint32_t)Buf[5]) << 8) | ((uint32_t)Buf[4]);
		frame_id=dw2 & 0xFFFFFFFUL;
		chNo= (dw2 >> 28) & 0xF;

		if (byte_swap ==0)
			dw3= (((uint32_t)Buf[8]) << 24)  |  (((uint32_t)Buf[9]) << 16) | (((uint32_t)Buf[10]) << 8) | ((uint32_t)Buf[11]);
		else
			dw3= (((uint32_t)Buf[11]) << 24)  |  (((uint32_t)Buf[10]) << 16) | (((uint32_t)Buf[9]) << 8) | ((uint32_t)Buf[8]);

		if (byte_swap ==0)
			tick= (((uint32_t)Buf[12]) << 24)  |  (((uint32_t)Buf[13]) << 16) | (((uint32_t)Buf[14]) << 8) | ((uint32_t)Buf[15]);
		else
			tick= (((uint32_t)Buf[15]) << 24)  |  (((uint32_t)Buf[14]) << 16) | (((uint32_t)Buf[13]) << 8) | ((uint32_t)Buf[12]);

		if (start_tick_get ==0)
		{
			start_tick=tick;
			start_tick_get=1;
		}

		rel_tick=tick-start_tick;
		rel_us = (unsigned long long int)rel_tick*1000/90;

#if 1
		/* also stored the update rel_us back to array */
		rel_ms_32 = (rel_us/1000) & 0xFFFFFFFF;
		if (byte_swap ==0) {
			Buf[16] =  (rel_ms_32 >> 24) & 0xFF;
			Buf[17] =  (rel_ms_32 >> 16) & 0xFF;
			Buf[18] =  (rel_ms_32 >> 8) & 0xFF;
			Buf[19] =  rel_ms_32 & 0xFF;
		}
		else {
			Buf[19] =  (rel_ms_32 >> 24) & 0xFF;
			Buf[18] =  (rel_ms_32 >> 16) & 0xFF;
			Buf[17] =  (rel_ms_32 >> 8) & 0xFF;
			Buf[16] =  rel_ms_32 & 0xFF;
		}

		if ((g_hci_link_get==0) && (dw1==HCI_LINK_CH)) {
			fprintf(stderr, "Get FW HCI_LINK_CH time offset = %u (%llu)\n", rel_ms_32, rel_us);
			g_hci_link_offset = rel_ms_32;
			g_hci_link_get = 1;
		}
#endif

		//rick debug,
		frame_cnt++;
		if (frame_cnt <2)
			fprintf(stderr,"dw1=%d,dw2=%d,dw3=%d,start_tick=%d\n", dw1,dw2,dw3,start_tick);

//		if ((tick < start_tick) || (tick > 0x01235e51) || (tick < prev_tick) || (message_id >15))
//			thread_id=0xffff;
//		else
		{
			prev_tick=tick;
#ifdef __LINUX__
        sprintf(buffer_dw2,"%u", frame_id);
#else
		_ultoa(frame_id,buffer_dw2,10);
#endif
		if (chNo == 0xF)
			strcpy(buffer_chNo,ch_unknown);
		else
#ifdef __LINUX__
        sprintf(buffer_chNo,"%x", chNo);
#else
		_ultoa(chNo,buffer_chNo,16);
#endif
#ifdef __LINUX__
        sprintf(buffer_dw3,"%u", dw3);
        sprintf(buffer_tick,"%u", tick);
        sprintf(buffer_rel_tick,"%u", rel_tick);
        sprintf(buffer_rel_us,"%llu", rel_us);
#else
		_ultoa(dw3,buffer_dw3,10);
		_ultoa(tick,buffer_tick,10);
		_ultoa(rel_tick,buffer_rel_tick,10);
		_ui64toa(rel_us,buffer_rel_us,10);
#endif
		}

		message_lost=0;

#if 1
		fprintf(wr_fp,"%30s\t%8s%15s\t%15s\t%15s\t%15s%15s\n",get_fwstring_in_table(dw1),buffer_chNo,buffer_dw2,buffer_dw3,buffer_tick,buffer_rel_tick,buffer_rel_us);
#else
		switch (thread_id)
		{
		// ----- H.264 encode
		case VIU_THREAD:
//			if (frame_id == (viu_frame_cnt[message_id]+2))
//				message_lost=1;
			viu_frame_cnt[message_id]=frame_id;
			//_ultoa(frame_id,buffer_dw2,10);
			//_ultoa(dw3,buffer_dw3,10);
			//_ultoa(tick,buffer_tick,10);
			//fprintf(wr_fp,"%30s\t%15s\t%15s\t%15s\t%15s\n",VIU_string[message_id],buffer_dw2,buffer_dw3,buffer_tick,buffer_rel_tick);
			if (dram_log_ch_id ==0)
			{
				fprintf(wr_fp,"%30s\t%8s%15s\t%15s\t%15s\t%15s%15s\n",VIU_string[message_id],buffer_chNo,buffer_dw2,buffer_dw3,buffer_tick,buffer_rel_tick,buffer_rel_us);
			}
			if (dram_log_ch_id ==1)
			{
				fprintf(wr_fp,"%30s\t%8s%15s\t%15s\t%15s\t%15s%15s\n",VIU_1_string[message_id],buffer_chNo,buffer_dw2,buffer_dw3,buffer_tick,buffer_rel_tick,buffer_rel_us);
			}
			break;
		case VEN_THREAD:
			//_ultoa(frame_id,buffer_dw2,10);
			//_ultoa(dw3,buffer_dw3,10);
			//_ultoa(tick,buffer_tick,10);
			//fprintf(wr_fp,"%30s\t%15s\t%15s\t%15s\t%15s\n",VEN_string[message_id],buffer_dw2,buffer_dw3,buffer_tick,buffer_rel_tick);

			if (dram_log_ch_id ==0)
			{
				fprintf(wr_fp,"%30s\t%8s%15s\t%15s\t%15s\t%15s%15s\n",VEN_string[message_id],buffer_chNo,buffer_dw2,buffer_dw3,buffer_tick,buffer_rel_tick,buffer_rel_us);
			}
			if (dram_log_ch_id ==1)
			{
				fprintf(wr_fp,"%30s\t%8s%15s\t%15s\t%15s\t%15s%15s\n",VEN_1_string[message_id],buffer_chNo,buffer_dw2,buffer_dw3,buffer_tick,buffer_rel_tick,buffer_rel_us);
			}
			break;
		case MUX_THREAD:
			//_ultoa(frame_id,buffer_dw2,10);
			//_ultoa(dw3,buffer_dw3,10);
			//_ultoa(tick,buffer_tick,10);
			//fprintf(wr_fp,"%30s\t%15s\t%15s\t%15s\t%15s\n",MUX_string[message_id],buffer_dw2,buffer_dw3,buffer_tick,buffer_rel_tick);
			if (dram_log_ch_id ==0)
			{
				fprintf(wr_fp,"%30s\t%8s%15s\t%15s\t%15s\t%15s%15s\n",MUX_string[message_id],buffer_chNo,buffer_dw2,buffer_dw3,buffer_tick,buffer_rel_tick,buffer_rel_us);
			}
			if (dram_log_ch_id ==1)
			{
				fprintf(wr_fp,"%30s\t%8s%15s\t%15s\t%15s\t%15s%15s\n",MUX_1_string[message_id],buffer_chNo,buffer_dw2,buffer_dw3,buffer_tick,buffer_rel_tick,buffer_rel_us);
			}
			break;
		case DTM_THREAD:
//			if (frame_id == (dtm_frame_cnt[message_id]+2))
//				message_lost=1;
			dtm_frame_cnt[message_id]=frame_id;
			//_ultoa(frame_id,buffer_dw2,10);
			//_ultoa(dw3,buffer_dw3,10);
			//_ultoa(tick,buffer_tick,10);
			//fprintf(wr_fp,"%30s\t%15s\t%15s\t%15s\t%15s\n",DTM_string[message_id],buffer_dw2,buffer_dw3,buffer_tick,buffer_rel_tick);
//			if (dram_log_ch_id ==0)
			{
				fprintf(wr_fp,"%30s\t%8s%15s\t%15s\t%15s\t%15s%15s\n",DTM_string[message_id],buffer_chNo,buffer_dw2,buffer_dw3,buffer_tick,buffer_rel_tick,buffer_rel_us);
			}
			break;
		case HCI_THREAD:
			strcpy(buffer_dw3,hex_prefix);
#ifdef __LINUX__
            sprintf(temp_string,"%lx", dw3);
#else
			_ultoa(dw3,temp_string,16);
#endif
			strcat(buffer_dw3,temp_string);
			//_ultoa(frame_id,buffer_dw2,16);
			//_ultoa(frame_id,buffer_dw2,10);
			//_ultoa(dw3,buffer_dw3,10);
			//_ultoa(tick,buffer_tick,10);
			fprintf(wr_fp,"%30s\t%8s%15s\t%15s\t%15s\t%15s%15s\n",HCI_string[message_id],buffer_chNo,buffer_dw2,buffer_dw3,buffer_tick,buffer_rel_tick,buffer_rel_us);
			break;
		//----- H.264 deocde
		case DMX_H264_THREAD:
			//if (message_id >= 4)
			//{
			//	_ultoa(dw3,buffer_dw3,16);
			//	_ultoa(dw2,buffer_dw2,16);
			//}
			//_ultoa(frame_id,buffer_dw2,10);
			//_ultoa(dw3,buffer_dw3,10);
			//_ultoa(tick,buffer_tick,10);
			fprintf(wr_fp,"%30s\t%8s%15s\t%15s\t%15s\t%15s%15s\n",DMX_string[message_id],buffer_chNo,buffer_dw2,buffer_dw3,buffer_tick,buffer_rel_tick,buffer_rel_us);
			break;
		case VDE_THREAD:
			//_ultoa(frame_id,buffer_dw2,10);
			//_ultoa(dw3,buffer_dw3,10);
			//_ultoa(tick,buffer_tick,10);
			fprintf(wr_fp,"%30s\t%8s%15s\t%15s\t%15s\t%15s%15s\n",VDE_string[message_id],buffer_chNo,buffer_dw2,buffer_dw3,buffer_tick,buffer_rel_tick,buffer_rel_us);
			break;
		case VOU_THREAD:
			//_ultoa(frame_id,buffer_dw2,10);
			//_ultoa(dw3,buffer_dw3,10);
			//_ultoa(tick,buffer_tick,10);
			fprintf(wr_fp,"%30s\t%8s%15s\t%15s\t%15s\t%15s%15s\n",VOU_string[message_id],buffer_chNo,buffer_dw2,buffer_dw3,buffer_tick,buffer_rel_tick,buffer_rel_us);
			break;

		//----- JPEG decode
		case DMX_JPEG_THREAD:
			//_ultoa(frame_id,buffer_dw2,10);
			//_ultoa(dw3,buffer_dw3,16);
			//_ultoa(tick,buffer_tick,10);
			fprintf(wr_fp,"%30s\t%8s%15s\t%15s\t%15s\t%15s%15s\n",JDMX_string[message_id],buffer_chNo,buffer_dw2,buffer_dw3,buffer_tick,buffer_rel_tick,buffer_rel_us);
			break;
		case JDE_THREAD:
			//_ultoa(frame_id,buffer_dw2,10);
			//_ultoa(dw3,buffer_dw3,10);
			//_ultoa(tick,buffer_tick,10);
			fprintf(wr_fp,"%30s\t%8s%15s\t%15s\t%15s\t%15s%15s\n",JDE_string[message_id],buffer_chNo,buffer_dw2,buffer_dw3,buffer_tick,buffer_rel_tick,buffer_rel_us);
			break;
		//----- JPEG encode
		case JEN_THREAD:
//			if (frame_id == (jen_frame_cnt[message_id]+2))
//				message_lost=1;
			jen_frame_cnt[message_id]=frame_id;
			//_ultoa(frame_id,buffer_dw2,10);
			//_ultoa(dw3,buffer_dw3,10);
			//_ultoa(tick,buffer_tick,10);
			fprintf(wr_fp,"%30s\t%8s%15s\t%15s\t%15s\t%15s%15s\n",JEN_string[message_id],buffer_chNo,buffer_dw2,buffer_dw3,buffer_tick,buffer_rel_tick,buffer_rel_us);
			break;
					//----- VIU_INT
		case VIU_INT:
			//_ultoa(frame_id,buffer_dw2,10);
			//_ultoa(dw3,buffer_dw3,10);
			//_ultoa(tick,buffer_tick,10);
			fprintf(wr_fp,"%30s\t%8s%15s\t%15s\t%15s\t%15s%15s\n",VIU_INT_string[message_id],buffer_chNo,buffer_dw2,buffer_dw3,buffer_tick,buffer_rel_tick,buffer_rel_us);
			break;
		case DCMMSG_THREAD:
			//_ultoa(frame_id,buffer_dw2,10);
			//_ultoa(dw3,buffer_dw3,10);
			//_ultoa(tick,buffer_tick,10);
			fprintf(wr_fp,"%30s\t%8s%15s\t%15s\t%15s\t%15s%15s\n",DCMMSG_string[message_id],buffer_chNo,buffer_dw2,buffer_dw3,buffer_tick,buffer_rel_tick,buffer_rel_us);
			break;
		case DCM_THREAD:
			//_ultoa(frame_id,buffer_dw2,10);
			//_ultoa(dw3,buffer_dw3,10);
			//_ultoa(tick,buffer_tick,10);
			fprintf(wr_fp,"%30s\t%8s%15s\t%15s\t%15s\t%15s%15s\n",DCM_string[message_id],buffer_chNo,buffer_dw2,buffer_dw3,buffer_tick,buffer_rel_tick,buffer_rel_us);
			break;
		case AIO_THREAD:
#ifdef __LINUX__
            sprintf(buffer_dw3,"%lu", dw3);
            sprintf(buffer_dw2,"%lu", dw2);
#else
			_ultoa(dw3,buffer_dw3,10);
			_ultoa(dw2,buffer_dw2,10);
#endif
			fprintf(wr_fp,"%30s\t%8s%15s\t%15s\t%15s\t%15s%15s\n",AIO_string[message_id],buffer_chNo,buffer_dw2,buffer_dw3,buffer_tick,buffer_rel_tick,buffer_rel_us);
			break;
		case QPSOS_THREAD:
#ifdef __LINUX__
            sprintf(buffer_dw3,"%lx", dw3);
            sprintf(buffer_dw2,"%lx", dw2);
#else
			_ultoa(dw3,buffer_dw3,16);
			_ultoa(dw2,buffer_dw2,16);
#endif
			fprintf(wr_fp,"%30s\t%8s%15s\t%15s\t%15s\t%15s%15s\n",QPSOS_string[message_id],buffer_chNo,buffer_dw2,buffer_dw3,buffer_tick,buffer_rel_tick,buffer_rel_us);
			//fprintf(aio_wr_fp[message_id],"%15s\n",buffer_rel_tick);
			break;
		default:
//			_ultoa(dw3,buffer_dw3,16);
//			_ultoa(dw2,buffer_dw2,16);
//			_ultoa(dw1,buffer_dw1,16);
//			fprintf(wr_fp,"%30s\t%8s%15s\t%15s\t%15s\t%15s\n",buffer_dw1,buffer_chNo,buffer_dw2,buffer_dw3,buffer_tick,buffer_rel_tick);
			fprintf(wr_fp,"xxxxxxxxxxxxxxxxxxxxxxxxxxxx\n");
			break;
		}
#endif
		loop++;
		if (loop>=endpos)
			break;
	}
/***************************************************/
	fclose(wr_fp);
	fprintf(stderr,"Update ouput file: %s success!\n",filename);
	return 0;
}

int process_full_buffer(int idx)
{
	uint32_t loop;
	uint32_t startpos;
	uint32_t endpos;
	PLAPP_DIAG_PROFILING_ENTRY	*entries;
	FILE *wr_fp;
	char filename[255];

	startpos = 0;
    endpos = finfo[idx].entries_cnt;
	entries = (PLAPP_DIAG_PROFILING_ENTRY *) finfo[idx].dataptr;

    memset(filename, 0, 255);
	strncpy(filename, finfo[idx].filename, 250);
	strcat(filename,".txt");

	if ((wr_fp=fopen(filename, "w"))==NULL)
	{
		fprintf(stderr,"Error opening ouput file: %s\n",filename);
		return 1;
	}

    fprintf(wr_fp,"TXT_FULLLOG\n");
    fprintf(wr_fp,"ENTRIES: %d\n", finfo[idx].entries_cnt);
    fprintf(wr_fp,"FRAMENO: %d\n", finfo[idx].entries_looped);
    fprintf(wr_fp," idx  event_id( %-30s ) ch type  FullFNo   FrameNo    Size        Time(ms)\n","name");
    fprintf(wr_fp,"=================================================================================\n");
    for (loop=startpos;loop<endpos;loop++) {
        uint32_t curidx;
        curidx = loop;
		if ( entries[curidx].data[0] > 0x8000000 ) {
		    /* app type */
	        fprintf(wr_fp,"%05u %08x( %-30s ) %2u  %2u %9u %9u %9u %12u\n",
	        									curidx,
	                                            entries[curidx].data[0],
	                                            get_string_in_table(entries[curidx].data[0]),
	                                            entries[curidx].data[1] >> 28,
	                                            (entries[curidx].data[1] >> 24) & 0xF,
	                                            entries[curidx].data[3],
	                                            entries[curidx].data[1] & 0xFFFFFF,
	                                            entries[curidx].data[2],
	                                            entries[curidx].data[4]
												);
		}
		else {
	        fprintf(wr_fp,"%05u %08x[ %-30s ] %2u  %2s %6s %12u %9u %12u %12u\n",
	        									curidx,
	                                            entries[curidx].data[0],
	                                            get_fwstring_in_table(entries[curidx].data[0]),
	                                            entries[curidx].data[1] >> 28,	 /* channel no */
	                                            " ",							 /* type, not in fw */
	                                            " ",							 /* full frame no, not in fw */
	                                            entries[curidx].data[1] & 0xFFFFFFF,  /* frame no */
	                                            entries[curidx].data[2],  			   /* size */
	                                            entries[curidx].data[4], 			   /* time in ms */
	                                            entries[curidx].data[3] 			   /* time in orignal tick */
												);

		}
    }
	fclose(wr_fp);
	fprintf(stderr,"Update ouput file: %s success!\n",filename);
	return 0;
}

#define PROF_FULL_FILENAME "prof_full.dat"

typedef struct _CONF_LIST
{
	char     id_name[40];
	uint32_t id;
	uint8_t  ch;
	uint8_t test_entry;  /* 0: frame_no field, 1: full_frame_no field,  2/3: (next frame), 4/5: (prev frame) */
	uint8_t data_entry;
} CONF_LIST_ENTRY;

CONF_LIST_ENTRY  config_table[30] = {
 {"VIU_PASS_FRAME_IN", 0, 0xF, 0, 4},
 {"VEN_ENC_TOP", 0, 0, 0, 4},
 {"VEN_ENC_TOP_DONE", 0, 0, 0, 4},
 {"DTM_REQ_OUT", 0, 0, 0, 4},
 {"EVENT_APP_S_OUT", 0, 0, 0, 4},
 {"EVENT_APP_S_OUT_FINISH", 0, 0, 0, 4},
 {"EVENT_APP_S_IN", 0, 1, 0, 4},
 {"EVENT_APP_S_IN_FINISH", 0, 1, 0, 4},
 {"DMX2VDE_DATA_PASSING_VCL", 0, 1, 0, 4},
 {"VDE_DATA_START_DEC", 0, 1, 0, 4},
 {"VDE_DATA_END_DEC", 0, 1, 0, 4},
 {"VOU_DATA_DISPLAY", 0, 1, 0, 4},
 {"", 0, 0, 4},
};


int fileter_files(int idx)
{

}

int combine_files(void)
{
	int fileidx[MAX_FILE_NO];
	int i,j;
	int entry_get = 0;
	int entry_peek;
	FILE *wr_fp;
	uint32_t totalloop = 0;
	uint32_t totalloopexpected = 0;
	uint32_t timemin;
	uint32_t maxno=0;

	char buf[20];

	if ((wr_fp=fopen(PROF_FULL_FILENAME, "wb"))==NULL)
	{
		fprintf(stderr,"Error opening ouput file: %s\n", PROF_FULL_FILENAME);
		return 1;
	}

	/* update time info stored in fw table */
	for (i=0;i<finfo_used;i++) {
		if (finfo[i].filetype==LOG_TYPE_FW)	{
			PLAPP_DIAG_PROFILING_ENTRY	*entries;
			entries = (PLAPP_DIAG_PROFILING_ENTRY *) finfo[i].dataptr;
			for (j=0;j<finfo[i].entries_cnt;j++) {
				entries[j].data[4] = entries[j].data[4] + g_drv_fw_time_offset;
			}
		}
	}


	for (i=0;i<finfo_used;i++) {
		fileidx[i] = 0;
		if (finfo[i].filetype!=LOG_TYPE_FUL) {
			totalloopexpected += finfo[i].entries_cnt;
			if (maxno<finfo[i].max_frameno)
				maxno = finfo[i].max_frameno;
		}
	}

	memset(buf, 0, 20);
	memcpy(buf,"FULPROF", 7);
    fwrite(buf, 1, 8, wr_fp);
    fwrite(&totalloopexpected, 1, 4, wr_fp);
    fwrite(&maxno, 1, 4, wr_fp);

	do {
		entry_peek = -1;
		timemin = 0xFFFFFFFF;
		for (i=0;i<finfo_used;i++) {
			if (fileidx[i] < finfo[i].entries_cnt) {
				if ((finfo[i].filetype==LOG_TYPE_APP)|| (finfo[i].filetype==LOG_TYPE_DRV)) {
					PLAPP_DIAG_PROFILING_ENTRY	*entries;
					entries = (PLAPP_DIAG_PROFILING_ENTRY *) finfo[i].dataptr;
					if (entries[fileidx[i]].data[4] < timemin) {
						entry_peek = i;
						timemin = entries[fileidx[i]].data[4];
					}
				}
				else if (finfo[i].filetype==LOG_TYPE_FW) {
					PLAPP_DIAG_PROFILING_ENTRY	*entries;
					entries = (PLAPP_DIAG_PROFILING_ENTRY *) finfo[i].dataptr;
					if (entries[fileidx[i]].data[4] < timemin) {
						entry_peek = i;
						timemin = entries[fileidx[i]].data[4];
					}
				}
			}
		}
		if (entry_peek >= 0 ) {
			PLAPP_DIAG_PROFILING_ENTRY	*entries;
			entries = (PLAPP_DIAG_PROFILING_ENTRY *) finfo[entry_peek].dataptr;
			fwrite(&entries[fileidx[entry_peek]], 1, 20, wr_fp);
			fileidx[entry_peek]++;
			totalloop++;
		}
	    if (totalloop > totalloopexpected) {
			fprintf(stderr,"WARNING: why loop cunt over ?? %d %d \n", totalloop, totalloopexpected);
		}
	} while (entry_peek>=0);
    if (totalloop != totalloopexpected) {
		fprintf(stderr,"WARNING: why loop count too small?? %d %d \n", totalloop, totalloopexpected);
	}
	fclose(wr_fp);
	fprintf(stderr,"Generated full profiling data file: %s success!\n",PROF_FULL_FILENAME);
	return 0;
}

int main(int argc, char* argv[])
{

	FILE *rd_fp,*wr_fp;
	unsigned int filesize;
	unsigned char Buf[12];
	unsigned long startpos = 0;
	unsigned long endpos = 0;
	unsigned long idx;
	unsigned long preidx = 0;
	unsigned int  logtype;
	unsigned int  fileidx;
	int  i, err;

	if (argc<2) {
		fprintf(stderr,"Usage: conv_prof log_data1 [log_data2] [log_data3] \n");
		return 1;
	}

	memset(&finfo[0], 0, sizeof(finfo));

	finfo_used = 0;
	do {
		err = read_file_into_mem(finfo_used, argv[finfo_used+1]);
		if (err) {
			fprintf(stderr,"Error: on process file %s \n", argv[finfo_used+1] );
			for (i=0;i<=finfo_used;i++) {
				if (finfo[i].dataptr!=NULL)
					free(finfo[i].dataptr);
			}
			return 1;
		}
		//else {
		//	fprintf(stderr,"Success on cache file %s \n", argv[finfo_used+1] );
		//}
		finfo_used++;
	} while ((finfo_used+1)<argc);

	for (i=0;i<finfo_used;i++) {
		fprintf(stderr,"==> Start process (%d) file, type=%d\n", i, finfo[i].filetype);
		if ((finfo[i].filetype==LOG_TYPE_APP) || (finfo[i].filetype==LOG_TYPE_DRV)) {
			process_app_buffer(i);
		}
		else if (finfo[i].filetype==LOG_TYPE_FW) {
			process_fw_buffer(i);
		}
		else if (finfo[i].filetype==LOG_TYPE_FUL) {
			process_full_buffer(i);
		}
	}

	if ((app_log_got) && (drv_log_got) && (fw_log_got))	{
		int ret;
		fprintf(stderr, "==> Start re-organization files\n");
		if (g_hci_link_get) {
			/* search the drv log to find the first system link message, so we know the time difference */
			for (i=0;i<finfo_used;i++) {
				if (finfo[i].filetype==LOG_TYPE_APP) {
					seach_app_buffer_timesync(i);
				}
				if (finfo[i].filetype==LOG_TYPE_DRV) {
					seach_drv_buffer_link(i);
				}
			}
		}

		if ((g_drv_link_get==0)||(g_hci_link_get==0))
			fprintf(stderr, "\n\n==> WARNING: can not get time info in data file!!!!\n\n");

		g_drv_fw_time_offset = g_drv_link_offset - g_hci_link_offset;

		/* now we get the time difference between driver log and fw log */
		fprintf(stderr, "Difference between Driver time and FW time is %u\n", g_drv_fw_time_offset);

		ret = combine_files();
		if (ret==0) {
			/* success generate combined file */
			/* free all buf */
			for (i=0;i<finfo_used;i++) {
				if (finfo[i].dataptr!=NULL)
					free(finfo[i].dataptr);
			}
			fprintf(stderr, "==> Convert the combined file to txt\n");
			finfo_used = 0;
			/* get combind file again and translate it to log */
			ret = read_file_into_mem(finfo_used, PROF_FULL_FILENAME );
			if (ret) {
				fprintf(stderr,"Error: on process file %s \n", PROF_FULL_FILENAME );
				for (i=0;i<=finfo_used;i++) {
					if (finfo[i].dataptr!=NULL)
						free(finfo[i].dataptr);
				}
			}
			else {
				if (finfo[0].filetype==LOG_TYPE_FUL) {
					process_full_buffer(0);
				}
				else {
					fprintf(stderr,"Error: combined file %s type not match\n", PROF_FULL_FILENAME );
				}
			}
		}
	}
	else {
		fprintf(stderr, "==> Not input all app/drv/fw logs, finish process \n");
	}
	for (i=0;i<finfo_used;i++) {
		if (finfo[i].dataptr!=NULL)
			free(finfo[i].dataptr);
	}
}
