/*************************************************************************/
/**      **/
/**            **/
/**                **/
/**              **/
/**                                                                     **/
/**                               **/
/**                                                  **/
/*************************************************************************/

#ifndef __QLPROFILE_H__
#define __QLPROFILE_H__

#ifdef CONFIG_ENABLE_PROFILING_SUPPORT
#define ENABLE_APP_LINUX_PROFILING
#else
//#error 	"ENABLE_APP_LINUX_PROFILING not defined"
#endif

#ifdef ENABLE_APP_LINUX_PROFILING
#define PL330APP_PROFILING_MAX_SIZE 80000

typedef struct _PLAPP_DIAG_PROFILING_STRUCT
{
	TQP_UINT8	header[8];
	TQP_UINT32	cur_profiling_idx;
	TQP_UINT32	looped;
	TQP_UINT32	entries[PL330APP_PROFILING_MAX_SIZE][5];
} PLAPP_DIAG_PROFILING_STRUCT, *PPLAPP_DIAG_PROFILING_STRUCT;


#define EVENT_APP_PORTOPEN			0xC0000001
#define EVENT_APP_PORTCLOSE		    0xC0000002
#define EVENT_APP_START             0xC0000003
#define EVENT_APP_STOP				0xC0000004
#define EVENT_APP_ACQUIRE			0xC0000005
#define EVENT_APP_OPEN				0xC0000006
#define EVENT_APP_OPEN_FAILED		0xC0001006
#define EVENT_APP_CLOSE			    0xC0000007
#define EVENT_APP_OPEN_MAPTO_CH		0xC0000008
#define EVENT_APP_D_OUT_START		0xC0000010
#define EVENT_APP_D_OUT			    0xC0000011
#define EVENT_APP_D_OUT_NODATA		0xC0000012
#define EVENT_APP_D_OUT_FAILED		0xC0000013
#define EVENT_APP_D_IN_START		0xC0000020
#define EVENT_APP_D_IN				0xC0000021
#define EVENT_APP_D_IN_FAILED		0xC0001022
#define EVENT_APP_D_OUT_INCOMPLETE_FRAME  0xC0000015

#define EVENT_APP_S_IN              0xC0000300
#define EVENT_APP_S_IN_FIRST        0xC0000301
#define EVENT_APP_S_IN_FINISH       0xC0000302
#define EVENT_APP_S_OUT             0xC0000400
#define EVENT_APP_S_OUT_FIRST       0xC0000401
#define EVENT_APP_S_OUT_FINISH      0xC0000402

#define EVENT_APP_TIME_SYNC         0xC0000501

extern int  g_profling_enable; /* define in qlprofile.c */
extern void pl330app_profiling_log_init(void);
extern void pl330app_profiling_log_add(TQP_UINT32 dwEvent, TQP_UINT32 dwChannel, TQP_UINT32 dwType, TQP_UINT32 dwPram1, TQP_UINT32 dwFrameNo, TQP_UINT32 dwSize);
extern void pl330app_profiling_log_fini(void);
extern void pl330app_profiling_log_reset(void);
extern void pl330app_profiling_log_dump(char *filename);

#define APP_PROFILING_LOG_INIT()           pl330app_profiling_log_init()
/* event, device, channel, frameno, dwsize */
#define APP_PROFILING_LOG(x1,x2,x3,x4,x5,x6)  { if (g_profling_enable) pl330app_profiling_log_add(x1,x2,x3,x4,x5,x6); }
#define APP_PORFILING_LOG_RESET()          { if (g_profling_enable) pl330app_profiling_log_reset(); }
#define APP_PORFILING_LOG_FINT()           { if (g_profling_enable) pl330app_profiling_log_fini(); }
#define APP_PORFILING_LOG_DUMP(x1)         { if (g_profling_enable) pl330app_profiling_log_dump(x1); }
#else
//#define PL330APP_PROFILING_MAX_SIZE         1
#define APP_PROFILING_LOG_INIT()              {}
#define APP_PROFILING_LOG(x1,x2,x3,x4,x5,x6)  {}
#define APP_PORFILING_LOG_RESET()             {}
#define APP_PORFILING_LOG_FINT()              {}
#define APP_PORFILING_LOG_DUMP(x1)            {}
#endif

#endif //__QLPROFILE_H__

