/*************************************************************************/
/**      **/
/**            **/
/**                **/
/**              **/
/**                                                                     **/
/**                               **/
/**                                                  **/
/*************************************************************************/

#ifndef __QLVAGC_H__
#define __QLVAGC_H__

typedef struct
{
	//int AGCInitDone;
	int AGCHandle;
	int AGCCtlEn;
	int AGCDevice;
	int AGCSilenceLevel;
	int32_t AGCMeanHigh;		 
	int32_t AGCMeanLow;
	int32_t AGCUpMaxHigh;
	int32_t AGCDownMinHigh;
	int AGCHwMin;
	int AGCHwMax;
	int AGCHwDef;
	int AGCHwStep;
	int AGCCheckCnt;
	int AGCAllowMeanOverCnt;
	int AGCAllowMeanUnderCnt;
	int AGCAllowHighOverCnt;
	int AGCCheckPeriod;
	int AGCProtectPeriod;
	int AGCCheckAlways;
	int AGCAlg;
	int AGCPrintInfo;

	int sampleno;
	int largeno;
	int smallno;
	int maxhighno;
	int slienceno;
	uint32_t lastvolume;
	//uint32_t maxhighinperoid;
	int32_t maxehighinperoid;
	int32_t maxelowinperoid;
	uint32_t maxmeaninperoid;
	//uint32_t maxhighfull;
	int cachevolval;
	//time_t maxhightime;
	time_t lastchecktime;
	time_t lastagcupdatetime;
} TQLVAGCInfo, *PTQLVAGCInfo;

int QLVAGC_Initial(component_t* pComponent, PTQLVAGCInfo* ppQLVAGCInfo);
int QLVAGC_Config(PTQLVAGCInfo pQLVAGCInfo, const char * pCfgFile);
int QLVAGC_HwOpen(PTQLVAGCInfo pQLVAGCInfo, int force);
int QLVAGC_HwClose(PTQLVAGCInfo pQLVAGCInfo);
int QLVAGC_AgcOnOff(PTQLVAGCInfo pQLVAGCInfo, int enable);
int QLVAGC_AgcUpdate(PTQLVAGCInfo pQLVAGCInfo, int DbgByteCnt);
void QLVAGC_Release(PTQLVAGCInfo pQLVAGCInfo);
#endif	// __QLVAGC_H__

