#ifndef __PLPROFILING_H__
#define __PLPROFILING_H__

#include "qptypes.h"
#include "qlautoconf.h"

#ifdef CONFIG_ENABLE_PROFILING_SUPPORT
#define ENABLE_LINUX_PROFILING
#else
//#error 	"ENABLE_LINUX_PROFILING not defined"
#endif

#ifdef ENABLE_LINUX_PROFILING
#define QP_MAX_PROFILING_SIZE       80000

#define EVENT_COMP_PORTOPEN			0x80000001
#define EVENT_COMP_PORTCLOSE		0x80000002
#define EVENT_COMP_START            0x80000003
#define EVENT_COMP_STOP				0x80000004
#define EVENT_COMP_ACQUIRE			0x80000005
#define EVENT_COMP_OPEN				0x80000006
#define EVENT_COMP_OPEN_FAILED		0x80001006
#define EVENT_COMP_CLOSE			0x80000007
#define EVENT_COMP_D_OUT			0x80000010
#define EVENT_COMP_D_OUT_NODATA		0x80000011
#define EVENT_COMP_D_OUT_FAILED		0x80001010
#define EVENT_COMP_D_IN				0x80000020
#define EVENT_COMP_D_IN_FAILED		0x80001020
#define EVENT_COMP_D_OUT_INCOMPLETE_FRAME  0x80000015

#define EVENT_FW_TO_ARM_MSG			0x90000001
#define EVENT_FW_TO_ARM_MSG_FAILED	0x90001001

#define EVENT_FW_FROM_ARM_MSG		0x90000010

#define EVENT_FW_SYSTEM_OPEN        0x90000101
#define EVENT_FW_SYSTEM_LINK		0x90000102
#define EVENT_FW_SYSTEM_START		0x90000103
#define EVENT_FW_SYSTEM_CLOSE		0x90000104
#define EVENT_FW_D_OUT_REQ			0x90000400
#define EVENT_FW_D_OUT_LAST_REQ		0x90000401
#define EVENT_FW_D_OUT_REQ2			0x90000402
#define EVENT_FW_D_OUT_INCOMPLETE_FRAME  0x90000415
#define EVENT_FW_D_OUT_REQ_ACK  	0x900004ff
#define EVENT_FW_D_IN_REQ			0x90000500
#define EVENT_FW_D_IN_REQ_FINISH	0x900005ff

extern void pl330_profiling_log_init(void);
extern void pl330_profiling_log_add(TQP_UINT32 dwEvent, TQP_UINT32 dwChannel, TQP_UINT32 dwType, TQP_UINT32 dwPram1, TQP_UINT32 dwFrameNo, TQP_UINT32 dwSize);
extern void pl330_profiling_log_fini(void);
extern void pl330_profiling_log_reset(void);
extern void* pl330_profiling_get_log_address(void);
extern unsigned int g_profiling_mode;

#define PROFILING_LOG_INIT()           { if (g_profiling_mode) pl330_profiling_log_init(); }
/* event, device, channel, frameno, dwsize */
#define PROFILING_LOG(x1,x2,x3,x4,x5,x6)  { if (g_profiling_mode) pl330_profiling_log_add(x1,x2,x3,x4,x5,x6); }
#define PORFILING_LOG_RESET()          { if (g_profiling_mode) pl330_profiling_log_reset(); }
#define PORFILING_LOG_FINT()           { if (g_profiling_mode) pl330_profiling_log_fini(); }
#define PORFILING_LOG_GET_ADDRESS()    pl330_profiling_get_log_address()
#else
#define QP_MAX_PROFILING_SIZE          		1
#define PROFILING_LOG_INIT()           		{}
#define PROFILING_LOG(x1,x2,x3,x4,x5,x6)  	{}
#define PORFILING_LOG_RESET()          		{}
#define PORFILING_LOG_FINT()           		{}
#define PORFILING_LOG_GET_ADDRESS()    		0
#endif

#endif

