///////////////////////////////////////////////////////////////////////////////
//        
//
// CdecoderTask.h
//
// Description: 
//
//	Header file which defines the decoder task
// 
// History:
//	Aug 4, 2006	(dt) initial check in
//
// Authors: (dt) David Tao
//
///////////////////////////////////////////////////////////////////////////////

#ifndef __CDECODERTASK_H__
#define __CDECODERTASK_H__


#include "qptypes.h"
#include "ctask.h"

#ifdef __cplusplus
extern "C" {
#endif


#ifndef __CDECODERTASK_FWD_DEFINED__
#define __CDECODERTASK_FWD_DEFINED__
typedef struct CDecoderTask CDecoderTask;
#endif //!__CDECODERTASK_FWD_DEFINED__


struct CDecoderTask
{
	// public CTask
	//
	CTask		m_Task;

	TQP_BOOL	m_bDecDone;
};

// constructor
//
CDecoderTask * CDecoderTask_Constructor(CDecoderTask *pDecoderTask,
										CObject *pParent,
										TQP_UINT32 dwAttributes,
										TQP_UINT32 dwPriority,
										CQLCodec *pMpegCodec,
										TQP_OSMEvtgrpID evtWait,
										TQP_OSMEvtgrpID evtReply
										);

// destructor
//
void CDecoderTask_Destructor(CDecoderTask *This);


#ifdef __cplusplus
}
#endif


#endif //__CDECODERTASK_H__


