///////////////////////////////////////////////////////////////////////////////
//        
//
//		codeclib.h
//
// History:
//	May 28, 2009	(EC) Created
//
// Authors: (EC) Enrico Cadorin
//
///////////////////////////////////////////////////////////////////////////////

//
// Public definitions for the Video Firmware module (codeclib).

#ifndef __CODECLIB_H__
#define __CODECLIB_H__

#include "qptypes.h"
#include "qpmemmgr.h"

#include "qpsos.h"

// codeclib shared memory area (PHY_CODECAREA); not to exceed 4kB

// TODO: put the right fields in this structure

typedef struct {
	TQP_UINT32		debugInfo[128];		// debug information
	void *			pointer;			// pointer to something
	TQP_BOOL		flag;				// binary flag
	TQP_UINT32		word;				// word parameter
} TCodecLibGlobs, *PTCodecLibGlobs;

//
// The fields of the codeclib shared area can be accessed using the macro below:
//
//		CodecLibGlobs.debugInfo[i] = counter;
//
//		if (CodecLibGlobs.glag) {
//		}
//
#define CodecLibGlobs (*((PTCodecLibGlobs) QPMMPhy2Vir((void *) PHY_CODECAREA)))

// external CPU need to use physical address to access those variables
//
#define CONFIG_SIGN_INT_MODE_PHY_ADDR      (PHY_CODECAREA + 0x90)
#define CONFIG_SIGN_FIXED_MODE_PHY_ADDR    (PHY_CODECAREA + 0x94)
#define CONFIG_VSYNC_CALLBACK_ADDR         (PHY_CODECAREA + 0x98)
#define CONFIG_V_START_WAIT_CNT_ADDR       (PHY_CODECAREA + 0x9C)

// code running on QPSOS use virtual address to access those variables
//
#define CONFIG_SIGN_FIXED_MODE    QPMMPhy2Vir((void *)CONFIG_SIGN_FIXED_MODE_PHY_ADDR)
#define CONFIG_SIGN_INT_MODE      QPMMPhy2Vir((void *)CONFIG_SIGN_INT_MODE_PHY_ADDR)
#define CONFIG_VSYNC_CALLBACK     QPMMPhy2Vir((void *)CONFIG_VSYNC_CALLBACK_ADDR)
#define CONFIG_V_START_WAIT_CNT   QPMMPhy2Vir((void *)CONFIG_V_START_WAIT_CNT_ADDR)

#endif //__CODECLIB_H__

