///////////////////////////////////////////////////////////////////////////////
//        
//
// Qpgenericdevice.h
//
// Description: 
//
//  This is the definations of the generic device
// 
// History:
//	Aug 4, 2006	(dt) initial check in
//
// Authors: (dt) David Tao
//
///////////////////////////////////////////////////////////////////////////////

#ifndef __QPGENERICDEVICE_H__
#define __QPGENERICDEVICE_H__


#include "qptypes.h"

#ifdef __cplusplus
extern "C" {
#endif


/////////////////////////////////////////////////////////////////////////////
//
//


// callback fuction type
//
typedef EQP_Errors (*QP_DEVICE_CALLBACK)(TQP_PVOID Context, TQP_UINT32 dwCode, TQP_PVOID pParam);


/////////////////////////////////////////////////////////////////////////////
//
//

#ifndef __IGENERICDEVICE_FWD_DEFINED__
#define __IGENERICDEVICE_FWD_DEFINED__
typedef struct IGenericDevice IGenericDevice;
#endif //__IGENERICDEVICE_FWD_DEFINED__

    struct IGenericDevice
    {
		EQP_Errors (*InitDevice)(IGenericDevice *This, 
								 QP_DEVICE_CALLBACK pFuncCallback,
								 TQP_PVOID context,
								 TQP_PVOID pInitData
								 );
		EQP_Errors (*Release)(IGenericDevice *This);
		EQP_Errors (*Reset)(IGenericDevice *This);
		EQP_Errors (*Set)(IGenericDevice *This, 
						  TQP_REFGUID guid,
						  TQP_OBJECT_HANDLE hIndex,
						  TQP_UINT32 dwCode,
						  TQP_PVOID pSettings,
						  TQP_PVOID pExtra,
						  TQP_UINT32 dwSize
						  );
		EQP_Errors (*Get)(IGenericDevice *This, 
						  TQP_REFGUID guid,
						  TQP_OBJECT_HANDLE hIndex,
						  TQP_UINT32 dwCode,
						  TQP_PVOID pSettings,
						  TQP_PVOID pExtra,
						  PTQP_UINT32 pdwSizeGot
						  );
    };

#define DECLARE_IGENERICDEVICE(Type) \
		EQP_Errors (*InitDevice)(Type *This,\
								 QP_DEVICE_CALLBACK pFuncCallback,\
								 TQP_PVOID context,\
								 TQP_PVOID pInitData\
								 );\
		EQP_Errors (*Release)(Type *This);\
		EQP_Errors (*Reset)(Type *This);\
		EQP_Errors (*Set)(Type *This,\
						  TQP_REFGUID guid,\
						  TQP_OBJECT_HANDLE hIndex,\
						  TQP_UINT32 dwCode,\
						  TQP_PVOID pInput,\
						  TQP_PVOID pOutput,\
						  TQP_UINT32 dwSize\
						  );\
		EQP_Errors (*Get)(Type *This,\
						  TQP_REFGUID guid,\
						  TQP_OBJECT_HANDLE hIndex,\
						  TQP_UINT32 dwCode,\
						  TQP_PVOID pInput,\
						  TQP_PVOID pOutput,\
						  PTQP_UINT32 pdwSizeGot\
						  );


/////////////////////////////////////////////////////////////////////////////
//
//

#define QPGenericDevice_InitDevice(This, pFuncCallback, context, pInitData) \
    (This)->InitDevice(This, pFuncCallback, context, pInitData)

#define QPGenericDevice_Release(This) \
    (This)->Release(This)

#define QPGenericDevice_Reset(This) \
    (This)->Reset(This)

#define QPGenericDevice_Set(This, guid, hIndex, dwCode, pInput, pOutput, dwSize) \
    (This)->Set(This, guid, hIndex, dwCode, pInput, pOutput, dwSize)

#define QPGenericDevice_Get(This, guid, hIndex, dwCode, pInput, pOutput, pdwSizeGot) \
    (This)->Get(This, guid, hIndex, dwCode, pInput, pOutput, pdwSizeGot)



#ifdef __cplusplus
}
#endif

#endif //__QPGENERICDEVICE_H__

