///////////////////////////////////////////////////////////////////////////////
//        
//
// Qptvaudio.h
//
// Description: 
//
//  This is the definations of the TVAudio chip interface
// 
// History:
//	Aug 4, 2006	(dt) initial check in
//
// Authors: (dt) David Tao
//
///////////////////////////////////////////////////////////////////////////////

#ifndef __QPTVAUDIO_H__
#define __QPTVAUDIO_H__


#include "qptypes.h"
#include "qpgenericdevice.h"

#ifdef __cplusplus
extern "C" {
#endif


/////////////////////////////////////////////////////////////////////////////
//
//

#define	TVAUDIO_MODE_MONO			0x0001
#define	TVAUDIO_MODE_STEREO			0x0002
#define	TVAUDIO_MODE_LANG_A			0x0010
#define	TVAUDIO_MODE_LANG_B			0x0020
#define	TVAUDIO_MODE_LANG_C			0x0040
#define	TVAUDIO_MODE_INVALID		0


typedef enum _ETVAUDIO_INPUT
{
	eTV,
	eMONO,
	eMUTE,
	eFM,
	eLINE
} ETVAUDIO_INPUT, *PETVAUDIO_INPUT;



/////////////////////////////////////////////////////////////////////////////
//
//

// device specific initialization data
//

typedef enum _QPTVAUDIO_TYPE
{
	TVAUDIO_DUMMY = 0,
	TVAUDIO_INVALID = -1
} QPTVAUDIO_TYPE, *PQPTVAUDIO_TYPE;


typedef struct _QPTVAUDIO_INITDATA
{
	QPTVAUDIO_TYPE	type;
} QPTVAUDIO_INITDATA, *PQPTVAUDIO_INITDATA;



/////////////////////////////////////////////////////////////////////////////
//
//

// property supported by this interface
//



/////////////////////////////////////////////////////////////////////////////
//
//

// codec cllback command code
//


/////////////////////////////////////////////////////////////////////////////
//
//

#ifndef __ITVAUDIO_FWD_DEFINED__
#define __ITVAUDIO_FWD_DEFINED__
typedef struct ITVAudio ITVAudio;
#endif //__ITVAUDIO_FWD_DEFINED__

    struct ITVAudio
    {
		// IGenericDevice
		DECLARE_IGENERICDEVICE(ITVAudio)

		// ITVAudio
		EQP_Errors (*SetMode)(ITVAudio *This, 
							  TQP_UINT32 ulMode
							  );
		EQP_Errors (*GetMode)(ITVAudio *This, 
							  PTQP_UINT32 pulMode
							  );
		EQP_Errors (*GetSupportedModes)(ITVAudio *This, 
										PTQP_UINT32 pulMode
										);
		EQP_Errors (*GetAvailableModes)(ITVAudio *This, 
										PTQP_UINT32 pulMode
										);
		EQP_Errors (*SelectInput)(ITVAudio *This, 
								  ETVAUDIO_INPUT eInput
								  );
		EQP_Errors (*GetInput)(ITVAudio *This, 
							   PETVAUDIO_INPUT pInput
							   );
		EQP_Errors (*MuteAudio)(ITVAudio *This);
		EQP_Errors (*UnmuteAudio)(ITVAudio *This);
    };


/////////////////////////////////////////////////////////////////////////////
//
//

#define QPTVAudio_SetMode(This, ulMode) \
    (This)->SetMode(This, ulMode)

#define QPTVAudio_GetMode(This, pulMode) \
    (This)->GetMode(This, pulMode)

#define QPTVAudio_GetSupportedModes(This, pulMode) \
    (This)->GetSupportedModes(This, pulMode)

#define QPTVAudio_GetAvailableModes(This, pulMode) \
    (This)->GetAvailableModes(This, pulMode)

#define QPTVAudio_SelectInput(This, eInput) \
    (This)->SelectInput(This, eInput)

#define QPTVAudio_GetInput(This, pInput) \
    (This)->GetInput(This, pInput)

#define QPTVAudio_MuteAudio(This) \
    (This)->MuteAudio(This)

#define QPTVAudio_UnmuteAudio(This) \
    (This)->UnmuteAudio(This)

#ifdef __cplusplus
}
#endif

#endif //__QPTVAUDIO_H__



