/* Copyright 1996 Sanyo Electric Co., Ltd, Osaka, Japan.
 */

/********************************************************************
* Sanyo Confidential                                            *
*                                                                   *
* Hypermedia Research Center                                        *
* Network System Dept.                                              *
* SANNET:8-652-3680 TEL:                                            *
*                                                                   *
*                                                                   *
*  Copyright(C) SANYO Electric Co., Ltd. 1996,1997,2000,2001        *
********************************************************************/

#define TA_HLNG 0x01
#define TA_TFIFO 0x00
#define TA_WSGL 0x00
#define TWF_ORW 0x02
#define TWF_CLR 0x01
#define TMO_FEVR (-1)

#define E_OK 0
#define E_ID (-35)
#define E_NOMEM (-10)
#define E_NOEXS (-52)
#define E_OBJ (-63)
#define E_TMOUT (-85)

#define TTS_RUN	0x01
#define TTS_RDY	0x02
#define TTS_WAI	0x04
#define TTS_SUS	0x08
#define TTS_WAS	0x0C
#define TTS_DMT	0x10

enum {
	TSK_DEFAULT = 1,
	TSK_QPX_TASKID_0,
	TSK_QPX_TASKID_1,
	TSK_QPX_TASKID_MAX
};

enum {
	SEM_SHELL = 1,
	SEM_QPX_SEMID_0,
	SEM_QPX_SEMID_1,
	SEM_QPX_SEMID_2,
	SEM_QPX_SEMID_3,
	SEM_QPX_SEMID_4,
	SEM_QPX_SEMID_5,
	SEM_QPX_SEMID_6,
	SEM_QPX_SEMID_7,
	SEM_QPX_SEMID_8,
	SEM_QPX_SEMID_9,
	SEM_QPX_SEMID_10,
	SEM_QPX_SEMID_11,
	SEM_QPX_SEMID_12,
	SEM_QPX_SEMID_13,
	SEM_QPX_SEMID_14,
	SEM_QPX_SEMID_15,
	SEM_QPX_SEMID_16,
	SEM_QPX_SEMID_17,
	SEM_QPX_SEMID_18,
	SEM_QPX_SEMID_19,
	SEM_QPX_SEMID_20,
	SEM_QPX_SEMID_21,
	SEM_QPX_SEMID_22,
	SEM_QPX_SEMID_23,
	SEM_QPX_SEMID_24,
	SEM_QPX_SEMID_25,
	SEM_QPX_SEMID_26,
	SEM_QPX_SEMID_27,
	SEM_QPX_SEMID_28,
	SEM_QPX_SEMID_29,
	SEM_QPX_SEMID_30,
	SEM_QPX_SEMID_31,
	SEM_QPX_SEMID_32,
	SEM_QPX_SEMID_33,
	SEM_QPX_SEMID_34,
	SEM_QPX_SEMID_35,
	SEM_QPX_SEMID_36,
	SEM_QPX_SEMID_37,
	SEM_QPX_SEMID_38,
	SEM_QPX_SEMID_39,
	SEM_QPX_SEMID_MAX
};

enum {
	EVF_COMMAND = 1,
	EVF_QPX_EVTGRPID_0,
	EVF_QPX_EVTGRPID_1,
	EVF_QPX_EVTGRPID_2,
	EVF_QPX_EVTGRPID_MAX
};

enum {
	MPL_SYSTEM = 1
};

#define TPR_NUM			16
#define TPR_MIN			TPR_NUM
#define TPR_CAMMAIN		(TPR_MIN-4)		// 12
#define	TPR_QPX_TASKID	(TPR_CAMMAIN-2)	// 10


/* integer */
typedef char            B;
typedef unsigned char   UB;
typedef short           H;
typedef unsigned short  UH;
typedef long            W;
typedef unsigned long   UW;
typedef volatile unsigned short VUH;

/* typeless */
typedef long            VW;
typedef short           VH;
typedef char            VB;
typedef void            *VP;
/*typedef void          (*FP)();*/

/* types for itron objects */
typedef int             INT;
typedef unsigned int    UINT;

#ifndef WIN32
typedef char            BOOL;       /* bool type */
#endif
typedef INT             FN;         /* function number */
typedef W               ID;         /* identifire */
typedef W               BOOL_ID;    /* boolean or identifire */
typedef W               HNO;        /* handler number */
typedef W               RNO;        /* rendezvous number*/
typedef W               NODE;       /* node number */
typedef UW              ATR;        /* attribute */
typedef H               ER;         /* error code */
typedef H               PRI;        /* priority  */
typedef B               T_MSG;      /* message packet */

/* types for Timer and Alarm functions */
typedef W                   DLYTIME;    /* delay time(ms) */
typedef W                   TMO;       /* time out(ms) */

struct create_task
{
    VP              exinf;      /* extended indormation */
    ATR             tskatr;     /* task attribute */
    void            (*task)(INT);/* task entry point */
    PRI             itskpri;    /* initial task priority */
    INT             stksz;      /* stack size */
    UW              stkaddr;        /* task's stack initial value */
};

typedef struct create_task      T_CTSK;

struct sem_create
{
    VP          exinf;              /* extended infomation */
    ATR         sematr;             /* semaphore attribute */
    INT         isemcnt;            /* initial semaphore count */
    INT         maxsem;             /* maximum semaphore count */
};

typedef struct sem_create       T_CSEM;

struct evf_create
{
    VP          exinf;              /* extended infomation */
    ATR         flgatr;             /* eventflag attribute */
    UINT        iflgptn;            /* initial eventflag pattern */
};

typedef struct evf_create       T_CFLG;

struct refer_eventflag
{
    VP          exinf;              /* extended infomation */
    BOOL_ID     wtsk;               /* wait task information */
    UINT        flgptn;             /* eventflag bit pattern */
};

typedef struct refer_eventflag  T_RFLG;

struct mailbox_create
{
    VP          exinf;              /* extended infomation */
    ATR         mbxatr;             /* mailbox attribute */
    INT         bufcnt;             /* length of ringbuffer */
    UW          bufaddr;            /* buffer address */
};

typedef struct mailbox_create       T_CMBX;

struct refer_mailbox
{
    VP          exinf;              /* extended infomation */
    BOOL_ID     wtsk;               /* wait task information */
    T_MSG       *pk_msg;            /* first address of message packet which should be received in next ; ɎM郁bZ[WpbPbg̐擪AhX */
};

typedef struct refer_mailbox  T_RMBX;

/* DLINK: Double Linked List */
struct dlink_item
{
    struct dlink_item           *next;  /* next reference */
    struct dlink_item           *prev;  /* prev reference */
};

typedef struct dlink_item       DLITEM;

/* DLHEADER: Header for Double Linked List */
struct dlink_header
{
    struct dlink_item           link;   /* link pointer */
};

typedef struct dlink_header     DLHEADER;

/* RBUFFER: Ring Buffer */
struct ring_buffer
{
    INT                         size;   /* buffer size(number) */
    INT                         in;     /* input index */
    INT                         out;    /* output index */
    VP                          *buf;   /* buffer pointer */
};

typedef struct ring_buffer      RBUFFER;

struct mailbox
{
    DLHEADER        tasks;              /* task list of receive queuing ; M҂^XÑXg */

    ID              mbxid;              /* Mail box ID */

    ATR             mbxatr;             /* mailbox attribute */
    VP              exinf;              /* extended information */

    RBUFFER         mbxbuf;             /* mail buffer */
};

typedef struct mailbox MBOX;

struct eventflag
{
    DLHEADER        tasks;          /* wait queue */

    UINT            flgptn;         /* eventflag pattern */
    UINT            iflgptn;        /* initial eventflag pattern */

    ATR             flgatr;         /* eventflag attribute */
    VP              exinf;          /* extended information */
};

typedef struct eventflag EVFLAG;


struct systime
{
    H                   millisec;   /* millisecond */
    UW                  sec;        /* second */
};

typedef struct systime  SYSTIME;    /* system time */
typedef struct systime  CYCTIME;    /* cycle time */
typedef struct systime  ALMTIME;    /* alarm time */

struct defalm
{
    VP          exinf;      /* expansion info */
    ATR         almatr;     /* alarm handler */
    void        (*almhdr)();/* alarm handler address */
    UINT        tmmode;     /* wake up time mode */
    ALMTIME     almtim;     /* handler wake up time */
};

typedef struct defalm   T_DALM;     /* alarm handler define info */

struct refalm
{
    VP                  exinf;      /* expansion info  */
    ALMTIME             lfttime;    /* leftover time */
};

typedef struct refalm   T_RALM;     /* alarm handler state info */

/* cre_mpl */
struct create_memorypool
{
    VP          exinf;
    ATR         mplatr;
    INT         mplsz;              /* memory pool size */
    VP          mplstart;           /* memory pool start address */
};
typedef struct create_memorypool    T_CMPL;
/* rel_mpl */
 typedef struct             /* variable length memory pool state */
 {
    VP      exinf;          /* expansion info  */
    BOOL_ID wtsk;           /* 1 if waitting task is (not use) */
    INT     frsz;           /* sum of free area */
    INT     maxsz;          /* max size of free area */
  } T_RMPL;

/* task.c */
struct refer_task
{
    VP              exinf;      /* extended information */
    PRI             tskpri;     /* task priority (current) */
    UINT            tskstat;    /* task state */

    UB              dstate;     /* dispatch & interrupt state */
    UB              wstate;     /* wait state */
    INT             wupcnt;     /* wakeup count */
    ATR             tskatr;     /* task attribute */
    void            (*task)(INT); /* task entry point */
    PRI             itskpri;    /* initial priority */
};

typedef struct refer_task   T_RTSK;

//TCB         *fnd_tsk(ID);
//void        schedule_task(void);
//ER          wai_tsk(DLHEADER *, UB, UW);
//ER          twai_tsk(DLHEADER *, UB, TMO, UW);
//void        sig_tcb(TCB *, UW);
//void        doj_tsk(DLHEADER *, UW);
//TCB         *get_tcb(void);
//TCB         *get_tcbs(void);
//void        tsk_init(void);

ER          cre_tsk(ID, T_CTSK *);
ER          del_tsk(ID);
ER          sus_tsk(ID);
ER          rsm_tsk(ID);
ER          slp_tsk(void);
ER          tslp_tsk(TMO);
ER          wup_tsk(ID tid);
ER          can_wup(INT *, ID);
ER          dly_tsk(DLYTIME);
ER          sta_tsk(ID tid, INT stacd);
void        ext_tsk(void);
void        exd_tsk(void);
ER          ter_tsk(ID tid);
ER          dis_dsp(void);
ER          ena_dsp(void);
ER          chg_pri(ID tid, PRI pri);
ER          rot_rdq(PRI pri);
ER          rel_wai(ID);
ER          get_tid(ID *ptid);
ER          ref_tsk(T_RTSK*, ID);

/* main.c */
//void        kernel_entry(void);
//void        default_task(INT);
//void        itron_bcopy(VP, VP, INT);
//void        itron_bzero (VP, INT);


/* target.c (in target specific directory) */
//void            target_init1(void);
//void            sys_mpl_init(void);
//void            target_init2(void);
//void            target_init3(void);
//void            target_init4(void);
//void        user_entry_point(void);
//void        default_task_loop(void);
//void        target_halt(unsigned long);


/* Semaphore */
ER          cre_sem(ID, T_CSEM *);
ER          del_sem(ID);
ER          wai_sem(ID);
ER          preq_sem(ID);
ER          twai_sem(ID, TMO);
ER          sig_sem(ID);
//ER          ref_sem(T_RSEM *, ID);
void        sem_init(void);

/* Event Flag */
EVFLAG      *fnd_flg(ID);
EVFLAG      *get_flgs(void);
ER          cre_flg(ID, T_CFLG *);
ER          del_flg(ID);
ER          set_flg(ID, UINT);
ER          clr_flg(ID, UINT);
ER          wai_flg(UINT *, ID, UINT, UINT);
ER          pol_flg(UINT *, ID, UINT, UINT);
ER          twai_flg(UINT *, ID, UINT, UINT, TMO);
ER          ref_flg(T_RFLG *, ID);
void        evflag_init(void);

/* Mail Box */
MBOX        *get_mbxs(void);
MBOX        *fnd_mbx(ID);
ER          cre_mbx(ID, T_CMBX*);
ER          del_mbx(ID);
ER          snd_msg(ID, T_MSG *);
ER          rcv_msg(T_MSG **, ID);
ER          prcv_msg(T_MSG **, ID);
ER          trcv_msg(T_MSG **, ID, TMO);
ER          ref_mbx(T_RMBX *, ID);
void        mbx_init(void);

/* Timer */
void        timer_entry(void);
void        timer_init(void);
ER          set_tim(SYSTIME *);
ER          get_tim(SYSTIME *);
ER          def_alm(HNO, T_DALM *);
ER          ref_alm(T_RALM *, HNO);
ER          can_alm(HNO);

/* queue.c */
//void        ini_lnk(LHEADER *);
//void        apd_lnk(LHEADER *, LITEM *);
//LITEM       *del_lnk(LHEADER *);
//LITEM       *frm_lnk(LHEADER *, LITEM *);

//void        ini_dlk(DLHEADER *);
//void        apd_dlk(DLHEADER *, DLITEM *);
//DLITEM      *del_dlk(DLHEADER *);
//void        inf_dlk(DLITEM *, DLITEM *);
//void        inb_dlk(DLITEM *, DLITEM *);
//void        ins_dlk(DLHEADER *, DLITEM *);
//DLITEM      *rmv_dlk(DLITEM *);

//void        ini_pol(POOLHEADER *, DLITEM *, INT, INT);
//DLITEM      *alc_pol(POOLHEADER *);
//DLITEM      *nxt_pol(POOLHEADER *, DLITEM *);
//void        fre_pol(POOLHEADER *, DLITEM *);

//void        ini_rbf(RBUFFER *, INT, VP*);
//INT         ins_rbf(RBUFFER *, VP);
//VP          rmv_rbf(RBUFFER *);

//void        ini_brb(BYRBUFFER *, INT, B*);
//INT         ins_brb(BYRBUFFER *, B);
//INT         rmv_brb(BYRBUFFER *, B*);

/* mpl.c */
ER          cre_mpl(ID, T_CMPL *);
ER          del_mpl(ID);
ER          ref_mpl(T_RMPL *, ID);
void        mpl_init(void);

ER          get_blk(VP *, ID, INT);
ER          pget_blk(VP *, ID, INT);
ER          tget_blk(VP *, ID, INT, TMO);
ER          rel_blk(ID, VP);

/* mpf.c */
//ER          cre_mpf(ID, T_CMPF *);
//ER          del_mpf(ID);
//ER          get_blf(VP *, ID);
//ER          pget_blf(VP *, ID);
//ER          tget_blf(VP *, ID, TMO);
//ER          rel_blf(ID, VP );
//ER          ref_mpf(T_RMPF *pk_rmpf, ID mpfid);
//void        mpf_init(void);

/* intr.c */
//void        intr_init(void);
//ER          def_int(UINT, T_DINT *);
//ER          loc_cpu(void);
//ER          unl_cpu(void);
//ER          dis_int(void);
//ER          ena_int(void);

/* cyclic */
//void        cyclic_init(void);
//void        cyclic_entry(void);
//ER          can_cyc(HNO);
//ER          def_cyc(HNO, T_DCYC *);
//ER          act_cyc(HNO, UINT);
//ER          ref_cyc(T_RCYC *, HNO);

/* mbuffer.c */
//ER          cre_mbf(ID, T_CMBF *);
//ER          del_mbf(ID);
//ER          ref_mbf(T_RMBF *, ID);
//ER          snd_mbf(ID, VP, INT);
//ER          psnd_mbf(ID, VP, INT);
//ER          tsnd_mbf(ID, VP, INT, TMO);
//ER          rcv_mbf(VP, INT *, ID);
//ER          prcv_mbf(VP, INT *, ID);
//ER          trcv_mbf(VP, INT *, ID, TMO);
//void        mbf_init(void);

