///////////////////////////////////////////////////////////////////////////////
//
//    
//
//	usblib.h
//
// Modification History:
//	Aug 20, 09	Created for common memory space comm.
//
// Authors:
//	(BP)	Brian Pin
//
///////////////////////////////////////////////////////////////////////////////
#ifndef __USBLIB_H__
#define __USBLIB_H__
#include "qpsos.h"
#include "qpmemmgr.h"
#include "qppfmgr.h"

#pragma pack(push, 4)

struct usb_system_configs {
	unsigned	i2cType;	/* FLAT_USBAREA + 0 */
	unsigned	useMode;	/* FLAT_USBAREA + 4 */
	unsigned	connectCmd;	/* FLAT_USBAREA + 8 */
	unsigned	keep_host_config;	/* 1: keep, 0: not keep */
	unsigned	useMode_in_flash;	/* FLAT_USBAREA + h10 */
	unsigned	saved_config;	/* FLAT_USBAREA + h14 */
};

#pragma pack(pop)

unsigned		usbpf_use_gpioi2c(void);
EUsblibGadgetModes	usbpf_use_mode(void);
void 			usbpf_set_use_mode(EUsblibGadgetModes mode);
unsigned		usbpf_keep_connect_query(void);
void			usbpf_set_soft_disconnect(EUsbSoftConnectCmdTypes cmd);

#define NOT_KEEP	0
#define KEEP		1
unsigned		usbpf_keep_host_config_query(void);
void			usbpf_set_keep_host_config(unsigned keep);


/* Report automatic value changes to host using UVC status pipe
 * return: 
 *	 0: data queued on UVC
 *	!0: data not queued on UVC, no harm, can ignore or wait some time to do
 *	    it again.
 */
int uvc_report_exposure_time(TQP_INT32 value);
int uvc_report_white_balance(TQP_UINT16 value);
int uvc_report_focus(TQP_UINT16 value);
int uvc_report_automated_ctrl_info(char selector, char entity, char value);
#endif /* __USBLIB_H__ */

