///////////////////////////////////////////////////////////////////////////////
//        
//
//		Internal Memory Manager interface
//
// Use compile time constants to select an OS:
//	Windows: _QP_WINDOWS
//	Windows Kernel: _QP_WINKER
//	ITRON: _QP_ITRON
//	NuCore: _QP_NUCORE
//
// History:
//	Sep 6, 2006	(EC) Created
//
// Authors: (EC) Enrico Cadorin
//
///////////////////////////////////////////////////////////////////////////////



#ifndef __QPOSMEMGRINT_H__
#define __QPOSMEMGRINT_H__

#ifdef QP_LINXKER
#include "../common/qptypes.h"
#include "../common/qpmemmgr.h"
#else
#include "qptypes.h"
#include "qpmemmgr.h"
#endif

extern void MMGetCaps (PTQP_MMCaps);
extern TQP_MMID MMInit (void * ptr, unsigned long bytes);
extern void MMTerm (TQP_MMID);
extern void * MMMalloc (TQP_MMID mmID, unsigned long bytes);
extern void MMFree (TQP_MMID mmID, void * ptr);
extern void * MMMalloc2 (PTQP_UINT32 memTypeP, unsigned long bytes);
extern void MMFree2 (void * memP);
extern EQP_Errors MemMInit(void);
extern EQP_Errors MemMTerm(void);
extern EQP_Errors 
MMStartM2MRequest(
	PTQP_MMM2MReqParms reqParmsP, 
	TQP_MMM2MReqCompl complProc, 
	void * refCon, 
	TQP_MMM2MReqID * reqIDP);

#endif //__QPOSMEMGRINT_H__
