///////////////////////////////////////////////////////////////////////////////
//        
//
//		Internal Time Manager interface
//
// Use compile time constants to select an OS:
//	Windows: _QP_WINDOWS
//	ITRON: _QP_ITRON
//	NuCore: _QP_NUCORE
//	QPSOS: _QP_SOS
//
// History:
//	Aug 23, 2007	(EC) Created
//
// Authors: (EC) Enrico Cadorin
//
///////////////////////////////////////////////////////////////////////////////



#ifndef __QPTIMEMGRINT_H__
#define __QPTIMEMGRINT_H__

#ifdef QP_LINXKER
#include "../common/qptypes.h"
#include "../common/qptimemgr.h"
#else
#include "qptypes.h"
#include "qptimemgr.h"
#endif

#if defined(_QP_WINDOWS)
#include <windows.h>
#elif defined(_QP_WINKER)
#include <wdm.h>
#elif defined(_QP_ITRON)
#elif defined(_QP_LINUX) || defined(_QP_MACOSX)
#include <pthread.h>
#endif


extern EQP_Errors TimeInit (void);
extern void TimeTerm (void);
extern void TimeGetCaps (PTQP_TMCaps);
extern TQPTM_Time TimeGetSysTimeMilliS (void);
extern TQPTM_Time TimeGetSysTimeMicroS (void);
extern TQPTM_Time TimeGetSysTimeNanoS (void);
extern TQPTM_Time TimeGetSysTicks (void);
extern EQP_Errors TimeDelayMilliS (TQP_UINT32 milliS);
extern EQP_Errors TimeDelayMicroS (TQP_UINT32 microS);


#endif //__QPTIMEMGRINT_H__
