///////////////////////////////////////////////////////////////////////////////
//        
//
// Cadi7393.h
//
// Description: 
//
//  ADI7393 implementation
// 
// History:
//	June 18, 2008 created
//
// Authors: Andy Yu
//
///////////////////////////////////////////////////////////////////////////////


#ifndef __CADI7393_H__
#define __CADI7393_H__

#include "cvidencoder.h"
#include "qpi2c.h"

#ifdef __cplusplus
extern "C" {
#endif


/////////////////////////////////////////////////////////////////////////////
//
//

// default ADI7393 I2C address
//
#define ADI7393_DEVICE_ADDR		(0x2A)


/////////////////////////////////////////////////////////////////////////////
//
//

typedef struct CADI7393
{
	// public CVideoEncoder
	//
	CVideoEncoder	m_VideoEncoder;

	// CSaa7128
	//
	II2C			*m_pI2C;				// I2C interface
	TQP_UINT8		m_cI2CDevAddr;			// i2c device address

} CADI7393;


CADI7393 * CADI7393_Constructor(CADI7393 *pADI7393, 
								CObject *pParent,
								TQP_UINT32 dwAttributes,
								II2C *pI2C,
								TQP_UINT8 cI2CDevAddr
								);
void CADI7393_Destructor(CADI7393 *This);

#ifdef __cplusplus
}
#endif

#endif //__CADI7393_H__

