///////////////////////////////////////////////////////////////////////////////
//        
//
// Cadi7401.h
//
// Description: 
//
//  ADI7401 implementation
// 
// History:
//	June 18, 2008 created
//
// Authors: Andy Yu
//
///////////////////////////////////////////////////////////////////////////////


#ifndef __CADI7401_H__
#define __CADI7401_H__

#include "cviddecoder.h"
#include "qpi2c.h"

#ifdef __cplusplus
extern "C" {
#endif


/////////////////////////////////////////////////////////////////////////////
//
//

// default ADI7401 I2C address
//
#define ADI7401_DEVICE_ADDR		0x20


/////////////////////////////////////////////////////////////////////////////
//
//

typedef struct CADI7401 
{
	// public CVideoDecoder
	//
	CVideoDecoder		m_VideoDecoder;

	// CADI7401
	II2C				*m_pI2C;				// I2C interface
	TQP_UINT8			m_cI2CDevAddr;			// i2c device address

} CADI7401;


CADI7401 * CADI7401_Constructor(CADI7401 *pADI7401, 
							  CObject *pParent,
							  TQP_UINT32 dwAttributes,
							  ITuner *pTuner,
							  ITVAudio *pTvAudio,
							  II2C *pI2C,
							  TQP_UINT8 cI2CDevAddr
							  );
void CADI7401_Destructor(CADI7401 *This);

#ifdef __cplusplus
}
#endif

#endif //__CADI7401_H__


