///////////////////////////////////////////////////////////////////////////////
//        
//
// cadi7441.c
//
// Description: 
//
//  adi7441A implementation
// 
// History:
//	February 12, 2010 created
//
// Authors: Frank Wei
//
///////////////////////////////////////////////////////////////////////////////


#ifndef __CADI7441_H__
#define __CADI7441_H__

#include "cviddecoder.h"
#include "qpi2c.h"

#ifdef __cplusplus
extern "C" {
#endif


/////////////////////////////////////////////////////////////////////////////
//
//

// default ADI7441 I2C address
//
#define ADI7441_DEVICE_ADDR		0x21	//USER
#define ADI7441_DEVICE_ADDR_1		0x23
#define ADI7441_DEVICE_ADDR_2		0x31
#define ADI7441_DEVICE_ADDR_3		0x25
#define ADI7441_DEVICE_ADDR_4		0x35	//HDMI
#define ADI7441_DEVICE_ADDR_5		0x33	//KSV
#define ADI7441_DEVICE_ADDR_6		0x37	//EDID

#define EDID_MAP_DEVICE_ADDR		0x50

/////////////////////////////////////////////////////////////////////////////
//
//

typedef struct CADI7441 
{
	// public CVideoDecoder
	//
	CVideoDecoder		m_VideoDecoder;

	// CADI7441
	II2C				*m_pI2C;				// I2C interface
	TQP_UINT8			m_cI2CDevAddr;			// i2c device address

} CADI7441;


CADI7441 * CADI7441_Constructor(CADI7441 *pADI7441, 
							  CObject *pParent,
							  TQP_UINT32 dwAttributes,
							  ITuner *pTuner,
							  ITVAudio *pTvAudio,
							  II2C *pI2C,
							  TQP_UINT8 cI2CDevAddr,
							  VIDEO_SOURCE source
							  );
void CADI7441_Destructor(CADI7441 *This);

#ifdef __cplusplus
}
#endif

#endif //__CADI7441_H__


