///////////////////////////////////////////////////////////////////////////////
//        
//
// Cadi9889.c
//
// Description: 
//
//  ad9889B implementation
// 
// History:
//	February 12, 2010 created
//
// Authors: Frank Wei
//
///////////////////////////////////////////////////////////////////////////////


#ifndef __CADI9889_H__
#define __CADI9889_H__

#include "cvidencoder.h"
#include "qpi2c.h"

#ifdef __cplusplus
extern "C" {
#endif


/////////////////////////////////////////////////////////////////////////////
//
//

// default ADI9889 I2C address
//
#define ADI9889_DEVICE_ADDR		(0x3D)	//0x39


/////////////////////////////////////////////////////////////////////////////
//
//

typedef struct CADI9889
{
	// public CVideoEncoder
	//
	CVideoEncoder	m_VideoEncoder;

	// CSaa7128
	//
	II2C			*m_pI2C;				// I2C interface
	TQP_UINT8		m_cI2CDevAddr;			// i2c device address

} CADI9889;


CADI9889 * CADI9889_Constructor(CADI9889 *pADI9889, 
								CObject *pParent,
								TQP_UINT32 dwAttributes,
								II2C *pI2C,
								TQP_UINT8 cI2CDevAddr
								);
void CADI9889_Destructor(CADI9889 *This);

#ifdef __cplusplus
}
#endif

#endif //__CADI9889_H__

