///////////////////////////////////////////////////////////////////////////////
//        
//
// cadv7614.h
//
// Description: 
//   ADV7614 implementation
// 
// History:
//	 Sep 2, 2009 created
//
// Authors: Jack Lee
//
///////////////////////////////////////////////////////////////////////////////


#ifndef __CADV7614_H__
#define __CADV7614_H__

#include "cviddecoder.h"
#include "qpi2c.h"

#ifdef __cplusplus
extern "C" {
#endif


/////////////////////////////////////////////////////////////////////////////
//
//

// default ADV7614 I2C address
//
#define ADV7614_DEVICE_ADDR_IO			0x20
#define ADV7614_DEVICE_ADDR_CP			0x22
#define ADV7614_DEVICE_ADDR_AFE_DPLL	0x26
#define ADV7614_DEVICE_ADDR_HDMI		0x34


/////////////////////////////////////////////////////////////////////////////
//
//

typedef struct CADV7614 
{
	// public CVideoDecoder
	//
	CVideoDecoder	m_VideoDecoder;

	// CADV7614
	II2C			*m_pI2C;				// I2C interface
	TQP_UINT8		m_cI2CDevAddr;			// i2c device address

} CADV7614;


CADV7614 * CADV7614_Constructor(CADV7614 *pADV7614, 
							    CObject *pParent,
							    TQP_UINT32 dwAttributes,
							    ITuner *pTuner,
							    ITVAudio *pTvAudio,
							    II2C *pI2C,
							    TQP_UINT8 cI2CDevAddr
							    );
void CADV7614_Destructor(CADV7614 *This);

#ifdef __cplusplus
}
#endif

#endif //__CADV7614_H__


