///////////////////////////////////////////////////////////////////////////////
//        
//
// Caudcodec.h
//
// Description: 
//
//  Audio codec implementation
// 
// History:
//	Aug 28, 2006	(dt) created
//
// Authors: (dt) David Tao
//
///////////////////////////////////////////////////////////////////////////////

#ifndef __CAUDCODEC_H__
#define __CAUDCODEC_H__

#include "cobject.h"
#include "qpaudcodec.h"
#include "qptuner.h"
#include "qptvaudio.h"

#ifdef __cplusplus
extern "C" {
#endif


typedef struct CAudioCodec
{
	// public CObject
	//
	CObject				m_Object;

	// public IAudioCodec
	//
	IAudioCodec			m_iAudCodec;

	// CAudioCodec
	//
	ITuner				*m_pTuner;
	ITVAudio			*m_pTvAudio;
	QP_DEVICE_CALLBACK	m_pDeviceCallback;	// codec client call back function
	TQP_PVOID			m_callbackContext;	// codec client call back function context

	AIN_SOURCE			m_audioSource;

	int					m_nVolumeDef;
	int					m_nVolumeMin;
	int					m_nVolumeMax;

	int					m_nVolumeL;
	int					m_nVolumeR;
	TQP_BOOL			m_bMuteL;
	TQP_BOOL			m_bMuteR;

} CAudioCodec;



// constructor
//
CAudioCodec * CAudioCodec_Constructor(CAudioCodec *pAudCodec,
									  CObject *pParent,
									  TQP_UINT32 dwAttributes,
									  ITuner *pTuner,
									  ITVAudio *pTvAudio
									  );

// destructor
//
void CAudioCodec_Destructor(CAudioCodec *This);

#ifdef __cplusplus
}
#endif

#endif //__CAUDCODEC_H__




