///////////////////////////////////////////////////////////////////////////////
//        
//
// cadi7441.c
//
// Description: 
//
//  FM31 implementation
// 
// History:
//	Nov 20, 2011 created
//
// Authors: CY Liu
//
///////////////////////////////////////////////////////////////////////////////


#ifndef __CFM31_H__
#define __CFM31_H__

#include "caudcodec.h"
#include "qpi2c.h"

#ifdef __cplusplus
extern "C" {
#endif


/////////////////////////////////////////////////////////////////////////////
//
//

// default FM31 I2C address
//
#define FM31_DEVICE_ADDR		0x60

/////////////////////////////////////////////////////////////////////////////
//
//

typedef struct CFM31 
{
	// public CAudioCodec
	//
	CAudioCodec		m_AudioCodec;

	// CFM31
	II2C				*m_pI2C;				// I2C interface
	TQP_UINT8			m_cI2CDevAddr;			// i2c device address

} CFM31;


CFM31 * CFM31_Constructor(CFM31 *pFM31, 
							  CObject *pParent,
							  TQP_UINT32 dwAttributes,
							  ITuner *pTuner,
							  ITVAudio *pTvAudio,
							  II2C *pI2C,
							  TQP_UINT8 cI2CDevAddr
							  );
void CFM31_Destructor(CFM31 *This);

#ifdef __cplusplus
}
#endif

#endif //__CFM31_H__


