///////////////////////////////////////////////////////////////////////////////
//        
//
// cit6603.h
//
// Description: 
//
//  cit6603 implementation
// 
// History:
//	Aug 13, 2010 created
//
// Authors: Frank Wei
//
///////////////////////////////////////////////////////////////////////////////


#ifndef __CIT6603_H__
#define __CIT6603_H__

#include "cviddecoder.h"
#include "qpi2c.h"

#ifdef __cplusplus
extern "C" {
#endif


/////////////////////////////////////////////////////////////////////////////
//
//

// default IT6603 I2C address
//
#define IT6603_DEVICE_ADDR		0x48

#define EDID_MAP_DEVICE_ADDR		0x50

/////////////////////////////////////////////////////////////////////////////
//
//

typedef struct CIT6603 
{
	// public CVideoDecoder
	//
	CVideoDecoder		m_VideoDecoder;

	// CIT6603
	II2C				*m_pI2C;				// I2C interface
	TQP_UINT8			m_cI2CDevAddr;			// i2c device address

} CIT6603;


CIT6603 * CIT6603_Constructor(CIT6603 *pIT6603, 
							  CObject *pParent,
							  TQP_UINT32 dwAttributes,
							  ITuner *pTuner,
							  ITVAudio *pTvAudio,
							  II2C *pI2C,
							  TQP_UINT8 cI2CDevAddr
							  );
void CIT6603_Destructor(CIT6603 *This);

#ifdef __cplusplus
}
#endif

#endif //__CIT6603_H__


