///////////////////////////////////////////////////////////////////////////////
//        
//
// Cmi2010.h
//
// Description: 
//
//  Micron MI2010(MT9D111) implementation
// 
// History:
//	July 17, 2009	(dt) created
//
// Authors: (dt) David Tao
//
///////////////////////////////////////////////////////////////////////////////


#ifndef __CMI2010_H__
#define __CMI2010_H__

#include "cviddecoder.h"
#include "qpi2c.h"

#ifdef __cplusplus
extern "C" {
#endif


/////////////////////////////////////////////////////////////////////////////
//
//

// default MI2010 I2C address
//
#define MI2010_DEVICE_ADDR		(0xBA >> 1)


/////////////////////////////////////////////////////////////////////////////
//
//

typedef struct CMi2010 
{
	// public CVideoDecoder
	//
	CVideoDecoder		m_VideoDecoder;

	// CMi2010
	II2C				*m_pI2C;				// I2C interface
	TQP_UINT8			m_cI2CDevAddr;			// i2c device address

} CMi2010;


CMi2010 * CMi2010_Constructor(CMi2010 *pMi2010, 
							  CObject *pParent,
							  TQP_UINT32 dwAttributes,
							  ITuner *pTuner,
							  ITVAudio *pTvAudio,
							  II2C *pI2C,
							  TQP_UINT8 cI2CDevAddr
							  );
void CMi2010_Destructor(CMi2010 *This);

#ifdef __cplusplus
}
#endif

#endif //__CMI2010_H__



