///////////////////////////////////////////////////////////////////////////////
//        
//
// Cmt9v112.h
//
// Description: 
//
//  Micron MT9V112 implementation
// 
// History:
//	May 11, 2007	(dt) created
//
// Authors: (dt) David Tao
//
///////////////////////////////////////////////////////////////////////////////


#ifndef __CMT9V112_H__
#define __CMT9V112_H__

#include "cviddecoder.h"
#include "qpi2c.h"

#ifdef __cplusplus
extern "C" {
#endif


/////////////////////////////////////////////////////////////////////////////
//
//

// default MT9V112 I2C address
//
#define MT9V112_DEVICE_ADDR		(0xBA >> 1)


/////////////////////////////////////////////////////////////////////////////
//
//

typedef struct CMt9V112 
{
	// public CVideoDecoder
	//
	CVideoDecoder		m_VideoDecoder;

	// CMt9V112
	II2C				*m_pI2C;				// I2C interface
	TQP_UINT8			m_cI2CDevAddr;			// i2c device address

} CMt9V112;


CMt9V112 * CMt9V112_Constructor(CMt9V112 *pMt9V112, 
								CObject *pParent,
								TQP_UINT32 dwAttributes,
								ITuner *pTuner,
								ITVAudio *pTvAudio,
								II2C *pI2C,
								TQP_UINT8 cI2CDevAddr
								);
void CMt9V112_Destructor(CMt9V112 *This);

#ifdef __cplusplus
}
#endif

#endif //__CMT9V112_H__


