///////////////////////////////////////////////////////////////////////////////
//         
//
// cov10633.h
//
// Description: 
//
//  ov10633 declaration
// 
// History:
//	September 17, 2012 created
//
// Authors: 
//
///////////////////////////////////////////////////////////////////////////////


#ifndef __COV10633_H__
#define __COV10633_H__

#include "cviddecoder.h"
#include "qpi2c.h"
#include "cthread.h"

#ifdef __cplusplus
extern "C" {
#endif


/////////////////////////////////////////////////////////////////////////////
//
//

#define OV10633_DEVICE_ADDR		0x30


/////////////////////////////////////////////////////////////////////////////
//
//
typedef struct _COV10633 
{
	// public CVideoDecoder
	//
	CVideoDecoder			m_VideoDecoder;

	// COV10633
	II2C						*m_pI2C;				// I2C interface
	TQP_UINT8				m_cI2CDevAddr;			// i2c device address
} COV10633;


COV10633 * COV10633_Constructor(COV10633 *pOV10633, 
							  CObject *pParent,
							  TQP_UINT32 dwAttributes,
							  ITuner *pTuner,
							  ITVAudio *pTvAudio,
							  II2C *pI2C,
							  TQP_UINT8 cI2CDevAddr
							  );
void COV10633_Destructor(COV10633 *This);

#ifdef __cplusplus
}
#endif

#endif //__CADI7441_H__


