///////////////////////////////////////////////////////////////////////////////
//        
//
// Cov7720.h
//
// Description: 
//
//  Micron OV7720 implementation
// 
// History:
//	April 28, 2008	(dt) created
//	May   07, 2008	(ywc) change device address of OV7720
//
// Authors: (dt) David Tao
//
///////////////////////////////////////////////////////////////////////////////


#ifndef __COV7720_H__
#define __COV7720_H__

#include "cviddecoder.h"
#include "qpi2c.h"

#ifdef __cplusplus
extern "C" {
#endif


/////////////////////////////////////////////////////////////////////////////
//
//

// default OV7720 I2C address
//
#define OV7720_DEVICE_ADDR		0x21 //0x20 ywc modify in 20080507


/////////////////////////////////////////////////////////////////////////////
//
//

typedef struct COV7720 
{
	// public CVideoDecoder
	//
	CVideoDecoder		m_VideoDecoder;

	// COV7720
	II2C				*m_pI2C;				// I2C interface
	TQP_UINT8			m_cI2CDevAddr;			// i2c device address

} COV7720;


COV7720 * COV7720_Constructor(COV7720 *pOV7720, 
							  CObject *pParent,
							  TQP_UINT32 dwAttributes,
							  ITuner *pTuner,
							  ITVAudio *pTvAudio,
							  II2C *pI2C,
							  TQP_UINT8 cI2CDevAddr
							  );
void COV7720_Destructor(COV7720 *This);

#ifdef __cplusplus
}
#endif

#endif //__COV7720_H__


