///////////////////////////////////////////////////////////////////////////////
//        
//
// Csaa7115.h
//
// Description: 
//
//  SAA 7115 implementation
// 
// History:
//	Sep 5, 2006	(dt) created
//
// Authors: (dt) David Tao
//
///////////////////////////////////////////////////////////////////////////////


#ifndef __CSAA7115_H__
#define __CSAA7115_H__

#include "saa7115regs.h"
#include "cviddecoder.h"
#include "qpi2c.h"

#ifdef __cplusplus
extern "C" {
#endif


/////////////////////////////////////////////////////////////////////////////
//
//

// default 7115 I2C address
//
#define SAA7115_DEVICE_ADDR		(0x42 >> 1)


/////////////////////////////////////////////////////////////////////////////
//
//

typedef struct CSaa7115 
{
	// public CVideoDecoder
	//
	CVideoDecoder		m_VideoDecoder;

	// CSaa7115
	II2C				*m_pI2C;				// I2C interface
	TQP_UINT8			m_cI2CDevAddr;			// i2c device address

	SAA7115_INPUT_MODE	m_SVideoMode;
	SAA7115_INPUT_MODE	m_CVideoMode;
	SAA7115_INPUT_MODE	m_TVVideoMode;
	SAA7115_INPUT_MODE	m_InvalidVideoMode;

} CSaa7115;


CSaa7115 * CSaa7115_Constructor(CSaa7115 *pSaa7115, 
								CObject *pParent,
								TQP_UINT32 dwAttributes,
								ITuner *pTuner,
								ITVAudio *pTvAudio,
								II2C *pI2C,
								TQP_UINT8 cI2CDevAddr
								);
void CSaa7115_Destructor(CSaa7115 *This);

#ifdef __cplusplus
}
#endif

#endif //__CSAA7115_H__


