///////////////////////////////////////////////////////////////////////////////
//        
//
// Csaa7128.h
//
// Description: 
//
//  SAA 7115 implementation
// 
// History:
//	Sep 5, 2006	(dt) created
//
// Authors: (dt) David Tao
//
///////////////////////////////////////////////////////////////////////////////


#ifndef __CSAA7128_H__
#define __CSAA7128_H__

#include "cvidencoder.h"
#include "qpi2c.h"

#ifdef __cplusplus
extern "C" {
#endif


/////////////////////////////////////////////////////////////////////////////
//
//

// default 7128 I2C address
//
#define SAA7128_DEVICE_ADDR		(0x88 >> 1)


/////////////////////////////////////////////////////////////////////////////
//
//

typedef struct CSaa7128
{
	// public CVideoEncoder
	//
	CVideoEncoder	m_VideoEncoder;

	// CSaa7128
	//
	II2C			*m_pI2C;				// I2C interface
	TQP_UINT8		m_cI2CDevAddr;			// i2c device address

} CSaa7128;


CSaa7128 * CSaa7128_Constructor(CSaa7128 *pSaa7128, 
								CObject *pParent,
								TQP_UINT32 dwAttributes,
								II2C *pI2C,
								TQP_UINT8 cI2CDevAddr
								);
void CSaa7128_Destructor(CSaa7128 *This);

#ifdef __cplusplus
}
#endif

#endif //__CSAA7128_H__

