///////////////////////////////////////////////////////////////////////////////
//        
//
// Csil9011.h
//
// Description: 
//
//  SIL9011 implementation
// 
// History:
//	May 12, 2008 created
//
// Authors: Andy Yu
//
///////////////////////////////////////////////////////////////////////////////


#ifndef __CSIL9011_H__
#define __CSIL9011_H__

#include "cviddecoder.h"
#include "qpi2c.h"

#ifdef __cplusplus
extern "C" {
#endif


/////////////////////////////////////////////////////////////////////////////
//
//

// default SIL9011 I2C address
//
#define SIL9011_DEVICE_ADDR		0x30
#define SIL9011_DEVICE_ADDR_2		0x34


/////////////////////////////////////////////////////////////////////////////
//
//

typedef struct CSIL9011 
{
	// public CVideoDecoder
	//
	CVideoDecoder		m_VideoDecoder;

	// CSIL9011
	II2C				*m_pI2C;				// I2C interface
	TQP_UINT8			m_cI2CDevAddr;			// i2c device address

} CSIL9011;


CSIL9011 * CSIL9011_Constructor(CSIL9011 *pSIL9011, 
							  CObject *pParent,
							  TQP_UINT32 dwAttributes,
							  ITuner *pTuner,
							  ITVAudio *pTvAudio,
							  II2C *pI2C,
							  TQP_UINT8 cI2CDevAddr
							  );
void CSIL9011_Destructor(CSIL9011 *This);

#ifdef __cplusplus
}
#endif

#endif //__CSIL9011_H__


