///////////////////////////////////////////////////////////////////////////////
//        
//
// Csil9025.h
//
// Description: 
//
//  SIL9025 implementation
// 
// History:
//	May 12, 2008 created
//
// Authors: Andy Yu
//
///////////////////////////////////////////////////////////////////////////////


#ifndef __CSIL9025_H__
#define __CSIL9025_H__

#include "cviddecoder.h"
#include "qpi2c.h"

#ifdef __cplusplus
extern "C" {
#endif


/////////////////////////////////////////////////////////////////////////////
//
//

// default SIL9025 I2C address
//
#define SIL9025_DEVICE_ADDR		0x30
#define SIL9025_DEVICE_ADDR_2		0x34


/////////////////////////////////////////////////////////////////////////////
//
//

typedef struct CSIL9025 
{
	// public CVideoDecoder
	//
	CVideoDecoder		m_VideoDecoder;

	// CSIL9025
	II2C				*m_pI2C;				// I2C interface
	TQP_UINT8			m_cI2CDevAddr;			// i2c device address

} CSIL9025;


CSIL9025 * CSIL9025_Constructor(CSIL9025 *pSIL9025, 
							  CObject *pParent,
							  TQP_UINT32 dwAttributes,
							  ITuner *pTuner,
							  ITVAudio *pTvAudio,
							  II2C *pI2C,
							  TQP_UINT8 cI2CDevAddr
							  );
void CSIL9025_Destructor(CSIL9025 *This);

#ifdef __cplusplus
}
#endif

#endif //__CSIL9025_H__


