///////////////////////////////////////////////////////////////////////////////
//        
//
// Csil9030.h
//
// Description: 
//
//  SIL9030 implementation
// 
// History:
//	May 12, 2008 created
//
// Authors: Andy Yu
//
///////////////////////////////////////////////////////////////////////////////


#ifndef __CSIL9030_H__
#define __CSIL9030_H__

#include "cvidencoder.h"
#include "qpi2c.h"

#ifdef __cplusplus
extern "C" {
#endif


/////////////////////////////////////////////////////////////////////////////
//
//

// default SIL9030 I2C address
//
#define SIL9030_DEVICE_ADDR		(0x3B) // change from (0x39) due to PE1005's address is the same (0x39)


/////////////////////////////////////////////////////////////////////////////
//
//

typedef struct CSIL9030
{
	// public CVideoEncoder
	//
	CVideoEncoder	m_VideoEncoder;

	// CSaa7128
	//
	II2C			*m_pI2C;				// I2C interface
	TQP_UINT8		m_cI2CDevAddr;			// i2c device address

} CSIL9030;


CSIL9030 * CSIL9030_Constructor(CSIL9030 *pSIL9030, 
								CObject *pParent,
								TQP_UINT32 dwAttributes,
								II2C *pI2C,
								TQP_UINT8 cI2CDevAddr
								);
void CSIL9030_Destructor(CSIL9030 *This);

#ifdef __cplusplus
}
#endif

#endif //__CSIL9030_H__

