///////////////////////////////////////////////////////////////////////////////
//        
//
// Csil9034.h
//
// Description: 
//
//  SIL9034 implementation
// 
// History:
//	May 12, 2008 created
//
// Authors: Andy Yu
//
///////////////////////////////////////////////////////////////////////////////


#ifndef __CSIL9034_H__
#define __CSIL9034_H__

#include "cvidencoder.h"
#include "qpi2c.h"

#ifdef __cplusplus
extern "C" {
#endif


/////////////////////////////////////////////////////////////////////////////
//
//

// default SIL9034 I2C address
//
#define SIL9034_DEVICE_ADDR		(0x3B) // change from (0x39) due to PE1005's address is the same (0x39)


/////////////////////////////////////////////////////////////////////////////
//
//

typedef struct CSIL9034
{
	// public CVideoEncoder
	//
	CVideoEncoder	m_VideoEncoder;

	// CSaa7128
	//
	II2C			*m_pI2C;				// I2C interface
	TQP_UINT8		m_cI2CDevAddr;			// i2c device address

} CSIL9034;


CSIL9034 * CSIL9034_Constructor(CSIL9034 *pSIL9034, 
								CObject *pParent,
								TQP_UINT32 dwAttributes,
								II2C *pI2C,
								TQP_UINT8 cI2CDevAddr
								);
void CSIL9034_Destructor(CSIL9034 *This);

#ifdef __cplusplus
}
#endif

#endif //__CSIL9034_H__

