///////////////////////////////////////////////////////////////////////////////
//        
//
// Ctuner.h
//
// Description: 
//
//  Tuner implementation
// 
// History:
//	Sep 5, 2006	(dt) created
//
// Authors: (dt) David Tao
//
///////////////////////////////////////////////////////////////////////////////


#ifndef __CTUNER_H__
#define __CTUNER_H__


#include "cobject.h"
#include "qptuner.h"


#ifdef __cplusplus
extern "C" {
#endif


// Sound Carrier Frquencies
//
#define TUNER_SIF_4_5_MHZ				0	// 4.5 MHz
#define TUNER_SIF_5_5_MHZ				1	// 5.5 MHz
#define TUNER_SIF_6_0_MHZ				2	// 6.0 MHz
#define TUNER_SIF_6_5_MHZ				3	// 6.5 MHz



typedef struct CTuner
{
	// public CObject
	//
	CObject				m_Object;

	// public ITuner
	//
	ITuner				m_iTuner;

	// CTuner
	//
	QP_DEVICE_CALLBACK	m_pDeviceCallback;							// codec client call back function
	TQP_PVOID			m_callbackContext;							// codec client call back function context

	TQP_UINT32			m_ulCurrentFrequency;
	TQP_UINT32			m_ulNumberOfStandards;
	TQP_UINT32			m_ulStandardsSupported;
	TQP_UINT32			m_ulCurrentStandard;
	TQP_UINT32			m_ulNumberOfInputs;
	TQP_UINT32			m_ulMinFrequency;
	TQP_UINT32			m_ulMaxFrequency;
	TQP_UINT32			m_ulIntermediateFrequency;
	TQP_UINT32			m_ulIntermediateFrequencyJapen;
	TQP_UINT32			m_ulSupportedModes;
	TQP_UINT32			m_ulTunerMode;
	TQP_UINT32			m_ulTuningGranularity;
	TQP_UINT32			m_ulSettlingTime;
	TQP_UINT32			m_ulStrategy;
	TQP_UINT32			m_ulTunerInput;


	TQP_UINT32			m_ulFMCurrentFrequency;
	TQP_UINT32			m_ulFMStandardsSupported;
	TQP_UINT32			m_ulFMMinFrequency;
	TQP_UINT32			m_ulFMMaxFrequency;
	TQP_UINT32			m_ulFMIntermediateFrequency;
	TQP_UINT32			m_ulFMTuningGranularity;
	TQP_UINT32			m_ulFMSettlingTime;
	TQP_UINT32			m_ulFMStrategy;

	TQP_UINT32			m_ulLastFrequency;
	TQP_UINT32			m_ulTuningFlags;
	TQP_UINT32			m_ulVideoSubChannel;
	TQP_UINT32			m_ulAudioSubChannel;
	TQP_UINT32			m_ulChannel;
	TQP_UINT32			m_ulCurrentCountry;

	TQP_UINT32			m_ulSoundCarrierFreq;
} CTuner;



CTuner * CTuner_Constructor(CTuner *pTuner,
							CObject *pParent,
							TQP_UINT32 dwAttributes
							);
void CTuner_Destructor(CTuner *This);


#ifdef __cplusplus
}
#endif

#endif //__CTUNER_H__

