///////////////////////////////////////////////////////////////////////////////
//        
//
// Ctvaudio.h
//
// Description: 
//
//  TVaudio implementation
// 
// History:
//	Sep 5, 2006	(dt) created
//
// Authors: (dt) David Tao
//
///////////////////////////////////////////////////////////////////////////////


#ifndef __CTVAUDIO_H__
#define __CTVAUDIO_H__


#include "cobject.h"
#include "qptvaudio.h"


#ifdef __cplusplus
extern "C" {
#endif



// TVAudio stereo mode
//
// 0 : USA
// 1 : JPN
// 2 : KOR
// 3 : D/K1,D/K2,D/K3, or D/K NICAM
// 4 : SECAM

#define TVAUDIO_STEREO_MODE_BTSC		0
#define TVAUDIO_STEREO_MODE_JPN			1
#define TVAUDIO_STEREO_MODE_KOR			2
#define TVAUDIO_STEREO_MODE_DK_NICAM	3
#define TVAUDIO_STEREO_MODE_SECAM		4


typedef struct CTVAudio
{
	// public CObject
	//
	CObject			m_Object;

	// public ITVAudio
	//
	ITVAudio		m_iTvAudio;

	// CTVAudio
	//
	QP_DEVICE_CALLBACK	m_pDeviceCallback;							// codec client call back function
	TQP_PVOID			m_callbackContext;							// codec client call back function context

	TQP_UINT32			m_ulSupportedModes;
	TQP_UINT32			m_ulAvailableModes;
	TQP_UINT32			m_ulMode;

	// prefered settings saved in the registry
	//
	TQP_UINT16			m_usPreferedStandard;
	TQP_BOOL			m_bAutoDetect;
	TQP_UINT32			m_dwStereoMode;

	ETVAUDIO_INPUT		m_audioSource;

	TQP_BOOL			m_bMuted;

} CTVAudio;


// constructor
//
CTVAudio * CTVAudio_Constructor(CTVAudio *pTVAudio, 
								CObject *pParent,
								TQP_UINT32 dwAttributes
								);


// destructor
//
void CTVAudio_Destructor(CTVAudio *This);

#ifdef __cplusplus
}
#endif

#endif //__CTVAUDIO_H__


