///////////////////////////////////////////////////////////////////////////////
//        
//
// ctvp7002.h
//
// Description: 
//   TVP7002 implementation
// 
// History:
//	 June 14, 2010 created
//
// Authors: Jack Lee
//
///////////////////////////////////////////////////////////////////////////////


#ifndef __CTVP7002_H__
#define __CTVP7002_H__

#include "cviddecoder.h"
#include "qpi2c.h"

#ifdef __cplusplus
extern "C" {
#endif


/////////////////////////////////////////////////////////////////////////////
//
//

// default TVP7002 I2C address
//
#define TVP7002_DEVICE_ADDR 0x5C


/////////////////////////////////////////////////////////////////////////////
//
//

typedef struct CTVP7002 
{
	// public CVideoDecoder
	//
	CVideoDecoder	m_VideoDecoder;

	// CTVP7002
	II2C			*m_pI2C;				// I2C interface
	TQP_UINT8		m_cI2CDevAddr;			// i2c device address

} CTVP7002;


CTVP7002 * CTVP7002_Constructor(CTVP7002 *pTVP7002, 
							    CObject *pParent,
							    TQP_UINT32 dwAttributes,
							    ITuner *pTuner,
							    ITVAudio *pTvAudio,
							    II2C *pI2C,
							    TQP_UINT8 cI2CDevAddr
							    );
void CTVP7002_Destructor(CTVP7002 *This);

#ifdef __cplusplus
}
#endif

#endif //__CTVP7002_H__


