///////////////////////////////////////////////////////////////////////////////
//        
//
// ctvp7002vh.h
//
// Description: 
//   TVP7002VH implementation
// 
// History:
//	 October 10, 2013 created
//
// Authors: Jack Lee
//
///////////////////////////////////////////////////////////////////////////////


#ifndef __CTVP7002VH_H__
#define __CTVP7002VH_H__

#include "cviddecoder.h"
#include "qpi2c.h"

#ifdef __cplusplus
extern "C" {
#endif


/////////////////////////////////////////////////////////////////////////////
//
//

// default TVP7002VH I2C address
//
#define TVP7002VH_DEVICE_ADDR 0x5C


/////////////////////////////////////////////////////////////////////////////
//
//

typedef struct CTVP7002VH 
{
	// public CVideoDecoder
	//
	CVideoDecoder	m_VideoDecoder;

	// CTVP7002VH
	II2C			*m_pI2C;				// I2C interface
	TQP_UINT8		m_cI2CDevAddr;			// i2c device address

} CTVP7002VH;


CTVP7002VH * CTVP7002VH_Constructor(CTVP7002VH *pTVP7002VH, 
									CObject *pParent,
									TQP_UINT32 dwAttributes,
									ITuner *pTuner,
									ITVAudio *pTvAudio,
									II2C *pI2C,
									TQP_UINT8 cI2CDevAddr
									);
void CTVP7002VH_Destructor(CTVP7002VH *This);

#ifdef __cplusplus
}
#endif

#endif //__CTVP7002VH_H__


