///////////////////////////////////////////////////////////////////////////////
//        
//
// ctw9910.h
//
// Description: 
//   TW9910 implementation
// 
// History:
//	 April 2, 2013 created
//
// Authors: Jack Lee
//
///////////////////////////////////////////////////////////////////////////////


#ifndef __CTW9910_H__
#define __CTW9910_H__

#include "cviddecoder.h"
#include "qpi2c.h"

#ifdef __cplusplus
extern "C" {
#endif


/////////////////////////////////////////////////////////////////////////////
//
//

// default TW9910 I2C address
//
#define TW9910_DEVICE_ADDR 0x45


/////////////////////////////////////////////////////////////////////////////
//
//

typedef struct CTW9910 
{
	// public CVideoDecoder
	//
	CVideoDecoder	m_VideoDecoder;

	// CTW9910
	II2C			*m_pI2C;				// I2C interface
	TQP_UINT8		m_cI2CDevAddr;			// i2c device address

} CTW9910;


CTW9910 * CTW9910_Constructor(CTW9910 *pTW9910, 
							  CObject *pParent,
							  TQP_UINT32 dwAttributes,
							  ITuner *pTuner,
							  ITVAudio *pTvAudio,
							  II2C *pI2C,
							  TQP_UINT8 cI2CDevAddr
							  );
void CTW9910_Destructor(CTW9910 *This);

#ifdef __cplusplus
}
#endif

#endif //__CTW9910_H__


