///////////////////////////////////////////////////////////////////////////////
//        
//
// Cvidencoder.h
//
// Description: 
//
//  Video encoder implementation
// 
// History:
//	Sep 5, 2006	(dt) created
//
// Authors: (dt) David Tao
//
///////////////////////////////////////////////////////////////////////////////


#ifndef __CVIDENCODER_H__
#define __CVIDENCODER_H__


#include "cobject.h"
#include "qpvidencoder.h"


#ifdef __cplusplus
extern "C" {
#endif


typedef struct CVideoEncoder 
{
	// public CObject
	//
	CObject				m_Object;

	// IVideoEncoder
	//
	IVideoEncoder		m_iVideoEncoder;

	// CVideoEncoder
	//
	QP_DEVICE_CALLBACK	m_pDeviceCallback;							// codec client call back function
	TQP_PVOID			m_callbackContext;							// codec client call back function context

	VIDEO_STANDARD		m_VidStandard;								// video standard
	TQP_BOOL			m_fVideoEncoderEnabled;

} CVideoEncoder;


// constructor
//
CVideoEncoder * CVideoEncoder_Constructor(CVideoEncoder *pVideoEncoder, 
										  CObject *pParent,
										  TQP_UINT32 dwAttributes
										  );

// destructor
//
void CVideoEncoder_Destructor(CVideoEncoder *This);

#ifdef __cplusplus
}
#endif

#endif //__CVIDENCODER_H__

