///////////////////////////////////////////////////////////////////////////////
//        
//
// CVidInputAuto1.h
//
// Description: 
//   CVidInputAuto1 implementation
// 
// History:
//	 Sep. 23, 2010 created
//
// Authors: Jack Lee
//
///////////////////////////////////////////////////////////////////////////////


#ifndef __CVIDINPUTAUTO1_H__
#define __CVIDINPUTAUTO1_H__

#include "cviddecoder.h"
#include "qpi2c.h"

#ifdef __cplusplus
extern "C" {
#endif

#define AUTO1_DEVICE_ADDR 0x0


/////////////////////////////////////////////////////////////////////////////
//
//

typedef struct CVidInputAuto1 
{
	// public CVideoDecoder
	//
	CVideoDecoder	m_VideoDecoder;

	II2C			*m_pI2C;				// I2C interface
	TQP_UINT8		m_cI2CDevAddr;			// i2c device address

} CVidInputAuto1;


CVidInputAuto1 * CVidInputAuto1_Constructor(CVidInputAuto1 *pVidInputAuto1, 
											CObject *pParent,
											TQP_UINT32 dwAttributes,
											ITuner *pTuner,
											ITVAudio *pTvAudio,
											II2C *pI2C,
											TQP_UINT8 cI2CDevAddr
											);

void CVidInputAuto1_Destructor(CVidInputAuto1 *This);

#ifdef __cplusplus
}
#endif

#endif //__CVIDINPUTAUTO1_H__


