///////////////////////////////////////////////////////////////////////////////
//        
//
// cobject.c
//
// Description: 
//
//	Header file which defines the base object.
// 
// History:
//	Aug 4, 2006	(dt) initial check in
//
// Authors: (dt) David Tao
//
///////////////////////////////////////////////////////////////////////////////


#include "cobject.h"


static TQP_BOOL _CObject_Init(CObject *This) 
{
	This->m_fInitialized = QP_TRUE; 
	return (QP_TRUE);
}



static TQP_BOOL _CObject_Done(CObject *This) 
{
	This->m_fInitialized = QP_FALSE; 
	return (QP_TRUE);
}



CObject * CObject_Constructor(CObject *pObject,
							  CObject *pParent, 
							  TQP_UINT32 dwAttributes
							  )
{
	if (pObject)
	{
		// fill in function table
		//
		pObject->Init = _CObject_Init;
		pObject->Done = _CObject_Done;

		pObject->m_pParent = pParent;
		pObject->m_fInitialized = QP_FALSE;
		pObject->m_dwObjectAttributes = dwAttributes;

		INIT_CRITICAL(pObject)
	}

	return (pObject);
}


void CObject_Destructor(CObject *This) 
{
	DONE_CRITICAL(This);
}



CObject * CObject_GetParent(CObject *This) 
{
	return (This->m_pParent);
}



TQP_BOOL CObject_IsInitialized(CObject *This) 
{
	return (This->m_fInitialized);
}



void CObject_enterCritical(CObject *This) 
{
	ENTER_CRITICAL(This)
}



void CObject_leaveCritical(CObject *This) 
{
	LEAVE_CRITICAL(This)
}

