#ifndef _NVP6134_H_
#define _NVP6134_H_

#include "LINUXV4L2.h"

BYTE NVP6134_GetRegister( F42A18AF66EFF459eA332CA253FFF8A65 * pDevice, BYTE nIndex );

BOOL NVP6134_SetRegister( F42A18AF66EFF459eA332CA253FFF8A65 * pDevice, BYTE nIndex, BYTE nValue );

VOID NVP6134_COMMON_INIT( F42A18AF66EFF459eA332CA253FFF8A65 * pDevice );

VOID NVP6134_FORMAT_DETECTION( F42A18AF66EFF459eA332CA253FFF8A65 * pDevice );

typedef struct _NVP6134_SIGNAL_INFO {

	ULONG	ch_mode_status[ 4 ];

	ULONG	ch_vfmt_status[ 4 ];

	ULONG   getvideofmt[ 4 ];

} NVP6134_SIGNAL_INFO;

typedef struct _nvp6134_input_videofmt
{
    unsigned int inputvideofmt[16];
	unsigned int getvideofmt[16];
	unsigned int geteqstage[16];
	unsigned int getacpdata[16][8];
}nvp6134_input_videofmt;


#define NVP6134_STD_NTSC	0x00

#define NVP6134_STD_PAL		0x01

#define SET_BIT( data, bit ) ((data) |=   (1 << (bit)) )

#define CLE_BIT( data, bit ) ((data) &= (~(1 << (bit))))

typedef enum _NVP6134_VI_MODE
{
	NVP6134_VI_720H            = 0x00, // 720X576I(480)
	NVP6134_VI_960H,                   // 960X576I(480)
	NVP6134_VI_1280H,                  // 1280X576I(480)
	NVP6134_VI_1440H,                  // 1440X576I(480)
	NVP6134_VI_1920H,                  // 1920X576I(480)
	NVP6134_VI_960H2EX,                // 3840X576I(480)
	NVP6134_VI_720P_2530       = 0x10, // 1280X720@25P(30)
	NVP6134_VI_EXC_720P,               // 1280X720@25P(30)
	NVP6134_VI_EXT_720PA,              // 1280X720@25P(30)	
	NVP6134_VI_EXT_720PB,              // 1280X720@25P(30)
	NVP6134_VI_HDEX,                   // 2560X720@25P(30)
	NVP6134_VI_EXC_HDEX,               // 2560X720@25P(30)
	NVP6134_VI_EXT_HDAEX,              // 2560X720@25P(30)
	NVP6134_VI_EXT_HDBEX,              // 2560X720@25P(30)
	NVP6134_VI_720P_5060,              // 1280X720@50P(60)
	NVP6134_VI_EXC_720PRT,             // 1280X720@50P(60)
	NVP6134_VI_EXT_720PRT,             // 1280X720@50P(60)
	NVP6134_VI_M_720PRT,               // FOR NEXTCHIP TEST ONLY
	NVP6134_VI_1080P_2530      = 0x20, // 1920X1080@25P(30)
	NVP6134_VI_EXC_1080P,              // 1920X1080@25P(30)
	NVP6134_VI_EXT_1080P,              // 1920X1080@25P(30)
	NVP6134_VI_1080P_NRT,              // 1920X1080@12.5P(15)
	NVP6134_VI_1080P_NOVIDEO,          // 1920X1080@25P(30)
	NVP6134_VI_3M_NRT          = 0x30, // 2048X1536@18P
	NVP6134_VI_3M,                     // 2048X1536@25P(30P)
	NVP6134_VI_EXC_3M_NRT,             // RESERVED
	NVP6134_VI_EXC_3M,                 // RESERVED
	NVP6134_VI_EXT_3M_NRT,             // 2048X1536@18P
	NVP6134_VI_EXT_3M,                 // RESERVED
	NVP6134_VI_4M_NRT          = 0x40, // 2560X1440@NRT
	NVP6134_VI_4M,                     // 2560X1440@25P(30)
	NVP6134_VI_EXC_4M_NRT,             // RESERVED
	NVP6134_VI_EXC_4M,                 // RESERVED
	NVP6134_VI_EXT_4M_NRT,             // RESERVED
	NVP6134_VI_EXT_4M,                 // RESERVED
	NVP6134_VI_5M_NRT          = 0x50, // 2592X1944@12.5P
	NVP6134_VI_5M,                     // 2592X1944@25P	
	NVP6134_VI_EXC_5M_NRT,             // RESERVED
	NVP6134_VI_EXC_5M,                 // RESERVED
	NVP6134_VI_EXT_5M_NRT,             // 2592X1944@12.5P
	NVP6134_VI_EXT_5M,                 // RESERVED
	NVP6134_VI_5M_20P,                 // 2592X1944@20P
	NVP6134_VI_8M_NRT          = 0x80, // RESERVED
	NVP6134_VI_8M,                     // RESERVED
	NVP6134_VI_EXC_8M_NRT,             // RESERVED
	NVP6134_VI_EXC_8M,                 // RESERVED
	NVP6134_VI_EXT_8M_NRT,             // RESERVED
	NVP6134_VI_EXT_8M,                 // RESERVED
	NVP6134_VI_UHD_X,                  // RESERVED
	NVP6134_VI_BUTT

} NVP6134_VI_MODE;

typedef enum _NVP6134_OUTMODE_SEL
{
	NVP6134_OUTMODE_1MUX_SD = 0,
	NVP6134_OUTMODE_1MUX_HD,
	NVP6134_OUTMODE_1MUX_HD5060,
	NVP6134_OUTMODE_1MUX_FHD,
	NVP6134_OUTMODE_2MUX_SD,
	NVP6134_OUTMODE_2MUX_HD_X,
	NVP6134_OUTMODE_2MUX_HD,
	NVP6134_OUTMODE_2MUX_FHD_X,
	NVP6134_OUTMODE_4MUX_SD,
	NVP6134_OUTMODE_4MUX_HD_X,
	NVP6134_OUTMODE_4MUX_HD,
	NVP6134_OUTMODE_2MUX_FHD,
	NVP6134_OUTMODE_1MUX_HD_X,  
	NVP6134_OUTMODE_1MUX_FHD_X,
	NVP6134_OUTMODE_4MUX_FHD_X,
	NVP6134_OUTMODE_4MUX_MIX,
	NVP6134_OUTMODE_2MUX_MIX,
	NVP6134_OUTMODE_1MUX_BT1120S,
	NVP6134_OUTMODE_1MUX_3M_RT,
	NVP6134_OUTMODE_1MUX_4M_NRT,
	NVP6134_OUTMODE_BUTT

} NVP6134_OUTMODE_SEL;

#endif