#include "LINUXV4L2.h"

void MySleep( int ms )	//unit: 1/1000 second
{
	F6B9E557A4BA24ffd926B820B836289C8_100NS( (ms * 10000) );
}

BOOLEAN MZ0380_ComboAnalogVideoDecoderRegisterX( F42A18AF66EFF459eA332CA253FFF8A65 * pDevice, ULONG nDevNum, BYTE F3E85D87, BYTE * pValue, ULONG F02179B6B95CB43eeB160478D8CF83778, BYTE is_read );

//devaddr = 8 bit I2C chip address
int i2c_write_bytes( F42A18AF66EFF459eA332CA253FFF8A65 * pDevice, unsigned char devaddr, unsigned char *txbuf, unsigned int txcount)
{	
	MZ0380_ComboAnalogVideoDecoderRegisterX( pDevice, 0, devaddr, txbuf, txcount, 0 );

	return 1;
}

//devaddr = 8 bit I2C chip address
int i2c_read_bytes( F42A18AF66EFF459eA332CA253FFF8A65 * pDevice, unsigned char devaddr, unsigned char *rxbuf, unsigned int rxcount)
{
	MZ0380_ComboAnalogVideoDecoderRegisterX( pDevice, 0,  devaddr, rxbuf, rxcount, 1 );

	return 1;
}

int mcu_i2c_access(F42A18AF66EFF459eA332CA253FFF8A65 * pDevice, unsigned char devaddr, unsigned int txcount, unsigned char *txbuf, unsigned int rxcount, unsigned char *rxbuf)
{
	unsigned char i2c_txcount = 0;
	unsigned char i2c_rxcount = 0;
	unsigned char i2c_txbuf[32] = {0};
	unsigned char i2c_rxbuf[32] = {0};

	devaddr <<= 1;
	if(txcount != 0)
	{
		if(rxcount != 0)
		{
			i2c_txcount = txcount+3;
			i2c_txbuf[0] = 0x66;
			i2c_txbuf[1] = devaddr|1;
			i2c_txbuf[2] = (unsigned char)rxcount;
			RtlCopyMemory( i2c_txbuf+3, txbuf, txcount );
		//	memcpy(i2c_txbuf+3, txbuf, txcount);
		}
		else
		{
			i2c_txcount = txcount+2;
			i2c_txbuf[0] = 0x66;
			i2c_txbuf[1] = devaddr;
			RtlCopyMemory( i2c_txbuf+2, txbuf, txcount );
		//	memcpy(i2c_txbuf+2, txbuf, txcount);
		}

		if( !i2c_write_bytes(pDevice, i2c_txbuf[0], i2c_txbuf+1, i2c_txcount-1 ) ) {
			return 0;
		}
	}
	MySleep(100);				//must be sleep, until the MCU handle this request
	if(rxcount != 0)
	{
		i2c_rxcount = (unsigned char)rxcount;
		i2c_txbuf[0] = 0x66;
		RtlFillMemory( i2c_rxbuf, rxcount, 0 );
	//	memset(i2c_rxbuf, 0, rxcount);
		if( !i2c_read_bytes(pDevice, i2c_txbuf[0], i2c_rxbuf, i2c_rxcount ) ) {
			return 0;
		}
		RtlCopyMemory( rxbuf, i2c_rxbuf, rxcount );
	//	memcpy(rxbuf, i2c_rxbuf, rxcount);
	}
	return 1;
}

int WaitI2CReady_LDROM(F42A18AF66EFF459eA332CA253FFF8A65 * pDevice, int count)
{
	int i;
	unsigned char rxbuf[1];

	i = 0;
	while(1)
	{
	    i2c_read_bytes(pDevice, 0x60, rxbuf, 1);
		if(rxbuf[0] == 0)
		{
			//OutputDebugString("I2C ready \n");
		    break;
		}
		i++;
		if(i > (count+1)*20)
		{
			F1838C0176E054c129B7F2BF440D1236E( KERN_INFO, "LDROM I2C Time out \n");
			break;
		}
		MySleep(1);
	}
	return 0;
}


int i2c_access_LDROM(F42A18AF66EFF459eA332CA253FFF8A65 * pDevice, unsigned char devaddr, unsigned int txcount, unsigned char *txbuf, unsigned int rxcount, unsigned char *rxbuf)
{
	if(txcount != 0)
	{
		if( !i2c_write_bytes( pDevice, 0x6c, txbuf, txcount ) ) 
		{
				return FALSE;
		}
	}
	if(rxcount != 0)
	{
		WaitI2CReady_LDROM( pDevice, txcount + 2 );
		if( !i2c_read_bytes( pDevice, 0x6c, rxbuf, rxcount ) ) {
			return FALSE;
		}
	}
	return TRUE;
}

void GetMCUROMVersion(F42A18AF66EFF459eA332CA253FFF8A65 * pDevice, unsigned char *aprom, unsigned char *ldrom);
void Jump2LDROM(F42A18AF66EFF459eA332CA253FFF8A65 * pDevice, unsigned char *ldrom);
//int UpdateAPROM(F42A18AF66EFF459eA332CA253FFF8A65 * pDevice, unsigned char *bin_name);
int UpdateAPROM(F42A18AF66EFF459eA332CA253FFF8A65 * pDevice,unsigned char *bin_name, unsigned char * read_buf, unsigned int flength);

#if 0
int main(int argc, char* argv[])
{
	unsigned char aprom[3];
	unsigned char ldrom[1];

	aprom[0] = 0;
	ldrom[0] = 0;
	//aprom[0] = 0x16, aprom[1] = 0x8, aprom[2] = 0x11, //2016/8/11
	//ldrom[0] = should be 0x13
	GetMCUROMVersion(aprom, ldrom);	
	if(aprom[0] != 0)
	{
		//now in the APROM, jump to LDROM
		Jump2LDROM(ldrom);

	}
//	UpdateAPROM((unsigned char *)"c:\\hisilicon4_16_09_19.bin");
	UpdateAPROM((unsigned char *)"c:\\hisilicon4_16_08_11.bin");

	return 0;
}
#endif

int UpdateEDIDContent(F42A18AF66EFF459eA332CA253FFF8A65 * pDevice, unsigned char *buf);
int i2c_access_LDROM(F42A18AF66EFF459eA332CA253FFF8A65 * pDevice, unsigned char devaddr, unsigned int txcount, unsigned char *txbuf, unsigned int rxcount, unsigned char *rxbuf);
unsigned char UpdateAP_Tx[64];
unsigned char UpdateAP_Rx[64];
#define CMD_UPDATE_APROM	0xA0
#define CMD_UPDATE_CONFIG	0xA1
#define CMD_ERASE_ALL		0xA2
#define CMD_GET_FWVER		0xA3
#define CMD_RUN_APROM		0xA4
#define CMD_RUN_LDROM		0xA5
#define CMD_RESET			0xA6
#define CMD_PAYLOAD_END		0xA7
#define CMD_GET_ROMINFO		0xA8
#define CMD_GET_DEVICEID	0xA9
#define CMD_GET_FLASHMODE 	0xAA
#define CMD_BLANK_CHECK		0xAB
#define CMD_IDLE_CHECK		0xAC
#define CMD_DUMMY			0xFF

struct D_CMD_UPDATE_CONFIG
{
	unsigned char commandid;
	unsigned char char_0xaa;
	unsigned char char_0x55;
	unsigned char char_0x44;
	unsigned int  config0;		//must be 4 alignment 
	unsigned int  config1;		//must be 4 alignment 
};

struct D_CMD_GET_ROMINFO
{
	unsigned char firmversion;
	unsigned char pdid;
	unsigned char reserve1;		//0xaa
	unsigned char reserve2;		//0x55;
	unsigned int  config0;		//must be 4 alignment 
	unsigned int  config1;		//must be 4 alignment 
	unsigned int  aprom_checksum;//must be 4 alignment 
	unsigned int  aprom_len;	//must be 4 alignment 
};

struct D_CMD_UPDATE_APROM
{
	unsigned char commandid;
	unsigned char currentpage;	//512 bytes per page;
	unsigned char payloadlen;
	unsigned char payload[61];
};

struct D_CMD_PAYLOAD_END
{
	unsigned char commandid;
	unsigned char payloadlen;
	unsigned char char_0xaa;
	unsigned char char_0x55;
	unsigned int  pagechecksum;//must be 4 alignment 
};

#define AP_SIZE		0x8000
#define MCU_PAGE_SIZE	0x200
#define UPDATE_SUCCESS		0
#define FAIL_JMP_LDROM		1
#define FAIL_READ_BIN_FILE	2
#define FAIL_ERASE_APROM	3
#define FAIL_BLANKCHECK		4
#define FAIL_UPDATE_PAGE	5
#define FAIL_CHECKSUM		6
#define FAIL_MCU_NOT_EXIST  7
#define FAIL_JMP_APROM		8
#define FAIL_BUSY_LDROM		9
#define FAIL_PAGE_TRANSFER	10

int UpdateOnePage(F42A18AF66EFF459eA332CA253FFF8A65 * pDevice, unsigned int pageno, unsigned char *fbuf, unsigned int pagesize)
{
//#define MAX_I2C_TX_SIZE		64	//ADDED FOR H56
#define MAX_I2C_TX_SIZE		16
	unsigned int size, i;
	struct D_CMD_UPDATE_APROM s_update;
	struct D_CMD_PAYLOAD_END s_pageend;
	unsigned char *ptemp;

	s_pageend.commandid = CMD_PAYLOAD_END;
	s_pageend.payloadlen = (BYTE)pagesize;
	s_pageend.char_0xaa = 0xaa;
	s_pageend.char_0x55 = 0x55;
	s_pageend.pagechecksum = 0;

	ptemp = fbuf;
	s_update.commandid = CMD_UPDATE_APROM;
	s_update.currentpage = (BYTE)pageno;
	while(1)
	{
		if(pagesize > MAX_I2C_TX_SIZE-3)
			size = MAX_I2C_TX_SIZE-3;
		else
			size = pagesize;
		s_update.payloadlen = (BYTE)size;
		for(i = 0;i < size;i++)
		{
			s_update.payload[i] = *ptemp;
			s_pageend.pagechecksum += *ptemp;
			ptemp++;
		}
		pagesize -= size;
		i2c_access_LDROM(pDevice, 0x36, MAX_I2C_TX_SIZE, (unsigned char *)&s_update, 2, UpdateAP_Rx);
		if(UpdateAP_Rx[0] != 0x11 || UpdateAP_Rx[1] != pageno)
		{
			F1838C0176E054c129B7F2BF440D1236E( KERN_INFO, "FAIL_PAGE_TRANSFER \n");
			return FAIL_PAGE_TRANSFER;
		}
		if(pagesize == 0)
			break;
		s_update.currentpage = 0xff;	//means not the start of page
	}
	i2c_access_LDROM(pDevice, 0x36, sizeof(struct D_CMD_PAYLOAD_END), (unsigned char *)&s_pageend, 2, UpdateAP_Rx);
	i = 0;
	while(1)	//wait until done
	{
		if(UpdateAP_Rx[0] == 0xaa && UpdateAP_Rx[1] == 0x55)
			break;
		else if(UpdateAP_Rx[0] == 0xcc && UpdateAP_Rx[1] == 0xdd)
			break;
		else if(UpdateAP_Rx[0] == 0xee && UpdateAP_Rx[1] == 0xff)
			break;
		else
			MySleep(50);
		i2c_access_LDROM(pDevice, 0x36, 0, UpdateAP_Tx, 2, UpdateAP_Rx);
		i++;
		if(i > 10)
			break;

	}
	if(UpdateAP_Rx[0] == 0xaa && UpdateAP_Rx[1] == 0x55)
		return 0;
	if(UpdateAP_Rx[0] == 0xcc && UpdateAP_Rx[1] == 0xdd)
		return 2;		//checksum error
	if(UpdateAP_Rx[0] == 0xee && UpdateAP_Rx[1] == 0xff)
		return 1;		//page write error
	return 3;			//page write error
}

int CheckLD_ROM_Idle(F42A18AF66EFF459eA332CA253FFF8A65 * pDevice)
{
	int i;

	i = 0;
	while(1)
	{
		UpdateAP_Tx[0] = CMD_IDLE_CHECK;
		UpdateAP_Rx[0] = 0;
		i2c_access_LDROM(pDevice,0x36, 1, UpdateAP_Tx, 3, UpdateAP_Rx);
		F1838C0176E054c129B7F2BF440D1236E( KERN_INFO, "F42A18AF66EFF459eA332CA253FFF8A65::CheckLD_ROM_Idle (0x%x, 0x%x, 0x%x)\n", UpdateAP_Rx[0], UpdateAP_Rx[1], UpdateAP_Rx[2]);
		if(UpdateAP_Rx[0] == 0xab && UpdateAP_Rx[1] == 0xcd && UpdateAP_Rx[2] == 0xef)
			break;
		MySleep(5);
		i++;
		if(i > 5)
			return  1;	
	}
	return 0;
}

//1.i2c_access()
//		if(devaddr == 0x55 && rxbuf[0] == 0x45 && rxbuf[1] == 0x67 && rxbuf[2] == 0x89)
//		{
//			//it's special key, for the MCU is busy in starttimer(), not in the I2C loop 
//			return ret;
//		}
//
//2.i2c_access_LDROM()
//#define BAD_MCU		1

int UpdateAPROM(F42A18AF66EFF459eA332CA253FFF8A65 * pDevice,unsigned char *bin_name, unsigned char * read_buf, unsigned int flength)
{
	struct D_CMD_GET_ROMINFO rominfo;
	unsigned char *ptemp;
	unsigned int currentpage;
	unsigned int total_checksum;
	unsigned int i;
	unsigned int tempsize; 
	

//Action 1:
//set those pins to the following values, and let LDROM get into update the APROM
	if(CheckLD_ROM_Idle(pDevice) == 1)
	{
	//Action 2:
	//Jump from the AP ROM to LD ROM
		UpdateAP_Tx[0] = 0x12;
		UpdateAP_Tx[1] = 0x34;
		UpdateAP_Tx[2] = 0x57;	//0x56 ==> 51 10 27
		mcu_i2c_access(pDevice, 0x55, 3, UpdateAP_Tx, 3, UpdateAP_Rx);
		if(UpdateAP_Rx[0] == 0x51 && UpdateAP_Rx[1] == 0x10 && (UpdateAP_Rx[2] == 0x28 || UpdateAP_Rx[2] == 0x27))
		{   
			//Jump to LC ROM
			F1838C0176E054c129B7F2BF440D1236E( KERN_INFO, "F42A18AF66EFF459eA332CA253FFF8A65::Jump to LD ROM\n");
			UpdateAP_Tx[0] = 0x0D;
			UpdateAP_Tx[1] = 0x12;
			UpdateAP_Tx[2] = 0x04;	//0x56 ==> 51 10 27
			UpdateAP_Tx[3] = 0x86;
			UpdateAP_Tx[4] = 0x54;
			UpdateAP_Tx[5] = 0x06;	//0x56 ==> 51 10 27
			UpdateAP_Tx[6] = 0xAA;
			mcu_i2c_access(pDevice, 0x55, 7, UpdateAP_Tx, 3, UpdateAP_Rx);
			i = 0;
			while(1)
			{
				F1838C0176E054c129B7F2BF440D1236E( KERN_INFO, "F42A18AF66EFF459eA332CA253FFF8A65::Get (0x%x, 0x%x, 0x%x)\n", UpdateAP_Rx[0], UpdateAP_Rx[1], UpdateAP_Rx[2]);
				if(UpdateAP_Rx[0] == 0x45 && UpdateAP_Rx[1] == 0x67 && UpdateAP_Rx[2] == 0x89)
				{
					MySleep(200);
					break;
				}
				i++;
				if(CheckLD_ROM_Idle(pDevice) == 0)
				    break;
				if(i > 50)
				{
//					F1838C0176E054c129B7F2BF440D1236E( KERN_INFO, "Fail to jump LD ROM \n");
//					return FAIL_JMP_LDROM;
					break;
				}
				mcu_i2c_access(pDevice,0x55, 1, UpdateAP_Tx, 3, UpdateAP_Rx);
			}
		}
	}
	else
	{
		F1838C0176E054c129B7F2BF440D1236E( KERN_INFO, "Already in the LD ROM \n");
	}

//Action 3
//check if the device is in the LDROM or not
//.....
	if(CheckLD_ROM_Idle(pDevice) == 1)
	{
		F1838C0176E054c129B7F2BF440D1236E( KERN_INFO, "1 Fail to jump LD ROM \n");
		return FAIL_JMP_LDROM;
	}

#if 0 // [H.P.LIN] DISABLE IT
    if((fp = fopen((const char *)bin_name, "rb")) == NULL )
        return FAIL_READ_BIN_FILE;
	read_buf = (unsigned char *)malloc(AP_SIZE);
    flength = fread( read_buf, sizeof(unsigned char), AP_SIZE, fp );
    if(flength == 0) 
		return FAIL_READ_BIN_FILE;
	fclose(fp);
#endif

//Action 4
//Disable the security
	F1838C0176E054c129B7F2BF440D1236E( KERN_INFO, "Get ROM information ...\n");
	//Check the I2C bus check if is in the LD ROM or not
	UpdateAP_Tx[0] = CMD_GET_ROMINFO;
	UpdateAP_Rx[0] = 0;
	i2c_access_LDROM(pDevice,0x36, 1, UpdateAP_Tx, sizeof(struct D_CMD_GET_ROMINFO), (unsigned char *)&rominfo);
//To enable the security
	if((rominfo.config0&2) == 0)
	{
		struct D_CMD_UPDATE_CONFIG updateconfig;

		updateconfig.commandid = CMD_UPDATE_CONFIG;
		updateconfig.char_0xaa = 0xaa;
		updateconfig.char_0x55 = 0x55;
		updateconfig.char_0x44 = 0x44;
		updateconfig.config0 = rominfo.config0|2;
		updateconfig.config1 = rominfo.config1;
		i2c_access_LDROM(pDevice,0x36, sizeof(struct D_CMD_UPDATE_CONFIG), (unsigned char *)&updateconfig, 0, 0);
		F1838C0176E054c129B7F2BF440D1236E( KERN_INFO, "Update config ...\n");
	}

	if(CheckLD_ROM_Idle(pDevice) == 1)
	{
	    F1838C0176E054c129B7F2BF440D1236E( KERN_INFO, "Fail to jump LD ROM \n");
		return FAIL_JMP_LDROM;
	}


//Action 5
//Erase AP ROM, key point is here
	F1838C0176E054c129B7F2BF440D1236E( KERN_INFO, "In Erase All... \n");
	UpdateAP_Tx[0] = CMD_ERASE_ALL;
	i2c_access_LDROM(pDevice,0x36, 1, UpdateAP_Tx, 0, 0);
	MySleep(2000);		//for a new MCU, 2014, 08, 05
	i2c_access_LDROM(pDevice,0x36, 0, 0, 3, UpdateAP_Rx);
//put get checksum here to save time
	ptemp = read_buf;
	total_checksum = 0;
	for(i = 0;i < flength;i++)
		total_checksum += *ptemp++;

	i = 0;
	while(1)	//wait until done
	{
		if(UpdateAP_Rx[0] == 0x22 && UpdateAP_Rx[1] == 0x33 && UpdateAP_Rx[2] == 0x44)
		{
			F1838C0176E054c129B7F2BF440D1236E( KERN_INFO, "Erase finish...\n");
			break;
		}
		MySleep(50);
		i++;
		if(i > 200)
		{
		    F1838C0176E054c129B7F2BF440D1236E( KERN_INFO, "Time out erase finish...\n");
			return FAIL_ERASE_APROM;
		}
		i2c_access_LDROM(pDevice,0x36, 0, UpdateAP_Tx, 3, UpdateAP_Rx);
		if(UpdateAP_Rx[0] == 0xaa && UpdateAP_Rx[1] == 0xbb && UpdateAP_Rx[2] == 0xcc)
		{
			i2c_access_LDROM(pDevice,0x36, 1, UpdateAP_Tx, 3, UpdateAP_Rx);
			MySleep(300);
		}
	}
    F1838C0176E054c129B7F2BF440D1236E( KERN_INFO, "Out Erase All... \n");
//Erase AP ROM 

	if(CheckLD_ROM_Idle(pDevice) == 1)
	{
		F1838C0176E054c129B7F2BF440D1236E( KERN_INFO, "Busy in LDROM \n");
		return FAIL_BUSY_LDROM;
	}

//Action 6
//Blank check AP ROM
	UpdateAP_Tx[0] = CMD_BLANK_CHECK;
	i2c_access_LDROM(pDevice,0x36, 1, UpdateAP_Tx, 3, UpdateAP_Rx);
	i = 0;
	while(1)	//wait until done
	{
		if(UpdateAP_Rx[0] == 0x11 && UpdateAP_Rx[1] == 0x22 && UpdateAP_Rx[2] == 0x33)
		{
		    F1838C0176E054c129B7F2BF440D1236E( KERN_INFO, "Blank Check Success \n");
			break;
		}
		if(UpdateAP_Rx[0] == 0x44 && UpdateAP_Rx[1] == 0x55 && UpdateAP_Rx[2] == 0x66)
		{
			F1838C0176E054c129B7F2BF440D1236E( KERN_INFO, "Blank Check Fail \n");
			break;
		}
		MySleep(50);
		i++;
		if(i > 50)
		{
			F1838C0176E054c129B7F2BF440D1236E( KERN_INFO, "Time out blank check ...\n");
			return  FAIL_BLANKCHECK;
		}
		i2c_access_LDROM(pDevice,0x36, 0, UpdateAP_Tx, 3, UpdateAP_Rx);
	}

	if(CheckLD_ROM_Idle(pDevice) == 1)
	{
		F1838C0176E054c129B7F2BF440D1236E( KERN_INFO, "Busy in LDROM \n");
		return FAIL_BUSY_LDROM;
	}

//Action 7
//Update the AP ROM with per page (512 bytes)
	currentpage = 0;
	ptemp = read_buf;
	tempsize = flength;
	while(1)
	{
		int res;

		if(tempsize >= MCU_PAGE_SIZE)
			res = UpdateOnePage(pDevice,currentpage, ptemp, MCU_PAGE_SIZE);
		else
			res = UpdateOnePage(pDevice,currentpage, ptemp, tempsize);
		if(tempsize == MCU_PAGE_SIZE && flength != 32*1024)
		{
			//it's a special case, it's to write the checksum and totallength 
			//to the end of APROM
			ptemp = read_buf;
			RtlFillMemory( ptemp, 0x10, 0 );
		//	memset(ptemp, 0, 0x10);
			res = UpdateOnePage(pDevice,currentpage+1, ptemp, 0x10);
			break;
		}
		if(res != 0)
		{
			F1838C0176E054c129B7F2BF440D1236E( KERN_INFO, "Fail to write page...\n");
			return FAIL_UPDATE_PAGE;
		}
		if(tempsize < MCU_PAGE_SIZE)
			break;
		tempsize -= MCU_PAGE_SIZE;
		ptemp += MCU_PAGE_SIZE;
		currentpage++;
		F1838C0176E054c129B7F2BF440D1236E( KERN_INFO, "Update page, current page %d...\n", currentpage);
	}

//Action 8:
//enable the security
	UpdateAP_Tx[0] = CMD_GET_ROMINFO;
	UpdateAP_Rx[0] = 0;
	i2c_access_LDROM(pDevice,0x36, 1, UpdateAP_Tx, sizeof(struct D_CMD_GET_ROMINFO), (unsigned char *)&rominfo);
	if(rominfo.aprom_checksum != total_checksum && rominfo.aprom_len != flength)
	{
		F1838C0176E054c129B7F2BF440D1236E( KERN_INFO, "FAIL_CHECKSUM \n");
		return FAIL_CHECKSUM;
	}
//To enable the security
	if(rominfo.config0&2)
	{
		struct D_CMD_UPDATE_CONFIG updateconfig;

		updateconfig.commandid = CMD_UPDATE_CONFIG;
		updateconfig.char_0xaa = 0xaa;
		updateconfig.char_0x55 = 0x55;
		updateconfig.char_0x44 = 0x44;
		updateconfig.config0 = rominfo.config0&0xfffffffd;
		updateconfig.config1 = rominfo.config1;
		i2c_access_LDROM(pDevice,0x36, sizeof(struct D_CMD_UPDATE_CONFIG), (unsigned char *)&updateconfig, 0, 0);
#ifdef BAD_MCU
		MySleep(500);		//for a new MCU, 2014, 08, 05
#endif
		F1838C0176E054c129B7F2BF440D1236E( KERN_INFO, "Update config ...\n");
	}

	if(CheckLD_ROM_Idle(pDevice) == 1)
	{
		F1838C0176E054c129B7F2BF440D1236E( KERN_INFO, "Busy in LDROM \n");
		return FAIL_BUSY_LDROM;
	}

//Action 9
//Jump back to APROM again
	F1838C0176E054c129B7F2BF440D1236E( KERN_INFO, "Run APROM \n");
	UpdateAP_Tx[0] = CMD_RUN_APROM;
	UpdateAP_Rx[0] = 0;
	i2c_access_LDROM(pDevice,0x36, 1, UpdateAP_Tx, 0, 0);
	MySleep(1500);		//for a new MCU, 2014, 08, 05
	i2c_access_LDROM(pDevice,0x36, 0, 0, 3, UpdateAP_Rx);
	F1838C0176E054c129B7F2BF440D1236E( KERN_INFO, "F42A18AF66EFF459eA332CA253FFF8A65::Run APROM Read LD_ROM(0x%x, 0x%x, 0x%x) \n", UpdateAP_Rx[0], UpdateAP_Rx[1], UpdateAP_Rx[2]);
	MySleep(1500);		//for a new MCU, 2014, 08, 05
	i2c_access_LDROM(pDevice,0x36, 0, 0, 3, UpdateAP_Rx);
	F1838C0176E054c129B7F2BF440D1236E( KERN_INFO, "F42A18AF66EFF459eA332CA253FFF8A65::Run APROM Read LD_ROM(0x%x, 0x%x, 0x%x) \n", UpdateAP_Rx[0], UpdateAP_Rx[1], UpdateAP_Rx[2]);


//get the MCU version 
	i = 0;
	while(1)
	{
		UpdateAP_Tx[0] = 0x12;
		UpdateAP_Tx[1] = 0x34;
		UpdateAP_Tx[2] = 0x57;	//0x56 ==> 51 10 27
		mcu_i2c_access(pDevice,0x55, 3, UpdateAP_Tx, 3, UpdateAP_Rx);
		F1838C0176E054c129B7F2BF440D1236E( KERN_INFO, "F42A18AF66EFF459eA332CA253FFF8A65::Get MCU version (0x%x, 0x%x, 0x%x) \n", UpdateAP_Rx[0], UpdateAP_Rx[1], UpdateAP_Rx[2]);
		if(UpdateAP_Rx[0] == 0x51 && UpdateAP_Rx[1] == 0x10 && UpdateAP_Rx[2] == 0x27)
		{   
			break;
		}
		if(UpdateAP_Rx[0] == 0x51 && UpdateAP_Rx[1] == 0x10 && UpdateAP_Rx[2] == 0x28)
		{   
			break;
		}
		i++;
		MySleep(50);
		if(i > 50)
		{
			F1838C0176E054c129B7F2BF440D1236E( KERN_INFO, "Fail to run APROM \n");
			return FAIL_JMP_APROM;
		}
	}
	F1838C0176E054c129B7F2BF440D1236E( KERN_INFO, "Success to update APROM \n");
	return UPDATE_SUCCESS;
}


void GetMCUROMVersion(F42A18AF66EFF459eA332CA253FFF8A65 * pDevice,unsigned char *aprom, unsigned char *ldrom)
{
	unsigned char txbuf[16];
	unsigned char rxbuf[16];
	int i;
	struct D_CMD_GET_ROMINFO rominfo;

//Step 1: make sure the MCU is working fine
//get the MCU key word
	i = 0;
	while(1)
	{
		txbuf[0] = 0x12;
		txbuf[1] = 0x34;
		txbuf[2] = 0x57;	//0x56 ==> 51 10 27
		mcu_i2c_access(pDevice,0x55, 3, txbuf, 3, rxbuf);
		F1838C0176E054c129B7F2BF440D1236E( KERN_INFO, "F42A18AF66EFF459eA332CA253FFF8A65::AP ROM flag (0x%x, 0x%x, 0x%x) \n", rxbuf[0], rxbuf[1], rxbuf[2]);
		if(rxbuf[0] == 0x51 && rxbuf[1] == 0x10 && rxbuf[2] == 0x27)
		{   
			break;
		}
		if(rxbuf[0] == 0x51 && rxbuf[1] == 0x10 && rxbuf[2] == 0x28)
		{   
			break;
		}
		else if(CheckLD_ROM_Idle(pDevice) == 0)
		{
			goto getrominfo;
		}
		i++;
		if(i >= 5)
			return;			//something wrong in the MCU, not in the LD rom and AP rom
	}

	/* get APROM version */
	txbuf[0] = 0x12;
	txbuf[1] = 0x34;
	txbuf[2] = 0x58;	//0x56 ==> 51 10 27
	mcu_i2c_access(pDevice,0x55, 3, txbuf, 3, rxbuf);
	F1838C0176E054c129B7F2BF440D1236E( KERN_INFO, "F42A18AF66EFF459eA332CA253FFF8A65::APROM version(0x%x, 0x%x, 0x%x) \n", rxbuf[0], rxbuf[1], rxbuf[2]);
	RtlCopyMemory( aprom, rxbuf, 3 );
//	memcpy(aprom, rxbuf, 3);
	return;				//now in the APROM

getrominfo:

	//Get LD ROM information
	//Check the I2C bus check if is in the LD ROM or not
	txbuf[0] = CMD_GET_ROMINFO;
	rxbuf[0] = 0;
	i2c_access_LDROM(pDevice,0x36, 1, txbuf, sizeof(struct D_CMD_GET_ROMINFO), (unsigned char *)&rominfo);
	if(rominfo.reserve1 == 0xaa && rominfo.reserve2 == 0x55)
		*ldrom = rominfo.firmversion;
	else
		*ldrom = 0;
}


void Jump2LDROM(F42A18AF66EFF459eA332CA253FFF8A65 * pDevice,unsigned char *ldrom)
{
	unsigned char txbuf[32];
	unsigned char rxbuf[32];
	int i;
	struct D_CMD_GET_ROMINFO rominfo;

	//Jump to LD ROM
	i = 0;
	while(1)
	{
		txbuf[0] = 0x0D;
		txbuf[1] = 0x12;
		txbuf[2] = 0x04;	
		txbuf[3] = 0x86;
		txbuf[4] = 0x54;
		txbuf[5] = 0x06;	
		txbuf[6] = 0xAA;
		mcu_i2c_access(pDevice,0x55, 7, txbuf, 3, rxbuf);
		F1838C0176E054c129B7F2BF440D1236E( KERN_INFO, "F42A18AF66EFF459eA332CA253FFF8A65::Jump2LDROM (0x%x, 0x%x, 0x%x)\n", rxbuf[0], rxbuf[1], rxbuf[2]);
		if(rxbuf[0] == 0x45 && rxbuf[1] == 0x67 && rxbuf[2] == 0x89)
		{
			MySleep(200);
			break;
		}
		i++;
		if(i > 3)
		{
			break;
		}
	}

	MySleep(100);

	{
		//Get LD ROM information
		//Check the I2C bus check if is in the LD ROM or not
		txbuf[0] = CMD_GET_ROMINFO;
		rxbuf[0] = 0;
		i2c_access_LDROM(pDevice,0x36, 1, txbuf, sizeof(struct D_CMD_GET_ROMINFO), (unsigned char *)&rominfo);
		F1838C0176E054c129B7F2BF440D1236E( KERN_INFO, "F42A18AF66EFF459eA332CA253FFF8A65::LDROM firmversion 0x%x \n", rominfo.firmversion);
		F1838C0176E054c129B7F2BF440D1236E( KERN_INFO, "F42A18AF66EFF459eA332CA253FFF8A65::LDROM pdid 0x%x \n", rominfo.pdid);
		F1838C0176E054c129B7F2BF440D1236E( KERN_INFO, "F42A18AF66EFF459eA332CA253FFF8A65::LDROM reserve1 0x%x \n", rominfo.reserve1);
		F1838C0176E054c129B7F2BF440D1236E( KERN_INFO, "F42A18AF66EFF459eA332CA253FFF8A65::LDROM reserve2 0x%x \n", rominfo.reserve2);
		F1838C0176E054c129B7F2BF440D1236E( KERN_INFO, "F42A18AF66EFF459eA332CA253FFF8A65::LDROM config0 0x%x \n", rominfo.config0);
		F1838C0176E054c129B7F2BF440D1236E( KERN_INFO, "F42A18AF66EFF459eA332CA253FFF8A65::LDROM config1 0x%x \n", rominfo.config1);
		F1838C0176E054c129B7F2BF440D1236E( KERN_INFO, "F42A18AF66EFF459eA332CA253FFF8A65::LDROM aprom_checksum 0x%x \n", rominfo.aprom_checksum);
		F1838C0176E054c129B7F2BF440D1236E( KERN_INFO, "F42A18AF66EFF459eA332CA253FFF8A65::LDROM aprom_len 0x%x \n", rominfo.aprom_len);
	}
	if(rominfo.reserve1 == 0xaa && rominfo.reserve2 == 0x55)
		*ldrom = rominfo.firmversion;	//should be 0x13
	else
		*ldrom = 0;
}
